const path = require('path');
const currentDir = path.dirname(__filename);


const siteDev = {
  name: "adminpanel-dev",
  script: path.join(currentDir, 'entrypoint.js'),
  windowsHide: true,
  watch: false,
  env: {
      NODE_ENV: 'development',
      DOTENV_CONFIG_PATH: path.resolve(__dirname, '../../.env'),
      NEXT_PUBLIC_APP_ID: 'adminpanel'
  },
  cwd: currentDir,
  log_date_format: "YYYY-MM-DD HH:mm:ss",
  out_file: '../../logs/raw/adminpanel-dev.stdout.log',
  error_file: '../../logs/raw/adminpanel-dev.stderr.log',
  node_args: '--max-old-space-size=4096',
  vizion: false
}

module.exports = {
    apps: [siteDev] 
}