"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.API = exports.getApiUrl = exports.setApiUrl = void 0;
var PendingResult_1 = require("./PendingResult");
var isElectron_1 = require("./lib/isElectron");
var logger_1 = require("./logger");
var logger = (0, logger_1.getLogger)();
var APIURL = 'http://localhost:8000';
var setApiUrl = function (apiurl) { return APIURL = apiurl; };
exports.setApiUrl = setApiUrl;
var getApiUrl = function () { var _a, _b; return (_b = (_a = process === null || process === void 0 ? void 0 : process.env) === null || _a === void 0 ? void 0 : _a.PROXY_API_URL) !== null && _b !== void 0 ? _b : APIURL; };
exports.getApiUrl = getApiUrl;
var wait = function (ms) { return new Promise(function (resolve) { return setTimeout(resolve, ms); }); };
var _fetch = function (urlOrData_1, data_1, update_1, plain_1) {
    var args_1 = [];
    for (var _i = 4; _i < arguments.length; _i++) {
        args_1[_i - 4] = arguments[_i];
    }
    return __awaiter(void 0, __spreadArray([urlOrData_1, data_1, update_1, plain_1], args_1, true), void 0, function (urlOrData, data, update, plain, retryNum) {
        var SERVER, realUrl, baseUrl, params, key, fn;
        if (retryNum === void 0) { retryNum = 10; }
        return __generator(this, function (_a) {
            SERVER = (0, exports.getApiUrl)();
            if (typeof urlOrData === 'string') {
                realUrl = typeof window === 'undefined' || (0, isElectron_1.isElectron)() ? (!urlOrData.startsWith('https://') && !urlOrData.startsWith('http://') ? SERVER : '') + urlOrData : urlOrData;
            }
            else if (typeof urlOrData === 'object' && urlOrData.url) {
                baseUrl = typeof window === 'undefined' || (0, isElectron_1.isElectron)() ? (!urlOrData.url.startsWith('https://') && !urlOrData.url.startsWith('http://') ? SERVER : '') + urlOrData.url : urlOrData.url;
                params = new URLSearchParams();
                for (key in urlOrData) {
                    if (key !== 'url') {
                        params.append(key, urlOrData[key]);
                    }
                }
                realUrl = baseUrl + (baseUrl.includes('?') ? '&' : '?') + params.toString();
            }
            else {
                throw new Error("Invalid params for API");
            }
            fn = function () { return __awaiter(void 0, void 0, void 0, function () {
                var res, resData, e_1, err, response, e_2, errStr, err;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            update ? update((0, PendingResult_1.getPendingResult)('loading')) : null;
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 10, , 13]);
                            return [4 /*yield*/, fetch(realUrl, data ? {
                                    method: 'POST',
                                    headers: {
                                        'Content-Type': 'application/json'
                                    },
                                    body: JSON.stringify(data)
                                } : undefined)];
                        case 2:
                            res = _b.sent();
                            resData = void 0;
                            _b.label = 3;
                        case 3:
                            _b.trys.push([3, 5, , 6]);
                            return [4 /*yield*/, res.text()];
                        case 4:
                            resData = _b.sent();
                            if (!plain)
                                resData = JSON.parse(resData);
                            return [3 /*break*/, 6];
                        case 5:
                            e_1 = _b.sent();
                            console.error("Error decoding JSON response from API: ", realUrl, e_1);
                            return [3 /*break*/, 6];
                        case 6:
                            if (!!res.ok) return [3 /*break*/, 9];
                            if (!(retryNum > 0 && (res.status < 400 || res.status > 499) && res.status !== 500)) return [3 /*break*/, 8];
                            console.error('API retry: ', res.status, realUrl);
                            return [4 /*yield*/, wait(1000)];
                        case 7:
                            _b.sent();
                            return [2 /*return*/, _fetch(urlOrData, data, update, plain, retryNum - 1)];
                        case 8:
                            err = (0, PendingResult_1.getPendingResult)('error', null, resData);
                            if (update) {
                                update(err);
                            }
                            else {
                                return [2 /*return*/, err];
                            }
                            return [2 /*return*/];
                        case 9:
                            response = (0, PendingResult_1.getPendingResult)('loaded', resData);
                            if (update) {
                                update(response);
                            }
                            else {
                                return [2 /*return*/, response];
                            }
                            return [3 /*break*/, 13];
                        case 10:
                            e_2 = _b.sent();
                            logger.trace('API retry: ', { realUrl: realUrl, urlOrData: urlOrData, data: data, update: update, plain: plain, retryNum: retryNum });
                            if (!(retryNum > 0)) return [3 /*break*/, 12];
                            return [4 /*yield*/, wait(2000)];
                        case 11:
                            _b.sent();
                            return [2 /*return*/, _fetch(urlOrData, data, update, plain, retryNum - 1)];
                        case 12:
                            errStr = (_a = e_2.apiError) !== null && _a !== void 0 ? _a : e_2.toString();
                            if (e_2 instanceof SyntaxError) {
                                logger.error({ error: e_2 }, "Fetch error");
                                errStr = 'Server error. Check configuration and network connection.';
                            }
                            err = (0, PendingResult_1.getPendingResult)('error', null, errStr);
                            if (update) {
                                update(err);
                            }
                            else {
                                return [2 /*return*/, err];
                            }
                            return [3 /*break*/, 13];
                        case 13: return [2 /*return*/];
                    }
                });
            }); };
            if (update) {
                fn();
            }
            else {
                return [2 /*return*/, fn()];
            }
            return [2 /*return*/];
        });
    });
};
exports.API = {
    //@ts-ignore
    actionFetch: function () {
        var arg = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            arg[_i] = arguments[_i];
        }
        return function () { return _fetch.apply(void 0, arg); };
    },
    fetch: _fetch,
    get: function (url, update, plain, retryNum) { return _fetch(url, null, update, plain, retryNum); },
    post: function (url, data, update, plain, retryNum) { return _fetch(url, data, update, plain, retryNum); }
};
