"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseSchema = exports.Schema = void 0;
exports.initSchemaSystem = initSchemaSystem;
var Zod = __importStar(require("zod"));
var uuid_1 = require("uuid");
var moment_1 = __importDefault(require("moment"));
initSchemaSystem();
exports.Schema = Zod.z;
// export const z = Zod.z
// export const ZodError = Zod.ZodError;
__exportStar(require("zod"), exports);
var onEvent = function (that, eventName, eventHandler, eventContext, eventParams) {
    if (!that._def.events) {
        that._def.events = [];
    }
    that._def.events.push({
        eventName: eventName,
        eventHandler: eventHandler,
        eventContext: eventContext !== null && eventContext !== void 0 ? eventContext : 'server',
        eventParams: eventParams
    });
    return that;
};
function extendZodTypePrototype(type) {
    type.prototype.indexed = function (indexFn) {
        this._def.indexed = true;
        this._def.indexFn = indexFn;
        return this;
    };
    type.prototype.groupIndex = function (groupName, groupCode) {
        this._def.groupIndex = true;
        this._def.groupName = groupName;
        this._def.groupCode = groupCode;
        return this;
    };
    type.prototype.linkTo = function (getElements, getId, readIds, getDisplayField, options) {
        this._def.linkTo = getElements;
        this._def.linkToId = getId;
        this._def.linkToReadIds = readIds;
        this._def.getDisplayField = getDisplayField;
        this._def.linkToOptions = options !== null && options !== void 0 ? options : {};
        return this;
    };
    type.prototype.synthesize = function (fn) {
        this._def.synthesize = fn;
        return this;
    };
    type.prototype.label = function (caption) {
        this._def.label = caption;
        return this;
    };
    type.prototype.hint = function (hintText) {
        this._def.hint = hintText;
        return this;
    };
    type.prototype.datePicker = function (type) {
        this._def.datePicker = type;
        this._def.coerce = true;
        return this;
    };
    type.prototype.sequence = function () {
        this._def.sequence = true;
        return this;
    };
    type.prototype.name = function (key) {
        this._def.keyName = key;
        return this;
    };
    type.prototype.display = function (views) {
        this._def.display = !views ? ['*'] : views;
        return this;
    };
    type.prototype.columnWidth = function (width) {
        this._def.columnWidth = width;
        return this;
    };
    type.prototype.hidden = function (views) {
        this._def.hidden = !views ? ['*'] : views;
        return this;
    };
    type.prototype.generate = function (val, force) {
        this._def.generate = { generator: val, force: force };
        return this;
    };
    type.prototype.before = function (val) {
        this._def.before = val;
        return this;
    };
    type.prototype.after = function (val) {
        this._def.after = val;
        return this;
    };
    type.prototype.dependsOn = function (field, value) {
        this._def.dependsOn = field;
        this._def.dependsOnValue = value;
        return this;
    };
    type.prototype.help = function (val) {
        this._def.help = val;
        return this;
    };
    type.prototype.generateOptions = function (call) {
        this._def.generateOptions = call;
        return this;
    };
    type.prototype.visible = function (fn) {
        this._def.visible = fn;
        return this;
    };
    type.prototype.choices = function () {
        this._def.choices = true;
        return this;
    };
    type.prototype.displayOptions = function (options) {
        this._def.displayOptions = options;
        return this;
    };
    type.prototype.secret = function () {
        this._def.secret = true;
        return this;
    };
    type.prototype.static = function () {
        this._def.static = true;
        return this;
    };
    type.prototype.id = function () {
        this._def.id = true;
        this._def.indexed = true;
        return this;
    };
    type.prototype.search = function (searchable) {
        if (searchable === void 0) { searchable = true; }
        this._def.search = searchable;
        return this;
    };
    type.prototype.filter = function (display) {
        if (display === void 0) { display = true; }
        this._def.filter = display;
        return this;
    };
    type.prototype.size = function (size) {
        this._def.size = size;
        return this;
    };
    type.prototype.color = function () {
        this._def.color = true;
        return this;
    };
    type.prototype.textArea = function (height) {
        if (height === void 0) { height = 300; }
        this._def.textArea = true;
        this._def.textAreaHeight = height;
        return this;
    };
    type.prototype.file = function (_a) {
        var initialPath = _a.initialPath, extensions = _a.extensions;
        this._def.file = true;
        this._def.initialPath = initialPath;
        this._def.extensions = extensions !== null && extensions !== void 0 ? extensions : ['*'];
        return this;
    };
    type.prototype.location = function (latKey, lonKey, type, options, style) {
        if (type === void 0) { type = 'point'; }
        if (options === void 0) { options = {}; }
        if (style === void 0) { style = {}; }
        this._def.latKey = latKey;
        this._def.lonKey = lonKey;
        this._def.location = true;
        this._def.locationType = type;
        this._def.locationOptions = options;
        this._def.locationStyle = style;
        return this;
    };
    type.prototype.group = function (group) {
        this._def.group = group;
        return this;
    };
    type.prototype.defaultValue = function (value) {
        this._def.defaultValue = value;
        return this;
    };
    type.prototype.on = function (eventName, eventHandler, eventContext, eventParams) {
        return onEvent(this, eventName, eventHandler, eventContext, eventParams);
    };
    type.prototype.onList = function (eventHandler, eventContext, eventParams) {
        return onEvent(this, 'list', eventHandler, eventContext, eventParams);
    };
    type.prototype.onCreate = function (eventHandler, eventContext, eventParams) {
        return onEvent(this, 'create', eventHandler, eventContext, eventParams);
    };
    type.prototype.onRead = function (eventHandler, eventContext, eventParams) {
        return onEvent(this, 'read', eventHandler, eventContext, eventParams);
    };
    type.prototype.onUpdate = function (eventHandler, eventContext, eventParams) {
        return onEvent(this, 'update', eventHandler, eventContext, eventParams);
    };
    type.prototype.onDelete = function (eventHandler, eventContext, eventParams) {
        return onEvent(this, 'delete', eventHandler, eventContext, eventParams);
    };
}
// Extiende el prototipo general de todos los tipos de Zod
function initSchemaSystem() {
    var zodTypes = [Zod.ZodString, Zod.ZodNumber, Zod.ZodBoolean, Zod.ZodArray, Zod.ZodAny, Zod.ZodOptional, Zod.ZodUnion, Zod.ZodObject, Zod.ZodRecord, Zod.ZodDate];
    zodTypes.forEach(function (type) { return extendZodTypePrototype(type); });
}
exports.BaseSchema = exports.Schema.object({
    id: exports.Schema.string().generate(function () { return (0, moment_1.default)().format('YYYYMM-DDHHmm-ssSSS') + '-' + (0, uuid_1.v4)().split('-')[0]; }).hidden().id(),
});
