"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateGroup = exports.StateElement = exports.ActionGroup = exports.Action = void 0;
var Action = /** @class */ (function () {
    function Action(automationData) {
        this.automationData = automationData;
    }
    Action.prototype.getData = function (raw) {
        if (raw) {
            return this.automationData;
        }
        return { action: __assign({}, this.automationData) };
    };
    return Action;
}());
exports.Action = Action;
var ActionGroup = /** @class */ (function () {
    function ActionGroup(actions, name) {
        this.actions = actions;
        this.name = name;
    }
    ActionGroup.prototype.getActionByName = function (name) {
        return this.actions.find(function (action) { return action.automationData.name === name; });
    };
    ActionGroup.prototype.getActions = function () {
        return this.actions;
    };
    ActionGroup.prototype.getData = function () {
        var _a;
        return _a = {}, _a[this.name] = this.actions.map(function (action) { return action.getData(); }), _a;
    };
    return ActionGroup;
}());
exports.ActionGroup = ActionGroup;
var StateElement = /** @class */ (function () {
    function StateElement(name, value) {
        this.name = name;
        this.value = value;
    }
    StateElement.prototype.getData = function () {
        var _a;
        var value = this.value;
        return _a = {}, _a[this.name] = value, _a;
    };
    return StateElement;
}());
exports.StateElement = StateElement;
var StateGroup = /** @class */ (function () {
    function StateGroup(states, name) {
        this.states = states;
        this.name = name;
    }
    StateGroup.prototype.addState = function (state) {
        this.states.push(state);
        return this;
    };
    StateGroup.prototype.getDataArray = function () {
        return this.states.map(function (state) { return state.getData(); });
    };
    StateGroup.prototype.getDataObject = function () {
        var data = {};
        this.states.forEach(function (state) {
            data = __assign(__assign({}, data), state.getData());
        });
        return data;
    };
    StateGroup.prototype.getData = function () {
        var _a;
        return _a = {}, _a[this.name] = this.states.map(function (state) { return state.getData(); }), _a;
    };
    return StateGroup;
}());
exports.StateGroup = StateGroup;
