"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProtoCollection = void 0;
var ProtoCollection = /** @class */ (function () {
    function ProtoCollection(models) {
        this.items = models;
    }
    ProtoCollection.prototype.getData = function () {
        return this.items.map(function (model) { return model.getData(); });
    };
    ProtoCollection.prototype.filter = function (fn) {
        return new ProtoCollection(this.items.filter(fn));
    };
    ProtoCollection.load = function (data, ModelClass) {
        return new ProtoCollection(data.map(function (itemData) { return new ModelClass(itemData); }));
    };
    return ProtoCollection;
}());
exports.ProtoCollection = ProtoCollection;
