"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProtoMemDB = void 0;
var state = {};
var ProtoMemDB = function (chunk) {
    if (!state[chunk]) {
        state[chunk] = {};
    }
    return {
        set: function (group, tag, name, value) {
            state[chunk][group] = state[chunk][group] || {};
            state[chunk][group][tag] = state[chunk][group][tag] || {};
            state[chunk][group][tag][name] = value;
        },
        get: function (group, tag, name) {
            return state[chunk][group] && state[chunk][group][tag] && state[chunk][group][tag][name];
        },
        getTags: function (group) {
            return state[chunk][group] ? Object.keys(state[chunk][group]) : [];
        },
        getByTag: function (group, tag) {
            return state[chunk][group] && state[chunk][group][tag];
        },
        getByGroup: function (group) {
            return state[chunk][group];
        },
        remove: function (group, tag, name) {
            if (state[chunk][group] && state[chunk][group][tag]) {
                delete state[chunk][group][tag][name];
            }
        },
        clear: function (group, tag) {
            if (state[chunk][group]) {
                delete state[chunk][group][tag];
            }
        },
        clearGroup: function (group) {
            delete state[chunk][group];
        },
        clearAll: function () {
            state[chunk] = {};
        },
        getState: function () {
            return state[chunk];
        },
        setState: function (newState) {
            state[chunk] = newState;
        },
        setGroupState: function (group, newState) {
            state[chunk][group] = newState;
        }
    };
};
exports.ProtoMemDB = ProtoMemDB;
