import { SessionDataType } from './lib/perms';
import { z, ZodObject } from './BaseSchema';
import { ProtoSchema } from './ProtoSchema';
export declare abstract class ProtoModel<T extends ProtoModel<T>> {
    data: any;
    session: SessionDataType;
    schema: ZodObject<any>;
    idField: string;
    objectSchema: ProtoSchema;
    modelName: string;
    indexes: {
        keys: string[];
        primary: string;
    };
    groupIndexes: {
        key: string;
        fn: Function;
    }[] | [];
    constructor(data: any, schema: ZodObject<any>, session?: SessionDataType, modelName?: string);
    static getClassFromDefinition(definition: any): {
        new (data: {
            id?: string;
        }, session?: SessionDataType): {
            data: any;
            session: SessionDataType;
            schema: ZodObject<any>;
            idField: string;
            objectSchema: ProtoSchema;
            modelName: string;
            indexes: {
                keys: string[];
                primary: string;
            };
            groupIndexes: {
                key: string;
                fn: Function;
            }[] | [];
            get(key: string, defaultValue?: any): any;
            getObjectSchema(): ProtoSchema;
            getGroupIndexes(): [] | {
                key: string;
                fn: Function;
            }[];
            getIndexes(): {
                keys: string[];
                primary: string;
            };
            getSchemaLinks(): {
                field: string;
                linkTo: any;
                linkToId: any;
                linkToReadIds: any;
                displayKey: any;
                linkToOptions: any;
            }[];
            getObjectFields(): string[];
            getObjectFieldsDefinition(): {};
            getModelName(): string;
            getLocation(): {
                lat: string;
                lon: string;
                type: string;
                style: any;
                options: any;
            } | undefined;
            getId(): any;
            getSequeceField(): string;
            canTransition(newData?: any): boolean;
            getNotificationsTopic(action?: string | undefined): string;
            getNotificationsPayload(): string;
            setId(id: string, newData?: any): AutoModel<{
                id?: string;
            }>;
            isVisible(): boolean;
            list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
            listTransformed(search?: any, transformers?: {}, session?: any, extraData?: any, params?: any, jsCode?: any): Promise<any>;
            create(data?: any): AutoModel<{
                id?: string;
            }>;
            createTransformed(transformers?: {}): Promise<AutoModel<{
                id?: string;
            }>>;
            read(extraData?: any): any;
            readTransformed(transformers?: {}, extraData?: any): Promise<any>;
            update(updatedModel: AutoModel<{
                id?: string;
            }>, data?: any): AutoModel<{
                id?: string;
            }>;
            updateTransformed(updatedModel: AutoModel<{
                id?: string;
            }>, transformers?: {}): Promise<AutoModel<{
                id?: string;
            }>>;
            delete(data?: any): AutoModel<{
                id?: string;
            }>;
            deleteTransformed(transformers?: {}): Promise<AutoModel<{
                id?: string;
            }>>;
            validate(): /*elided*/ any;
            serialize(raw?: any): string;
            linkTo(displayKey?: string | Function, options?: {
                deleteOnCascade: boolean;
            }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            getData(data?: any): any;
        };
        _newInstance(data: any, session?: SessionDataType): AutoModel<any>;
        getApiOptions(): {
            name: any;
            prefix: any;
        };
        schemaInstance: z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
            [x: string]: any;
        }, {
            [x: string]: any;
        }>;
        createDerived<D>(name: string, schema: ZodObject<any>, apiName?: any, apiPrefix?: any): {
            new (data: D, session?: SessionDataType): {
                data: any;
                session: SessionDataType;
                schema: ZodObject<any>;
                idField: string;
                objectSchema: ProtoSchema;
                modelName: string;
                indexes: {
                    keys: string[];
                    primary: string;
                };
                groupIndexes: {
                    key: string;
                    fn: Function;
                }[] | [];
                get(key: string, defaultValue?: any): any;
                getObjectSchema(): ProtoSchema;
                getGroupIndexes(): [] | {
                    key: string;
                    fn: Function;
                }[];
                getIndexes(): {
                    keys: string[];
                    primary: string;
                };
                getSchemaLinks(): {
                    field: string;
                    linkTo: any;
                    linkToId: any;
                    linkToReadIds: any;
                    displayKey: any;
                    linkToOptions: any;
                }[];
                getObjectFields(): string[];
                getObjectFieldsDefinition(): {};
                getModelName(): string;
                getLocation(): {
                    lat: string;
                    lon: string;
                    type: string;
                    style: any;
                    options: any;
                } | undefined;
                getId(): any;
                getSequeceField(): string;
                canTransition(newData?: any): boolean;
                getNotificationsTopic(action?: string | undefined): string;
                getNotificationsPayload(): string;
                setId(id: string, newData?: any): AutoModel<D>;
                isVisible(): boolean;
                list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
                listTransformed(search?: any, transformers?: {}, session?: any, extraData?: any, params?: any, jsCode?: any): Promise<any>;
                create(data?: any): AutoModel<D>;
                createTransformed(transformers?: {}): Promise<AutoModel<D>>;
                read(extraData?: any): any;
                readTransformed(transformers?: {}, extraData?: any): Promise<any>;
                update(updatedModel: AutoModel<D>, data?: any): AutoModel<D>;
                updateTransformed(updatedModel: AutoModel<D>, transformers?: {}): Promise<AutoModel<D>>;
                delete(data?: any): AutoModel<D>;
                deleteTransformed(transformers?: {}): Promise<AutoModel<D>>;
                validate(): /*elided*/ any;
                serialize(raw?: any): string;
                linkTo(displayKey?: string | Function, options?: {
                    deleteOnCascade: boolean;
                }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                    [x: string]: any;
                }, {
                    [x: string]: any;
                }>;
                getData(data?: any): any;
            };
            _newInstance(data: any, session?: SessionDataType): AutoModel<any>;
            getApiOptions(): {
                name: any;
                prefix: any;
            };
            schemaInstance: z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            createDerived<D>(name: string, schema: ZodObject<any>, apiName?: any, apiPrefix?: any): /*elided*/ any;
            getClassFromDefinition(definition: any): /*elided*/ any;
            getObjectSchema(): ProtoSchema;
            getGroupIndexes(): [] | {
                key: string;
                fn: Function;
            }[];
            getIndexes(): {
                keys: string[];
                primary: string;
            };
            getSchemaLinks(): {
                field: string;
                linkTo: any;
                linkToId: any;
                linkToReadIds: any;
                displayKey: any;
                linkToOptions: any;
            }[];
            getObjectFields(): string[];
            getObjectFieldsDefinition(): {};
            getModelName(): string;
            getIdField(): string;
            getSequeceField(): string;
            getNotificationsTopic(): string;
            getAdditionalDescriptions(): string;
            linkTo(displayKey?: string | Function, options?: {
                deleteOnCascade: boolean;
            }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            unserialize(data: string, session?: SessionDataType): ProtoModel<any>;
            getApiEndPoint(): string;
            load(data: any, session?: SessionDataType): ProtoModel<any>;
        };
        getClassFromDefinition(definition: any): /*elided*/ any;
        getObjectSchema(): ProtoSchema;
        getGroupIndexes(): [] | {
            key: string;
            fn: Function;
        }[];
        getIndexes(): {
            keys: string[];
            primary: string;
        };
        getSchemaLinks(): {
            field: string;
            linkTo: any;
            linkToId: any;
            linkToReadIds: any;
            displayKey: any;
            linkToOptions: any;
        }[];
        getObjectFields(): string[];
        getObjectFieldsDefinition(): {};
        getModelName(): string;
        getIdField(): string;
        getSequeceField(): string;
        getNotificationsTopic(): string;
        getAdditionalDescriptions(): string;
        linkTo(displayKey?: string | Function, options?: {
            deleteOnCascade: boolean;
        }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
            [x: string]: any;
        }, {
            [x: string]: any;
        }>;
        unserialize(data: string, session?: SessionDataType): ProtoModel<any>;
        getApiEndPoint(): string;
        load(data: any, session?: SessionDataType): ProtoModel<any>;
    };
    get(key: string, defaultValue?: any): any;
    static getObjectSchema(): ProtoSchema;
    getObjectSchema(): ProtoSchema;
    static getGroupIndexes(): [] | {
        key: string;
        fn: Function;
    }[];
    getGroupIndexes(): [] | {
        key: string;
        fn: Function;
    }[];
    static getIndexes(): {
        keys: string[];
        primary: string;
    };
    getIndexes(): {
        keys: string[];
        primary: string;
    };
    static getSchemaLinks(): {
        field: string;
        linkTo: any;
        linkToId: any;
        linkToReadIds: any;
        displayKey: any;
        linkToOptions: any;
    }[];
    getSchemaLinks(): {
        field: string;
        linkTo: any;
        linkToId: any;
        linkToReadIds: any;
        displayKey: any;
        linkToOptions: any;
    }[];
    static getObjectFields(): string[];
    getObjectFields(): string[];
    static getObjectFieldsDefinition(): {};
    getObjectFieldsDefinition(): {};
    static getModelName(): string;
    getModelName(): string;
    getLocation(): {
        lat: string;
        lon: string;
        type: string;
        style: any;
        options: any;
    } | undefined;
    static getIdField(): string;
    getId(): any;
    static getSequeceField(): string;
    getSequeceField(): string;
    canTransition(newData?: any): boolean;
    getNotificationsTopic(action?: string | undefined): string;
    static getNotificationsTopic(): string;
    getNotificationsPayload(): string;
    setId(id: string, newData?: any): T;
    isVisible(): boolean;
    list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
    listTransformed(search?: any, transformers?: {}, session?: any, extraData?: any, params?: any, jsCode?: any): Promise<any>;
    static getAdditionalDescriptions(): string;
    create(data?: any): T;
    createTransformed(transformers?: {}): Promise<T>;
    read(extraData?: any): any;
    readTransformed(transformers?: {}, extraData?: any): Promise<any>;
    update(updatedModel: T, data?: any): T;
    updateTransformed(updatedModel: T, transformers?: {}): Promise<T>;
    delete(data?: any): T;
    deleteTransformed(transformers?: {}): Promise<T>;
    validate(): this;
    serialize(raw?: any): string;
    static linkTo(displayKey?: string | Function, options?: {
        deleteOnCascade: boolean;
    }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
        [x: string]: any;
    }, {
        [x: string]: any;
    }>;
    linkTo(displayKey?: string | Function, options?: {
        deleteOnCascade: boolean;
    }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
        [x: string]: any;
    }, {
        [x: string]: any;
    }>;
    static getApiOptions(): any;
    protected static _newInstance(data: any, session?: SessionDataType): ProtoModel<any>;
    static unserialize(data: string, session?: SessionDataType): ProtoModel<any>;
    static getApiEndPoint(): string;
    static load(data: any, session?: SessionDataType): ProtoModel<any>;
    getData(data?: any): any;
}
export declare abstract class AutoModel<D> extends ProtoModel<AutoModel<D>> {
    protected static schemaInstance?: ZodObject<any>;
    constructor(data: D, schema: ZodObject<any>, session?: SessionDataType, modelName?: string);
    protected static _newInstance(data: any, session?: SessionDataType): AutoModel<any>;
    static createDerived<D>(name: string, schema: ZodObject<any>, apiName?: any, apiPrefix?: any): {
        new (data: D, session?: SessionDataType): {
            data: any;
            session: SessionDataType;
            schema: ZodObject<any>;
            idField: string;
            objectSchema: ProtoSchema;
            modelName: string;
            indexes: {
                keys: string[];
                primary: string;
            };
            groupIndexes: {
                key: string;
                fn: Function;
            }[] | [];
            get(key: string, defaultValue?: any): any;
            getObjectSchema(): ProtoSchema;
            getGroupIndexes(): [] | {
                key: string;
                fn: Function;
            }[];
            getIndexes(): {
                keys: string[];
                primary: string;
            };
            getSchemaLinks(): {
                field: string;
                linkTo: any;
                linkToId: any;
                linkToReadIds: any;
                displayKey: any;
                linkToOptions: any;
            }[];
            getObjectFields(): string[];
            getObjectFieldsDefinition(): {};
            getModelName(): string;
            getLocation(): {
                lat: string;
                lon: string;
                type: string;
                style: any;
                options: any;
            } | undefined;
            getId(): any;
            getSequeceField(): string;
            canTransition(newData?: any): boolean;
            getNotificationsTopic(action?: string | undefined): string;
            getNotificationsPayload(): string;
            setId(id: string, newData?: any): AutoModel<D>;
            isVisible(): boolean;
            list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
            listTransformed(search?: any, transformers?: {}, session?: any, extraData?: any, params?: any, jsCode?: any): Promise<any>;
            create(data?: any): AutoModel<D>;
            createTransformed(transformers?: {}): Promise<AutoModel<D>>;
            read(extraData?: any): any;
            readTransformed(transformers?: {}, extraData?: any): Promise<any>;
            update(updatedModel: AutoModel<D>, data?: any): AutoModel<D>;
            updateTransformed(updatedModel: AutoModel<D>, transformers?: {}): Promise<AutoModel<D>>;
            delete(data?: any): AutoModel<D>;
            deleteTransformed(transformers?: {}): Promise<AutoModel<D>>;
            validate(): /*elided*/ any;
            serialize(raw?: any): string;
            linkTo(displayKey?: string | Function, options?: {
                deleteOnCascade: boolean;
            }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            getData(data?: any): any;
        };
        _newInstance(data: any, session?: SessionDataType): AutoModel<any>;
        getApiOptions(): {
            name: any;
            prefix: any;
        };
        schemaInstance: z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
            [x: string]: any;
        }, {
            [x: string]: any;
        }>;
        createDerived<D>(name: string, schema: ZodObject<any>, apiName?: any, apiPrefix?: any): /*elided*/ any;
        getClassFromDefinition(definition: any): {
            new (data: {
                id?: string;
            }, session?: SessionDataType): {
                data: any;
                session: SessionDataType;
                schema: ZodObject<any>;
                idField: string;
                objectSchema: ProtoSchema;
                modelName: string;
                indexes: {
                    keys: string[];
                    primary: string;
                };
                groupIndexes: {
                    key: string;
                    fn: Function;
                }[] | [];
                get(key: string, defaultValue?: any): any;
                getObjectSchema(): ProtoSchema;
                getGroupIndexes(): [] | {
                    key: string;
                    fn: Function;
                }[];
                getIndexes(): {
                    keys: string[];
                    primary: string;
                };
                getSchemaLinks(): {
                    field: string;
                    linkTo: any;
                    linkToId: any;
                    linkToReadIds: any;
                    displayKey: any;
                    linkToOptions: any;
                }[];
                getObjectFields(): string[];
                getObjectFieldsDefinition(): {};
                getModelName(): string;
                getLocation(): {
                    lat: string;
                    lon: string;
                    type: string;
                    style: any;
                    options: any;
                } | undefined;
                getId(): any;
                getSequeceField(): string;
                canTransition(newData?: any): boolean;
                getNotificationsTopic(action?: string | undefined): string;
                getNotificationsPayload(): string;
                setId(id: string, newData?: any): AutoModel<{
                    id?: string;
                }>;
                isVisible(): boolean;
                list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
                listTransformed(search?: any, transformers?: {}, session?: any, extraData?: any, params?: any, jsCode?: any): Promise<any>;
                create(data?: any): AutoModel<{
                    id?: string;
                }>;
                createTransformed(transformers?: {}): Promise<AutoModel<{
                    id?: string;
                }>>;
                read(extraData?: any): any;
                readTransformed(transformers?: {}, extraData?: any): Promise<any>;
                update(updatedModel: AutoModel<{
                    id?: string;
                }>, data?: any): AutoModel<{
                    id?: string;
                }>;
                updateTransformed(updatedModel: AutoModel<{
                    id?: string;
                }>, transformers?: {}): Promise<AutoModel<{
                    id?: string;
                }>>;
                delete(data?: any): AutoModel<{
                    id?: string;
                }>;
                deleteTransformed(transformers?: {}): Promise<AutoModel<{
                    id?: string;
                }>>;
                validate(): /*elided*/ any;
                serialize(raw?: any): string;
                linkTo(displayKey?: string | Function, options?: {
                    deleteOnCascade: boolean;
                }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                    [x: string]: any;
                }, {
                    [x: string]: any;
                }>;
                getData(data?: any): any;
            };
            _newInstance(data: any, session?: SessionDataType): AutoModel<any>;
            getApiOptions(): {
                name: any;
                prefix: any;
            };
            schemaInstance: z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            createDerived<D>(name: string, schema: ZodObject<any>, apiName?: any, apiPrefix?: any): /*elided*/ any;
            getClassFromDefinition(definition: any): /*elided*/ any;
            getObjectSchema(): ProtoSchema;
            getGroupIndexes(): [] | {
                key: string;
                fn: Function;
            }[];
            getIndexes(): {
                keys: string[];
                primary: string;
            };
            getSchemaLinks(): {
                field: string;
                linkTo: any;
                linkToId: any;
                linkToReadIds: any;
                displayKey: any;
                linkToOptions: any;
            }[];
            getObjectFields(): string[];
            getObjectFieldsDefinition(): {};
            getModelName(): string;
            getIdField(): string;
            getSequeceField(): string;
            getNotificationsTopic(): string;
            getAdditionalDescriptions(): string;
            linkTo(displayKey?: string | Function, options?: {
                deleteOnCascade: boolean;
            }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
                [x: string]: any;
            }, {
                [x: string]: any;
            }>;
            unserialize(data: string, session?: SessionDataType): ProtoModel<any>;
            getApiEndPoint(): string;
            load(data: any, session?: SessionDataType): ProtoModel<any>;
        };
        getObjectSchema(): ProtoSchema;
        getGroupIndexes(): [] | {
            key: string;
            fn: Function;
        }[];
        getIndexes(): {
            keys: string[];
            primary: string;
        };
        getSchemaLinks(): {
            field: string;
            linkTo: any;
            linkToId: any;
            linkToReadIds: any;
            displayKey: any;
            linkToOptions: any;
        }[];
        getObjectFields(): string[];
        getObjectFieldsDefinition(): {};
        getModelName(): string;
        getIdField(): string;
        getSequeceField(): string;
        getNotificationsTopic(): string;
        getAdditionalDescriptions(): string;
        linkTo(displayKey?: string | Function, options?: {
            deleteOnCascade: boolean;
        }): z.ZodObject<any, z.UnknownKeysParam, z.ZodTypeAny, {
            [x: string]: any;
        }, {
            [x: string]: any;
        }>;
        unserialize(data: string, session?: SessionDataType): ProtoModel<any>;
        getApiEndPoint(): string;
        load(data: any, session?: SessionDataType): ProtoModel<any>;
    };
}
