"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoModel = exports.ProtoModel = void 0;
var Session_1 = require("./Session");
var BaseSchema_1 = require("./BaseSchema");
var ProtoSchema_1 = require("./ProtoSchema");
var logger_1 = require("./logger");
var Api_1 = require("./Api");
var logger = (0, logger_1.getLogger)();
function parseSearch(search) {
    var regex = /(\w+):("[^"]+"|\S+)/g;
    var parsed = {};
    var match;
    var searchWithoutTags = search;
    while ((match = regex.exec(search)) !== null) {
        var key = match[1].toLowerCase();
        var value = match[2].replace(/"/g, '').toLowerCase();
        parsed[key] = value;
        searchWithoutTags = searchWithoutTags.replace(match[0], '');
    }
    searchWithoutTags = searchWithoutTags.trim();
    return { parsed: parsed, searchWithoutTags: searchWithoutTags };
}
var ProtoModel = /** @class */ (function () {
    function ProtoModel(data, schema, session, modelName) {
        var _a, _b;
        this.data = data;
        this.session = session !== null && session !== void 0 ? session : (0, Session_1.createSession)();
        this.schema = schema.extend({}); // create a copy to avoid sharing schema with other instances
        this.objectSchema = ProtoSchema_1.ProtoSchema.load(this.schema);
        this.modelName = (_a = modelName === null || modelName === void 0 ? void 0 : modelName.toLowerCase()) !== null && _a !== void 0 ? _a : 'unknown';
        this.idField = (_b = this.objectSchema.is('id').getLast('id')) !== null && _b !== void 0 ? _b : 'id';
        this.indexes = {
            primary: this.idField,
            keys: this.objectSchema.is('indexed').getFields()
        };
        var groupIndexesSchema = this.objectSchema.is('groupIndex');
        var groupIndexes = groupIndexesSchema.getFields();
        this.groupIndexes = groupIndexes.map(function (field) {
            var _a;
            return {
                key: field,
                name: (_a = groupIndexesSchema.getFieldKeyDefinition(field, 'groupName')) !== null && _a !== void 0 ? _a : field,
                fn: groupIndexesSchema.getFieldKeyDefinition(field, 'groupCode')
            };
        });
    }
    ProtoModel.getClassFromDefinition = function (definition) {
        var schema = BaseSchema_1.Schema.object(Object.keys(definition.keys).reduce(function (acc, key) {
            var _a;
            var element = definition.keys[key];
            var schema = BaseSchema_1.z;
            if (typeof schema[element.type] !== 'function') {
                throw new Error("Type ".concat(element.type, " does not exist on z"));
            }
            schema = schema[element.type].apply(schema, ((_a = element.params) !== null && _a !== void 0 ? _a : []));
            if (element.modifiers) {
                element.modifiers.forEach(function (modifier) {
                    var methodName = modifier.name;
                    var params = modifier.params || [];
                    if (typeof schema[methodName] === 'function') {
                        schema = schema[methodName].apply(schema, params);
                    }
                    else {
                        throw new Error("Modifier ".concat(methodName, " does not exist on z"));
                    }
                });
            }
            acc[key] = schema;
            return acc;
        }, {}));
        var hasId = Object.keys(schema.shape).some(function (key) { return schema.shape[key]._def.id; });
        var objSchema = BaseSchema_1.Schema.object(__assign(__assign({}, (!hasId ? BaseSchema_1.BaseSchema.shape : {})), schema.shape));
        var objModel = AutoModel.createDerived(definition.id, objSchema, definition.apiOptions.name, definition.apiOptions.prefix);
        return objModel;
    };
    ProtoModel.prototype.get = function (key, defaultValue) {
        var _a;
        return (_a = this.data[key]) !== null && _a !== void 0 ? _a : defaultValue;
    };
    ProtoModel.getObjectSchema = function () {
        return this._newInstance({}).getObjectSchema();
    };
    ProtoModel.prototype.getObjectSchema = function () {
        return this.objectSchema;
    };
    ProtoModel.getGroupIndexes = function () {
        return this._newInstance({}).getGroupIndexes();
    };
    ProtoModel.prototype.getGroupIndexes = function () {
        return this.groupIndexes;
    };
    ProtoModel.getIndexes = function () {
        return this._newInstance({}).getIndexes();
    };
    ProtoModel.prototype.getIndexes = function () {
        return this.indexes;
    };
    ProtoModel.getSchemaLinks = function () {
        return this._newInstance({}).getSchemaLinks();
    };
    ProtoModel.prototype.getSchemaLinks = function () {
        var _this = this;
        return this.objectSchema.is('linkTo').getFields().map(function (field) {
            var _a = _this.objectSchema.getFieldDefinition(field), linkTo = _a.linkTo, linkToId = _a.linkToId, linkToReadIds = _a.linkToReadIds, displayKey = _a.displayKey, linkToOptions = _a.linkToOptions;
            return { field: field, linkTo: linkTo, linkToId: linkToId, linkToReadIds: linkToReadIds, displayKey: displayKey, linkToOptions: linkToOptions };
        });
    };
    ProtoModel.getObjectFields = function () {
        return this._newInstance({}).getObjectFields();
    };
    ProtoModel.prototype.getObjectFields = function () {
        return this.objectSchema.getFields();
    };
    ProtoModel.getObjectFieldsDefinition = function () {
        return this._newInstance({}).getObjectFieldsDefinition();
    };
    ProtoModel.prototype.getObjectFieldsDefinition = function () {
        return this.objectSchema.getDefinition();
    };
    ProtoModel.getModelName = function () {
        return this._newInstance({}).getModelName();
    };
    ProtoModel.prototype.getModelName = function () {
        return this.modelName;
    };
    ProtoModel.prototype.getLocation = function () {
        var locationFields = this.objectSchema.is('location').getFields();
        if (!locationFields.length) {
            throw "Model error: " + this.getModelName() + " doesn't have location information";
        }
        var field = locationFields[0];
        var latKey = this.objectSchema.getFieldKeyDefinition(field, 'latKey');
        var lonKey = this.objectSchema.getFieldKeyDefinition(field, 'lonKey');
        if (!this.data[field]) {
            return;
        }
        return {
            type: this.objectSchema.getFieldKeyDefinition(field, 'locationType'),
            style: this.objectSchema.getFieldKeyDefinition(field, 'locationStyle'),
            options: this.objectSchema.getFieldKeyDefinition(field, 'locationOptions'),
            lat: this.data[field][latKey],
            lon: this.data[field][lonKey]
        };
    };
    ProtoModel.getIdField = function () {
        var _a;
        return (_a = this.getObjectSchema().is('id').getLast('id')) !== null && _a !== void 0 ? _a : 'id';
    };
    ProtoModel.prototype.getId = function () {
        return this.data[this.idField];
    };
    ProtoModel.getSequeceField = function () {
        return this._newInstance({}).getSequeceField();
    };
    ProtoModel.prototype.getSequeceField = function () {
        var _this = this;
        return this.objectSchema.getFields().find(function (field) {
            var sequence = _this.objectSchema.getFieldDefinition(field).sequence;
            return sequence;
        });
    };
    ProtoModel.prototype.canTransition = function (newData) {
        return true;
    };
    ProtoModel.prototype.getNotificationsTopic = function (action) {
        if (!action) {
            return "notifications/".concat(this.getModelName(), "/#");
        }
        return "notifications/".concat(this.getModelName(), "/").concat(action, "/").concat(this.getId());
    };
    ProtoModel.getNotificationsTopic = function () {
        return this._newInstance({}).getNotificationsTopic();
    };
    ProtoModel.prototype.getNotificationsPayload = function () {
        return this.serialize();
    };
    ProtoModel.prototype.setId = function (id, newData) {
        var _a;
        return new this.constructor(__assign(__assign({}, (newData ? newData : this.data)), (_a = {}, _a[this.idField] = id, _a)), this.session, this.modelName);
    };
    ProtoModel.prototype.isVisible = function () {
        return true;
    };
    ProtoModel.prototype.list = function (search, session, extraData, params, jsCode) {
        var _this = this;
        if (params && params.filter) {
            var allFiltersMatch = Object.keys(params.filter).every(function (key) {
                var _a;
                if (params.filter[key].from || params.filter[key].to) {
                    var valid = true;
                    if (params.filter[key].from && _this.data && _this.data[key] < params.filter[key].from) {
                        valid = false;
                    }
                    if (params.filter[key].to && _this.data && _this.data[key] > params.filter[key].to) {
                        valid = false;
                    }
                    return valid;
                }
                else {
                    return _this.data && ((_a = _this.data[key]) === null || _a === void 0 ? void 0 : _a.toString()) == params.filter[key];
                }
            });
            if (!allFiltersMatch)
                return;
        }
        if (jsCode) {
            try {
                var fn = new Function('element', 'session', 'extraData', jsCode + "\n return filter_element(element, session, extraData);");
                var result = fn(this, session, extraData);
                if (result === false)
                    return;
            }
            catch (error) {
                logger.error({ error: error }, "Error executing JS code: ".concat(jsCode));
                return;
            }
            return this.read();
        }
        else if (search) {
            var _a = parseSearch(search), parsed = _a.parsed, searchWithoutTags = _a.searchWithoutTags;
            for (var _i = 0, _b = Object.entries(parsed); _i < _b.length; _i++) {
                var _c = _b[_i], key = _c[0], value = _c[1];
                if (!this.data.hasOwnProperty(key) || this.data[key] != value) {
                    //logger.debug({ data: this.data[key] }, `discarded: ${JSON.stringify(this.data[key])}`)
                    return;
                }
            }
            var findMatch_1 = function (schema, data, searchTerm, path) {
                var _a, _b, _c;
                if (path === void 0) { path = []; }
                for (var key in schema.shape) {
                    var value = schema.shape[key];
                    if (value._def.typeName === "ZodObject") {
                        if (findMatch_1(value, data[key], searchTerm, __spreadArray(__spreadArray([], path, true), [key], false)))
                            return true;
                    }
                    else if (value._def.search || ((_c = (_b = (_a = value._def) === null || _a === void 0 ? void 0 : _a.innerType) === null || _b === void 0 ? void 0 : _b._def) === null || _c === void 0 ? void 0 : _c.search)) {
                        var propValue = __spreadArray(__spreadArray([], path, true), [key], false).reduce(function (acc, key) { return acc && acc[key]; }, _this.data);
                        if (propValue && propValue.toString().toLowerCase().includes(searchTerm.toLowerCase())) {
                            return true;
                        }
                    }
                }
                return false;
            };
            if (findMatch_1(this.objectSchema, this.data, searchWithoutTags)) {
                return this.read();
            }
        }
        else {
            return this.read();
        }
    };
    ProtoModel.prototype.listTransformed = function (search_1) {
        return __awaiter(this, arguments, void 0, function (search, transformers, session, extraData, params, jsCode) {
            var result;
            if (transformers === void 0) { transformers = {}; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = this.list(search, session, extraData, params, jsCode);
                        if (!result) return [3 /*break*/, 2];
                        return [4 /*yield*/, (this.getObjectSchema().apply('list', result, transformers))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ProtoModel.getAdditionalDescriptions = function () {
        return '';
    };
    ProtoModel.prototype.create = function (data) {
        var transformed = this.getData(data);
        logger.trace({ transformed: transformed }, "Creating object: ".concat(JSON.stringify(transformed)));
        return (new this.constructor(transformed, this.session, this.modelName)).validate();
    };
    ProtoModel.prototype.createTransformed = function () {
        return __awaiter(this, arguments, void 0, function (transformers) {
            var newData;
            if (transformers === void 0) { transformers = {}; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getObjectSchema().apply('create', __assign({}, this.data), transformers)];
                    case 1:
                        newData = _a.sent();
                        return [2 /*return*/, this.create(newData)];
                }
            });
        });
    };
    ProtoModel.prototype.read = function (extraData) {
        return __assign({}, this.data);
    };
    ProtoModel.prototype.readTransformed = function () {
        return __awaiter(this, arguments, void 0, function (transformers, extraData) {
            var result;
            if (transformers === void 0) { transformers = {}; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (this.getObjectSchema().apply('read', this.read(extraData), transformers))];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ProtoModel.prototype.update = function (updatedModel, data) {
        return updatedModel.setId(this.getId(), __assign({}, (data ? data : updatedModel.data)));
    };
    ProtoModel.prototype.updateTransformed = function (updatedModel_1) {
        return __awaiter(this, arguments, void 0, function (updatedModel, transformers) {
            var newData;
            if (transformers === void 0) { transformers = {}; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getObjectSchema().apply('update', __assign({}, updatedModel.data), transformers, __assign({}, this.data))];
                    case 1:
                        newData = _a.sent();
                        return [2 /*return*/, this.update(updatedModel, newData)];
                }
            });
        });
    };
    ProtoModel.prototype.delete = function (data) {
        return new this.constructor(__assign({}, (data ? data : this.data)), this.session, this.modelName);
    };
    ProtoModel.prototype.deleteTransformed = function () {
        return __awaiter(this, arguments, void 0, function (transformers) {
            var newData;
            if (transformers === void 0) { transformers = {}; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getObjectSchema().apply('delete', __assign({}, this.data), transformers)];
                    case 1:
                        newData = _a.sent();
                        return [2 /*return*/, this.delete(newData)];
                }
            });
        });
    };
    ProtoModel.prototype.validate = function () {
        this.schema.parse(this.data); //validate
        return this;
    };
    ProtoModel.prototype.serialize = function (raw) {
        return raw ? this.data : JSON.stringify(this.data);
    };
    ProtoModel.linkTo = function (displayKey, options) {
        return this._newInstance({}).linkTo(displayKey, options);
    };
    ProtoModel.prototype.linkTo = function (displayKey, options) {
        var _this = this;
        var apiEndPoint = this.constructor.getApiEndPoint();
        return this.schema.linkTo(function (search, URLTransform) { return __awaiter(_this, void 0, void 0, function () {
            var url, result;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        url = URLTransform(apiEndPoint + (search ? '?search=' + search : ''));
                        return [4 /*yield*/, Api_1.API.get(url)];
                    case 1:
                        result = _c.sent();
                        return [2 /*return*/, (_b = (_a = result.data) === null || _a === void 0 ? void 0 : _a.items) !== null && _b !== void 0 ? _b : []];
                }
            });
        }); }, function (data) { return data[_this.idField]; }, function (link, ids, items) { return __awaiter(_this, void 0, void 0, function () {
            var response, _loop_1, _i, items_1, item;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Api_1.API.post(apiEndPoint + '?action=read_multiple', ids)];
                    case 1:
                        response = _a.sent();
                        if (response.data && response.data.length) {
                            _loop_1 = function (item) {
                                var linkId = item[link.field];
                                var linkItem = response.data.find(function (x) { return x[_this.idField] == linkId; });
                                if (linkItem) {
                                    item[link.field] = linkItem;
                                }
                            };
                            for (_i = 0, items_1 = items; _i < items_1.length; _i++) {
                                item = items_1[_i];
                                _loop_1(item);
                            }
                        }
                        return [2 /*return*/, items];
                }
            });
        }); }, displayKey, options);
    };
    ProtoModel.getApiOptions = function () {
        throw new Error("Derived class must implement getApiOptions");
    };
    ProtoModel._newInstance = function (data, session) {
        throw new Error("Derived class must implement _newInstance.");
    };
    ProtoModel.unserialize = function (data, session) {
        return this._newInstance(JSON.parse(data), session);
    };
    ProtoModel.getApiEndPoint = function () {
        var options = this.getApiOptions();
        var prefix = options.prefix.endsWith('/') ? options.prefix.slice(0, -1) : options.prefix;
        return prefix + '/' + options.name;
    };
    ProtoModel.load = function (data, session) {
        return this._newInstance(data !== null && data !== void 0 ? data : {}, session);
    };
    ProtoModel.prototype.getData = function (data) {
        return __assign({}, (this.getObjectSchema().applyGenerators(data !== null && data !== void 0 ? data : this.data)));
    };
    return ProtoModel;
}());
exports.ProtoModel = ProtoModel;
var AutoModel = /** @class */ (function (_super) {
    __extends(AutoModel, _super);
    function AutoModel(data, schema, session, modelName) {
        return _super.call(this, data, schema, session, modelName) || this;
    }
    AutoModel._newInstance = function (data, session) {
        throw new Error("Derived class must implement _newInstance.");
    };
    AutoModel.createDerived = function (name, schema, apiName, apiPrefix) {
        var DerivedModel = /** @class */ (function (_super) {
            __extends(DerivedModel, _super);
            function DerivedModel(data, session) {
                return _super.call(this, data, schema, session, name.substring(0, name.length - 5).toLowerCase()) || this;
            }
            DerivedModel._newInstance = function (data, session) {
                return new DerivedModel(data, session);
            };
            DerivedModel.getApiOptions = function () {
                return {
                    name: apiName,
                    prefix: apiPrefix
                };
            };
            DerivedModel.schemaInstance = schema;
            return DerivedModel;
        }(AutoModel));
        Object.defineProperty(DerivedModel, 'name', { value: name, writable: false });
        return DerivedModel;
    };
    return AutoModel;
}(ProtoModel));
exports.AutoModel = AutoModel;
