"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProtoSchema = void 0;
var ProtoSchema = /** @class */ (function () {
    function ProtoSchema(shape) {
        this.shape = shape;
    }
    ProtoSchema.prototype.getFields = function () {
        return Object.keys(this.shape);
    };
    ProtoSchema.prototype.getDefinition = function () {
        var _this = this;
        //this.shape is a zod object
        //return an object with the field name and the type of the field as a string
        var fields = {};
        Object.keys(this.shape).forEach(function (key) {
            fields[key] = {
                type: _this.shape[key]._def.typeName.replace("Zod", "").toLowerCase(),
                description: _this.shape[key]._def.hint || "",
                isId: _this.shape[key]._def.id || false
            };
        });
        return fields;
    };
    ProtoSchema.prototype.getFieldKeyDefinition = function (field, key) {
        return this.shape[field] ? this.shape[field]._def[key] : undefined;
    };
    //get field definition
    ProtoSchema.prototype.getFieldDefinition = function (field) {
        return this.shape[field] ? this.shape[field]._def : undefined;
    };
    ProtoSchema.prototype.applyGenerators = function (data) {
        var _this = this;
        var newData = __assign({}, data);
        Object.keys(this.shape).forEach(function (key) {
            if (_this.shape[key]._def.generate) {
                var gen = _this.shape[key]._def.generate;
                if (!data[key] || gen.force) {
                    newData[key] = typeof gen.generator === 'function' ? gen.generator(data) : gen.generator;
                }
            }
        });
        return newData;
    };
    //apply generative schema to data
    ProtoSchema.prototype.apply = function (eventName, data, transformers, prevData) {
        return __awaiter(this, void 0, void 0, function () {
            var newData, withEvents, keys, _loop_1, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        newData = __assign({}, data);
                        withEvents = this.is('events');
                        keys = Object.keys(withEvents.shape);
                        _loop_1 = function () {
                            var key, currField, isNode, events, x, e;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        key = keys[i];
                                        currField = withEvents.shape[key];
                                        isNode = typeof process !== 'undefined' && process.versions && process.versions.node;
                                        events = currField._def.events.filter(function (e) { return e.eventName == eventName && (!e.eventContext || (e.eventContext == 'client' && !isNode) || (e.eventContext == 'server' && isNode)); });
                                        x = 0;
                                        _b.label = 1;
                                    case 1:
                                        if (!(x < events.length)) return [3 /*break*/, 4];
                                        e = events[x];
                                        if (!transformers[e.eventHandler]) return [3 /*break*/, 3];
                                        return [4 /*yield*/, transformers[e.eventHandler](key, e, newData, prevData)];
                                    case 2:
                                        newData = _b.sent();
                                        _b.label = 3;
                                    case 3:
                                        x++;
                                        return [3 /*break*/, 1];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        };
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < keys.length)) return [3 /*break*/, 4];
                        return [5 /*yield**/, _loop_1()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, newData];
                }
            });
        });
    };
    ProtoSchema.prototype.getLayout = function (num) {
        var _this = this;
        var elements = [[]];
        var curIndex = 0;
        Object.keys(this.shape).forEach(function (key) {
            var field = _this.shape[key];
            if (elements[curIndex].length == num) {
                elements.push([]);
                curIndex++;
            }
            elements[curIndex].push(__assign(__assign({}, field), { name: key }));
        });
        return elements;
    };
    ProtoSchema.prototype.getFirst = function (field) {
        var _this = this;
        return Object.keys(this.shape).find(function (key) {
            if (_this.shape[key]._def[field]) {
                return key;
            }
        });
    };
    ProtoSchema.prototype.getLast = function (field) {
        var _this = this;
        var lastKey = undefined;
        Object.keys(this.shape).forEach(function (key) {
            if (_this.shape[key]._def[field]) {
                lastKey = key;
            }
        });
        return lastKey;
    };
    ProtoSchema.prototype.isDisplay = function (displayType) {
        var _this = this;
        var validFields = {};
        Object.keys(this.shape).forEach(function (k) {
            if (!_this.shape[k]._def.display || (_this.shape[k]._def.display.includes('*')) || _this.shape[k]._def.display.includes(displayType)) {
                if (!_this.shape[k]._def.hidden || (!_this.shape[k]._def.hidden.includes('*') && !_this.shape[k]._def.hidden.includes(displayType))) {
                    validFields[k] = _this.shape[k];
                }
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.isVisible = function (displayType, object) {
        var displayFields = this.isDisplay(displayType);
        var validFields = {};
        Object.keys(displayFields.shape).forEach(function (key) {
            if (displayFields.shape[key]._def["visible"]) {
                var visible = displayFields.shape[key]._def["visible"](displayType, object);
                if (visible) {
                    validFields[key] = displayFields.shape[key];
                }
            }
            else {
                validFields[key] = displayFields.shape[key];
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.is = function (field) {
        var _this = this;
        var validFields = {};
        Object.keys(this.shape).forEach(function (key) {
            if (_this.shape[key]._def[field]) {
                validFields[key] = _this.shape[key];
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.isNot = function (field) {
        var _this = this;
        var validFields = {};
        Object.keys(this.shape).forEach(function (key) {
            if (!_this.shape[key]._def[field]) {
                validFields[key] = _this.shape[key];
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.isAfter = function (afterField) {
        var _this = this;
        var validFields = {};
        Object.keys(this.shape).forEach(function (field) {
            var _a;
            if (((_a = _this.shape[field]._def) === null || _a === void 0 ? void 0 : _a.after) && _this.shape[field]._def.after == afterField) {
                validFields[field] = _this.shape[field];
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.isBefore = function (beforeField) {
        var _this = this;
        var validFields = {};
        Object.keys(this.shape).forEach(function (field) {
            var _a;
            if (((_a = _this.shape[field]._def) === null || _a === void 0 ? void 0 : _a.before) && _this.shape[field]._def.before == beforeField) {
                validFields[field] = _this.shape[field];
            }
        });
        return new ProtoSchema(validFields);
    };
    ProtoSchema.prototype.merge = function (schema) {
        var _this = this;
        var newfields = {};
        Object.keys(this.shape).forEach(function (key) {
            var beforeFields = schema.isBefore(key);
            newfields = __assign(__assign({}, newfields), beforeFields.shape);
            newfields[key] = _this.shape[key];
            var afterFields = schema.isAfter(key);
            newfields = __assign(__assign({}, newfields), afterFields.shape);
        });
        return new ProtoSchema(newfields);
    };
    //generate a protoSchema from a extended zodSchema
    ProtoSchema.load = function (schema) {
        return new ProtoSchema(schema.shape);
    };
    return ProtoSchema;
}());
exports.ProtoSchema = ProtoSchema;
