import { z } from './BaseSchema';
import { ProtoModel } from './ProtoModel';
import { SessionDataType } from './lib/perms';
export declare const BaseEventSchema: z.ZodObject<any, "strip", z.ZodTypeAny, {
    [x: string]: any;
}, {
    [x: string]: any;
}>;
export declare const EventSchema: z.ZodObject<any, "strip", z.ZodTypeAny, {
    [x: string]: any;
}, {
    [x: string]: any;
}>;
export type EventType = z.infer<typeof EventSchema>;
export declare class EventModel extends ProtoModel<EventModel> {
    constructor(data: EventType, session?: SessionDataType);
    list(search?: any, session?: any, extraData?: any, params?: any, jsCode?: any): any;
    getNotificationsTopic(action: string): string;
    protected static _newInstance(data: any, session?: SessionDataType): EventModel;
}
export declare const generateEvent: (event: EventType, token?: string) => Promise<void>;
