export declare const requireAuth: (session: SessionDataType) => void;
export declare const hasPermission: (session: SessionDataType, permission: string) => void;
export type userData = {
    id?: string;
    type?: string;
    admin?: boolean;
    permissions?: string[];
    environments?: string[];
};
export type validatedUserData = userData & {
    iat: number;
    exp: number;
};
export type SessionDataType = {
    user: userData;
    loggedIn: boolean;
    token?: string;
};
