"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLogger = void 0;
var pino_1 = __importDefault(require("pino"));
var Config_1 = require("./Config");
var getLogger = function (logId, userConfig) {
    if (logId === void 0) { logId = 'default'; }
    var config = userConfig !== null && userConfig !== void 0 ? userConfig : (0, Config_1.getConfig)();
    var logger = (0, pino_1.default)(config.logger);
    //wrapper for pino, allowing to have a third parameter id, to correlate messages with specific code nodes
    return {
        error: function (data, msg, id) { return logger.error(data, msg); },
        fatal: function (data, msg, id) { return logger.fatal(data, msg); },
        warn: function (data, msg, id) { return logger.warn(data, msg); },
        info: function (data, msg, id) { return logger.info(data, msg); },
        debug: function (data, msg, id) { return logger.debug(data, msg); },
        trace: function (data, msg, id) { return logger.trace(data, msg); },
    };
};
exports.getLogger = getLogger;
