import { z } from "../BaseSchema";
export declare const LoginSchema: z.ZodObject<{
    username: z.ZodString;
    password: z.ZodString;
}, "strip", z.ZodTypeAny, {
    username?: string;
    password?: string;
}, {
    username?: string;
    password?: string;
}>;
export type LoginRequest = z.infer<typeof LoginSchema>;
export declare const RegisterSchema: z.ZodEffects<z.ZodObject<{
    username: z.ZodString;
    password: z.ZodString;
    rePassword: z.ZodAny;
}, "strip", z.ZodTypeAny, {
    username?: string;
    password?: string;
    rePassword?: any;
}, {
    username?: string;
    password?: string;
    rePassword?: any;
}>, {
    username?: string;
    password?: string;
    rePassword?: any;
}, {
    username?: string;
    password?: string;
    rePassword?: any;
}>;
export declare const CmdRegisterSchema: z.ZodObject<{
    type: z.ZodString;
    username: z.ZodString;
    password: z.ZodString;
}, "strip", z.ZodTypeAny, {
    type?: string;
    username?: string;
    password?: string;
}, {
    type?: string;
    username?: string;
    password?: string;
}>;
export type CmdRegisterRequest = z.infer<typeof CmdRegisterSchema>;
export type RegisterRequest = z.infer<typeof RegisterSchema>;
