"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CmdRegisterSchema = exports.RegisterSchema = exports.LoginSchema = void 0;
var BaseSchema_1 = require("../BaseSchema");
exports.LoginSchema = BaseSchema_1.z.object({
    username: BaseSchema_1.z.string().email(),
    password: BaseSchema_1.z.string()
});
var BaseRegisterSchema = BaseSchema_1.z.object({
    username: BaseSchema_1.z.string().email(),
    password: BaseSchema_1.z.string().min(6),
    rePassword: BaseSchema_1.z.any()
});
exports.RegisterSchema = BaseRegisterSchema.refine(function (obj) { return obj.password === obj.rePassword; }, {
    message: 'Passwords do not match',
    path: ['password'], // this value is concatenated to the end of the actual path of the error
});
var hasType = BaseSchema_1.z.object({
    type: BaseSchema_1.z.string().min(1)
});
exports.CmdRegisterSchema = BaseSchema_1.z.object(__assign(__assign({}, BaseRegisterSchema.omit({ rePassword: true }).shape), hasType.shape));
