import { z } from "../BaseSchema";
import { ProtoModel } from "../ProtoModel";
import { SessionDataType } from "../lib/perms";
export declare const UserSchema: z.ZodObject<{
    username: z.ZodString;
    type: z.ZodString;
    password: z.ZodString;
    permissions: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    createdAt: z.ZodString;
    lastLogin: z.ZodOptional<z.ZodString>;
    from: z.ZodString;
}, "strip", z.ZodTypeAny, {
    username?: string;
    type?: string;
    password?: string;
    permissions?: string[];
    createdAt?: string;
    lastLogin?: string;
    from?: string;
}, {
    username?: string;
    type?: string;
    password?: string;
    permissions?: string[];
    createdAt?: string;
    lastLogin?: string;
    from?: string;
}>;
export type UserType = z.infer<typeof UserSchema>;
export declare class UserModel extends ProtoModel<UserModel> {
    constructor(data: UserType, session?: SessionDataType);
    static load(data: any, session?: SessionDataType): UserModel;
    protected static _newInstance(data: any, session?: SessionDataType): UserModel;
}
