"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserModel = exports.UserSchema = void 0;
var BaseSchema_1 = require("../BaseSchema");
var moment_1 = __importDefault(require("moment"));
var ProtoModel_1 = require("../ProtoModel");
exports.UserSchema = BaseSchema_1.Schema.object({
    username: BaseSchema_1.z.string().email().label('email').hint('user@example.com').static().id().search(),
    type: BaseSchema_1.z.string().min(1).label("group").hint('user, admin, ...').search().generate('user').help("The type refers to a group name. Groups contains privileges (admin true/false) and workspaces.").indexed(),
    password: BaseSchema_1.z.string().min(6).hint('**********').secret().hidden(["sheet", "list", "preview"]).onCreate('cypher').onUpdate('update').onRead('clearPassword').onList('clearPassword').help("Salted hashed password using bcrypt."),
    permissions: BaseSchema_1.z.array(BaseSchema_1.z.string()).optional().label("additional permissions"),
    createdAt: BaseSchema_1.z.string().min(1).generate(function (obj) { return (0, moment_1.default)().toISOString(); }).search().hidden(["edit", "add"]).indexed(),
    lastLogin: BaseSchema_1.z.string().optional().search().hidden(["edit", "add"]).indexed(),
    from: BaseSchema_1.z.string().min(1).search().generate(function (obj) { return 'admin'; }).help("Interface used to create the user. Users can be created from command line or from the admin panel").hidden(["edit", "add"])
});
var UserModel = /** @class */ (function (_super) {
    __extends(UserModel, _super);
    function UserModel(data, session) {
        return _super.call(this, data, exports.UserSchema, session, "User") || this;
    }
    UserModel.load = function (data, session) {
        return this._newInstance(data, session);
    };
    UserModel._newInstance = function (data, session) {
        return new UserModel(data, session);
    };
    return UserModel;
}(ProtoModel_1.ProtoModel));
exports.UserModel = UserModel;
