"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.file = void 0;
var handlebars_1 = __importDefault(require("handlebars"));
var logger_1 = require("../logger");
var logger = (0, logger_1.getLogger)();
var file = function (lib, path, vars) { return __awaiter(void 0, void 0, void 0, function () {
    var apiPath, templatePath, template, templateFunction, result;
    var _a, _b, _c, _d, _e, _f;
    return __generator(this, function (_g) {
        switch (_g.label) {
            case 0:
                logger.info({ template: { path: path, params: vars } }, "Template file executed");
                apiPath = path;
                if (lib.fs.existsSync(apiPath)) {
                    throw "File already exists";
                }
                templatePath = '../../' + ((_b = (_a = vars === null || vars === void 0 ? void 0 : vars.data) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.template);
                if (!((_d = (_c = vars === null || vars === void 0 ? void 0 : vars.data) === null || _c === void 0 ? void 0 : _c.options) === null || _d === void 0 ? void 0 : _d.template) || !lib.fs.existsSync(templatePath)) {
                    throw "There is a problem with your workspace definition. No template file was provided for this template.";
                }
                return [4 /*yield*/, lib.fs.promises.readFile(templatePath)];
            case 1:
                template = (_g.sent()).toString();
                handlebars_1.default.registerHelper('curlyBraces', function (options) {
                    var content = options.fn(this);
                    return "{{" + content + "}}";
                });
                templateFunction = handlebars_1.default.compile(template);
                result = templateFunction(__assign({ name: vars.name }, (_f = (_e = vars.data) === null || _e === void 0 ? void 0 : _e.options) === null || _f === void 0 ? void 0 : _f.variables));
                return [4 /*yield*/, lib.fs.promises.writeFile(apiPath, result)];
            case 2:
                _g.sent();
                logger.info({ template: apiPath }, "New file created with template file");
                return [2 /*return*/];
        }
    });
}); };
exports.file = file;
