var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var FlowBase_exports = {};
__export(FlowBase_exports, {
  FlowConstructor: () => FlowConstructor,
  default: () => FlowBase_default
});
module.exports = __toCommonJS(FlowBase_exports);
var import_reset = require("@tamagui/core/reset.css"), import__ = require("@tamagui/font-inter/css/400.css"), import__2 = require("@tamagui/font-inter/css/700.css"), import_react = __toESM(require("react"), 1), import_reactflow = require("reactflow"), import_Node = require("./lib/Node"), import_diff = require("./lib/diff"), import_nodes = require("./nodes"), import_Menu = __toESM(require("./diagram/Menu"), 1), import_Edge = __toESM(require("./Edge"), 1), import_ActionsBar = __toESM(require("./ActionsBar"), 1), import_custom = __toESM(require("./nodes/custom"), 1), import_Diagram = __toESM(require("./diagram/Diagram"), 1), import_react_topics = require("react-topics"), import_ts_morph = require("ts-morph"), import_FlowsStore = require("./store/FlowsStore"), import_Node2 = require("./lib/Node"), import_FlowsOperations = require("./lib/FlowsOperations"), import_deep_diff = __toESM(require("deep-diff"), 1), import_DynamicCustomComponent = __toESM(require("./DynamicCustomComponent"), 1), import_IdGenerator = require("./lib/IdGenerator"), import_DiagramStore = require("./store/DiagramStore"), import_layouts = __toESM(require("./diagram/layouts"), 1), import_ContextMenu = require("./ContextMenu"), import_jsx_runtime = require("react/jsx-runtime");
const FlowsBase = ({
  dataNotify = () => {
  },
  disableDots = !1,
  bgColor = "transparent",
  onShowCode = null,
  sourceCode,
  onSave,
  onPlay,
  onReload,
  disableStart = !1,
  getFirstNode = (nodes) => nodes.find((n) => n.id && n.id.startsWith("SourceFile")),
  customComponents = [],
  customSnippets = [],
  hideBaseComponents = !1,
  positions,
  autoFitView,
  layout,
  topics,
  flowId,
  display = !0,
  enableCommunicationInterface = void 0,
  children,
  showActionsBar = !1,
  zoomOnDoubleClick = !0,
  onSelectionChange = () => {
  },
  onEdit = () => {
  },
  config = {},
  themeMode = "light",
  theme = {},
  primaryColor = "#F7B500",
  disableMiniMap = !0,
  bridgeNode = !1,
  onViewPortChange = () => {
  },
  defaultViewPort = { x: 100, y: window.innerHeight / 4, zoom: 0.8 },
  path = "Start",
  mode = "js",
  nodePreview = "flow",
  metadata = {},
  defaultSelected = () => {
  },
  nodeMenu = null
}) => {
  const { data, publish } = topics, useFlowsStore2 = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), diagramRef = (0, import_react.useRef)(null), flowRef = (0, import_react.useRef)(null), setError = useFlowsStore2((state) => state.setError), clearError = useFlowsStore2((state) => state.clearError), setDataNotify = useFlowsStore2((state) => state.setDataNotify), initialEdges = useFlowsStore2((state) => state.initialEdges), setInitialEdges = useFlowsStore2((state) => state.setInitialEdges), initialNodes = useFlowsStore2((state) => state.initialNodes), setInitialNodes = useFlowsStore2((state) => state.setInitialNodes), setSaveStatus = useFlowsStore2((state) => state.setSaveStatus), setNodeData = useFlowsStore2((state) => state.setNodeData), setNodesData = useFlowsStore2((state) => state.setNodesData), setMetadata = useFlowsStore2((state) => state.setMetadata), setCurrentPath = useFlowsStore2((state) => state.setCurrentPath), setNodesMetaData = useFlowsStore2((state) => state.setNodesMetaData), clearNodesData = useFlowsStore2((state) => state.clearNodesData), appendCustomComponents = useFlowsStore2((state) => state.appendCustomComponents), appendedCustomComponents = useFlowsStore2((state) => state.customComponents), nodeData = useFlowsStore2((state) => state.nodeData), menuState = useFlowsStore2((state) => state.menuState), _customComponents = [...customComponents, ...config?.masks?.map((m) => (0, import_DynamicCustomComponent.default)(m)) ?? []].filter((x) => x), nodeTypes = (0, import_react.useMemo)(() => import_nodes.NodeTypes, []), edgeTypes = (0, import_react.useMemo)(() => ({ custom: (props) => (0, import_Edge.default)(props, bridgeNode) }), []), extraStateData = { nodePreview, flowsHeight: diagramRef.current?.offsetHeight }, [nodes, setNodes, onNodesChange] = (0, import_DiagramStore.useProtoNodesState)(initialNodes, extraStateData), [edges, setEdges, onEdgesChange] = (0, import_DiagramStore.useProtoEdgesState)(initialEdges, extraStateData), [hasChanges, setHasChanges] = (0, import_react.useState)(!1), [prevReducedNodes, setPrevReducedNodes] = (0, import_react.useState)(""), [prevNodeData, setPrevNodeData] = (0, import_react.useState)((0, import_FlowsOperations.deleteAdditionalKeys)(nodeData)), [menu, setMenu] = (0, import_react.useState)(null), rendered = (0, import_react.useRef)(!1), onConnect = (0, import_react.useCallback)((params) => setEdges((eds) => (0, import_DiagramStore.addProtoEdge)(params, eds)), [setEdges]), reload = async () => {
    clearNodesData();
    const { nodes: nodes2, edges: edges2, nodeDataTable } = await readSourceFile();
    setsAll(nodeDataTable, nodes2, edges2);
  }, prepare = (sourceCode2) => mode == "json" ? "(" + sourceCode2 + ")" : sourceCode2, currentLayout = layout || (mode == "json" ? import_layouts.default.elk : import_layouts.default.code), getEnabledNodesForMode = () => mode == "json" ? ["ObjectLiteralExpression", "ArrayLiteralExpression"] : ["*"], _getFirstNode = mode == "json" ? (nodes2) => nodes2.find((n) => n.id && n.id.startsWith("ObjectLiteralExpression")) : getFirstNode, readSourceFile = async (src = sourceCode, isDisableStart = disableStart) => {
    let source = new import_ts_morph.Project({
      useInMemoryFileSystem: !0,
      manipulationSettings: { indentationText: import_ts_morph.IndentationText.Tab },
      compilerOptions: {
        target: import_ts_morph.ScriptTarget.Latest,
        scriptKind: import_ts_morph.ScriptKind.TSX,
        languageVariant: import_ts_morph.LanguageVariant.JSX
      }
    }).createSourceFile("_temp1.tsx", prepare(src), { overwrite: !0 });
    if (mode == "json") {
      const obj = source.getStatements()[0]?.getExpression()?.getExpression();
      obj && (source = obj);
    }
    const Visitor = (node, visitCb, exitCb, nodeList) => {
      if (!visitCb(node)) return exitCb(node, nodeList, []);
      let childNodes = [];
      return node.forEachChild((child) => {
        childNodes = childNodes.concat(Visitor(child, visitCb, exitCb, []));
      }), exitCb(node, nodeList, childNodes);
    }, _data = {};
    let edges2 = [];
    const nodeDataTable = {};
    let firstElement, nodes2 = Visitor(source, (node) => {
      const flowNode = nodeTypes[node.getKindName()];
      if (flowNode) {
        const flowNodeType = flowNode.type ?? flowNode;
        if ((!flowNodeType.isShadow || !flowNodeType.isShadow(node, _data, mode, edges2)) && !firstElement && (firstElement = (0, import_Node.getId)(node)), flowNodeType.skipTraversal) return !1;
      }
      return !0;
    }, (node, nodeList, childNodeList) => {
      const flowNode = nodeTypes[node.getKindName()];
      if (node.getParent()?.getKindName() == "CatchClause" && node.getKindName() == "VariableDeclaration") return;
      var deletable = !0;
      if (flowNode) {
        const flowNodeType2 = flowNode.type ?? flowNode;
        if (flowNodeType2.getData) {
          nodeDataTable[(0, import_Node.getId)(node)] = {};
          var nodeData2 = flowNodeType2.getData(node, _data, nodeDataTable, edges2, mode);
          nodeData2 = { ...nodeDataTable[(0, import_Node.getId)(node)], ...nodeData2, _astNode: node }, nodeDataTable[(0, import_Node.getId)(node)] = nodeData2, _data[(0, import_Node.getId)(node)] = nodeData2;
          const customComponent2 = (0, import_custom.default)({ type: node.getKindName() }, nodeDataTable[(0, import_Node.getId)(node)] ?? {}, _customComponents);
          setNodeData((0, import_Node.getId)(node), nodeData2), customComponent2?.nonDeletable && (deletable = !1);
        }
        if ((!flowNodeType2.isShadow || !flowNodeType2.isShadow(node, _data, mode, edges2)) && (!flowNodeType2.checkCreate || flowNodeType2.checkCreate(node, _data)) && (node.getKindName() != "SourceFile" || !isDisableStart)) {
          let newNodes = (0, import_Node.createNode)([0, 0], node.getKindName(), (0, import_Node.getId)(node), null, node.getKindName() != "SourceFile" && deletable, edges2, nodeDataTable[(0, import_Node.getId)(node)]);
          nodeList = nodeList.concat(newNodes), _data[(0, import_Node.getId)(node)] = { type: "node", value: newNodes[0] };
        }
      }
      _data[(0, import_Node.getId)(node)] || (node.getChildren().length == 0 ? _data[(0, import_Node.getId)(node)] = { type: "data", value: node.getText(), _astNode: node } : _data[(0, import_Node.getId)(node)] = node.forEachDescendant((node2) => _data[(0, import_Node.getId)(node2)]));
      const customComponent = (0, import_custom.default)(_data[(0, import_Node.getId)(node)]?.value, nodeDataTable[(0, import_Node.getId)(node)] ?? {}, _customComponents), fakeSetNodeData = (id, data3) => {
        nodeDataTable[id] = data3;
      };
      customComponent && customComponent.filterChildren && fakeSetNodeData((0, import_Node.getId)(node), { ...nodeDataTable[(0, import_Node.getId)(node)], _initialNodes: childNodeList, _initialEdges: JSON.parse(JSON.stringify(edges2)) });
      const flowNodeType = flowNode && flowNode.type ? flowNode.type : flowNode, result = [
        ...nodeList,
        ...customComponent && customComponent.filterChildren ? customComponent.filterChildren(node, childNodeList, edges2, nodeDataTable, fakeSetNodeData) : childNodeList
      ];
      return flowNodeType && flowNodeType.filterChildren ? flowNodeType.filterChildren(node, result, edges2, nodeDataTable, fakeSetNodeData) : result;
    }, []).filter((n) => n);
    return config && config.layers && config.layers.length && (nodes2 = [...nodes2, ...config.layers.map((l) => {
      const layerId = "Layer_" + (0, import_IdGenerator.generateId)();
      return nodeDataTable[layerId] = l, (0, import_Node.createNode)(l.position ?? [0, 0], "Layer", layerId, {}, !1, [], {})[0];
    })]), {
      nodes: nodes2,
      edges: edges2,
      nodeDataTable
    };
  }, getTree = (nodeData2) => nodes.reduce((total, node) => {
    const customComponent = (0, import_custom.default)(node, total.nodeData[node.id] ?? {}, _customComponents);
    if (customComponent && customComponent.restoreChildren) {
      const restored = customComponent.restoreChildren(node, total.nodes, total.nodeData[node.id]._initialNodes, total.edges, initialEdges, total.nodeData);
      return restored.nodeData || (restored.nodeData = total.nodeData), restored;
    }
    return total;
  }, { nodes, edges, nodeData: nodeData2 }), onSaveNodes = async (preview) => {
    const tree = getTree(Object.assign({}, nodeData));
    var content;
    clearError();
    try {
      content = (0, import_Node.saveNodes)(tree.nodes, tree.edges, tree.nodeData, _getFirstNode, mode), console.log("CONTENT: ", content), setInitialEdges(tree.edges), setInitialNodes(tree.nodes);
      const positions2 = nodes.map((node) => ({ id: node.id, position: node.position }));
      !preview && onSave && nodes?.length && onSave(content, positions2, { nodesData: nodeData, nodes });
    } catch (e) {
      console.log("ERROR SAVING CODE: ", e.codeFrame, e);
      const parts = e.codeFrame.split(`
`).find((l) => l.startsWith("> ")).split("|");
      parts.shift();
      const linePos = e.loc.start.column, line = parts.join("|").substr(1, linePos), markerPosition = line.lastIndexOf("/* JSFLOWID("), id = line.substring(markerPosition + 12).split(")")[0];
      setSaveStatus("error"), setError(id);
    }
    return content;
  }, onPlayNodes = async () => {
    try {
      const content = await onSaveNodes();
      onPlay && onPlay(content);
    } catch (e) {
      console.error(e);
    }
  }, removeSizes = (arr) => arr.map((item) => {
    const { draggable, height, width, position, selected, positionAbsolute, dragging, data: data2, ...rest } = item, { layouted, ...cleanedData } = data2 || { layouted: 1 };
    return { ...rest, data: cleanedData };
  }), onReloadNodes = async () => {
    await setEdges([]), await setNodes([]), onReload ? onReload() : reload();
  }, actionPublisher = (action, payload) => {
    if (enableCommunicationInterface) {
      var parentId, nodeId = payload.nodeId, param = payload.param, topicParams, value = payload.value;
      try {
        value = JSON.parse(value);
      } catch {
      }
      switch (action) {
        case "delete-node":
          const deletedNodes = payload, deletedNodesIds = deletedNodes.map((n) => n.id), edgeToDelete = edges.find((e) => deletedNodesIds.includes(e.source));
          parentId = edgeToDelete?.target;
          const nodeType = edgeToDelete ? nodes.find((n) => n.id == edgeToDelete.source)?.type : deletedNodes.find((n) => n.id == deletedNodesIds[0])?.type;
          if (topicParams = {
            action: "delete-node",
            nodesToDelete: deletedNodesIds,
            deletedNodeType: nodeType
            // TODO: only returns type of the first node
          }, nodeType == "JsxElement") {
            let childPosToDelete = edgeToDelete ? Number(edgeToDelete.targetHandle.split("child-")[1]) : null;
            if (nodeData[parentId]) {
              const { data: newParentData } = (0, import_FlowsOperations.removeDataChildAndReorder)(nodeData[parentId], childPosToDelete);
              setNodesData({ ...nodeData, [parentId]: newParentData });
            }
          }
          publish("flow/editor", topicParams);
          break;
        case "delete-data":
          topicParams = {
            action: "delete-data",
            nodeId,
            param
          }, publish("flow/editor", topicParams);
          break;
        case "add-node":
          const newEdge = payload.newEdge, initialData = payload.initialData, nodeName = initialData?.name, type = payload.node?.type;
          nodeId = payload.node.id, parentId = newEdge.target, param = newEdge.targetHandle.split(parentId + "-")[1];
          let newNodesData = {
            ...nodeData,
            [nodeId]: { ...initialData }
          };
          topicParams = {
            ...topicParams,
            action: "add-node",
            nodeId,
            type,
            nodeName,
            parent: parentId
          };
          const dumpCode = (0, import_FlowsOperations.dumpContent)(nodes, edges.concat(newEdge), newNodesData, nodeId, type);
          if (type == "JsxElement") {
            const childPos = param?.startsWith("child") ? Number(param.split("child-")[1]) : void 0;
            topicParams = {
              ...topicParams,
              childrenPos: childPos - 1
            }, newNodesData = { ...newNodesData, [parentId]: { ...newNodesData[parentId], ["child-" + childPos]: dumpCode } }, setNodesData(newNodesData);
          } else {
            let port = newEdge.targetHandle.split(parentId)[1], portType = port.slice(0, 1), portName = port.slice(1);
            const parentNodeData = newNodesData[parentId];
            let key, value2;
            if (portType == import_Node.PORT_TYPES.flow) {
              const fallbackData = parentNodeData._fallBack?.find((fb) => fb.fallbackPort == portName && fb.portType == portType), prop = fallbackData?.preText + dumpCode + fallbackData?.postText;
              var index = prop.indexOf("=");
              if (index === -1) return;
              key = prop.substring(0, index).trim(), value2 = prop.substring(index + 1).trim();
            } else portType == import_Node.PORT_TYPES.data && (key = parentNodeData[portName]?.key, value2 = dumpCode);
            topicParams = {
              ...topicParams,
              data: {
                isAncestorJsxElement: !0,
                key,
                value: value2
              }
            };
          }
          publish("flow/editor", topicParams);
          break;
        case "add-data":
          var isProp = !!payload.isProp;
          topicParams = {
            action: "add-data",
            nodeId,
            param,
            value,
            isProp
          }, publish("flow/editor", topicParams);
          break;
        case "edit-data":
          topicParams = {
            action: "edit-data",
            nodeId,
            param,
            value,
            kind: payload.kind,
            deleteKey: payload.deleteKey
          }, publish("flow/editor", topicParams);
          break;
        default:
          console.error(`Communication sender error. Invalid action ${action}`);
          break;
      }
    }
  }, getPropName = (key) => {
    let propName;
    if (key)
      return key.startsWith("prop-") ? propName = key.split("prop-")[1] : key.startsWith("child-") ? propName = "children" : propName = key, propName;
  }, isConnected = (targetHandleId) => edges.find((e) => e.targetHandle == targetHandleId), onNodeDataChange = () => {
    if (!enableCommunicationInterface) return;
    const deletedAdditionalKeysNodeData = (0, import_FlowsOperations.deleteAdditionalKeys)(nodeData);
    if (!Object.keys(prevNodeData).length) return;
    const diffs = import_deep_diff.default.diff(prevNodeData, deletedAdditionalKeysNodeData);
    if (!(!diffs || diffs.length > 1)) {
      if (diffs.find((d) => d.kind == "E")) {
        const diff = diffs.find((d) => d.kind == "E");
        let nodeId = diff.path[0];
        if (!prevNodeData[nodeId]) return;
        const targetHandle = nodeId + import_Node.PORT_TYPES.data + diff.path[1];
        if (isConnected(targetHandle)) return;
        const type = nodes.find((n) => n.id == nodeId)?.type;
        let payload = { nodeId }, value, param, kind;
        if (type == "JsxElement" || type == "JsxSelfClosingElement") {
          let isProp;
          if (diff.path[2] == "key") {
            param = diff.rhs;
            let oldKey = diff.lhs;
            const propName = diff.path[1];
            value = nodeData[nodeId][propName]?.value, isProp = !0, payload = { ...payload, deleteKey: oldKey };
          } else {
            if (param = getPropName(diff.path[1]), value = diff.rhs, value == null || !param || typeof value == "object" || diff.path[2] == "kind") return;
            isProp = !param.includes("child"), isProp && (param = nodeData[nodeId]["prop-" + param]?.key ?? param, kind = nodeData[nodeId]["prop-" + param]?.kind);
          }
          payload = {
            ...payload,
            param,
            value,
            isProp,
            kind
          };
        } else {
          const jsxElementPort = (0, import_FlowsOperations.findJsxElementByNodeId)(nodeId, edges);
          if (jsxElementPort) {
            param = jsxElementPort.split("-")[2], nodeId = jsxElementPort.split("-")[0];
            const nodeType = jsxElementPort.split("_")[0], value2 = (0, import_FlowsOperations.findJsxElementDumpedPropValue)(nodes, edges, nodeData, nodeId, nodeType, param);
            payload = {
              ...payload,
              nodeId,
              param,
              value: value2,
              isProp: !0
            };
          }
        }
        actionPublisher("edit-data", payload);
      } else if (diffs.find((d) => d.kind == "N")) {
        const diff = diffs.find((d) => d.kind == "N");
        let nodeId = diff.path[0];
        if (!prevNodeData[nodeId]) return;
        const nodeType = nodes.find((n) => n.id == nodeId)?.type;
        let param = diff.path[1], payload;
        if (nodeType == "JsxElement" || nodeType == "JsxSelfClosingElement") {
          let val = diff.rhs;
          typeof val == "object" && (param = param.split("-")[0] + "-" + val.key, val = val.value), param = getPropName(param);
          const targetHandle = nodeId + import_Node.PORT_TYPES.data + diff.path[1];
          if (isConnected(targetHandle) || val == null || !param) return;
          const isProp = !param.includes("child");
          payload = { nodeId, param, value: val, isProp };
        } else {
          const ancestorJsxElementPort = (0, import_FlowsOperations.findJsxElementByNodeId)(nodeId, edges);
          var index = ancestorJsxElementPort?.indexOf("-");
          if (index === -1 || !ancestorJsxElementPort) return;
          const ancestorParam = ancestorJsxElementPort.slice(index + 1);
          let ancestorJsxId = ancestorJsxElementPort.split("-")[0];
          const ancestorNodeType = ancestorJsxElementPort.split("_")[0], ancestorJsxNodeData = nodeData[ancestorJsxId];
          if (!ancestorJsxNodeData) return;
          const modifiedPropName = ancestorJsxNodeData[ancestorParam]?.key, value = (0, import_FlowsOperations.findJsxElementDumpedPropValue)(nodes, edges, nodeData, ancestorJsxId, ancestorNodeType, modifiedPropName);
          payload = {
            nodeId: ancestorJsxId,
            param: modifiedPropName,
            value,
            isProp: !0
          };
        }
        actionPublisher("add-data", payload);
      } else if (diffs.find((d) => d.kind == "D")) {
        const diff = diffs.find((d) => d.kind == "D"), nodeId = diff.path[0], param = diff.lhs.key;
        actionPublisher("delete-data", { nodeId, param });
      }
    }
  }, dumpSelection = (selectedNodes) => {
    const firstNodeType = selectedNodes[0]?.type, prittifyError = ["ObjectLiteralExpression", "ArrowFunction", "CallExpression"].includes(firstNodeType) || selectedNodes.length <= 1;
    if (!selectedNodes || !selectedNodes.length || prittifyError)
      return sourceCode;
    const startNode = selectedNodes[0];
    if (!startNode) return sourceCode;
    let start = import_nodes.NodeTypes[startNode.type];
    start.type && (start = start.type);
    const code = start.dump(startNode, nodes, edges, nodeData);
    return (0, import_Node2.validateCode)(code, mode);
  }, onAddSnippet = async (snippet, edg, nodeId = void 0) => {
    const { nodes: smNodes, nodeDataTable, edges: smEdges } = await readSourceFile(snippet?.code, !0), index = smEdges.findIndex((v) => v.target.startsWith("SourceFile"));
    var newEdges = [...edges], newNodes = [...nodes], newNodesData = { ...nodeData }, nodesIdsToDelete = [];
    if (nodeId) {
      const deleteRecursiveEdges = (currentNodeId) => {
        const edgesToDelete = newEdges.filter((e) => e?.target == currentNodeId);
        nodesIdsToDelete.push(currentNodeId), edgesToDelete?.length && (edgesToDelete.forEach((e) => {
          deleteRecursiveEdges(e.source);
        }), newEdges = [...newEdges].filter((e) => e?.target != currentNodeId));
      };
      deleteRecursiveEdges(nodeId), nodesIdsToDelete.forEach((nodeId2) => {
        delete newNodesData[nodeId2];
      }), newNodes = newNodes.filter((n) => !nodesIdsToDelete.includes(n.id));
    }
    smEdges[index] = {
      ...smEdges[index],
      target: edg.target,
      targetHandle: edg.targetHandle
    }, setsAll({ ...nodeDataTable, ...nodeData }, [...smNodes, ...newNodes], [...smEdges, ...newEdges]);
  }, setsAll = (data2, nds, edgs) => {
    setNodesData(data2), setPrevNodeData((0, import_FlowsOperations.deleteAdditionalKeys)(data2)), setNodes(nds), setEdges(edgs), setInitialEdges(edgs), setInitialNodes(nds);
  }, onGraphChanged = async () => {
    try {
      const content = await onSaveNodes(!0);
      content !== void 0 ? onEdit(content, { nodesData: nodeData, nodes }) : console.error("There was an error in the code, not emitting");
    } catch {
    }
  }, handleRelayout = async () => {
    const reduceNodes = (nds) => nds.reduce((total, n) => total += n.id + " " + n.height + ",", "");
    let currentReducedNodes = reduceNodes(nodes);
    if (prevReducedNodes != currentReducedNodes)
      if (nodes && nodes.length && nodes.filter((n) => n.width && n.height).length == nodes.length) {
        const { layoutedNodes } = await (0, import_ActionsBar.reLayout)(currentLayout, nodes, edges, setNodes, setEdges, _getFirstNode, setNodesMetaData, nodeData);
        setPrevReducedNodes(reduceNodes(layoutedNodes));
      } else
        setPrevReducedNodes(currentReducedNodes);
  }, getDumpedFragment = (nodeId) => {
    if (!nodeId) return null;
    const selectedNode = nodes.find((n) => n.id === nodeId), firstNodeType = selectedNode?.type, startType = import_nodes.NodeTypes[firstNodeType]?.type;
    if (!startType) return null;
    const code = startType.dump(selectedNode, nodes, edges, nodeData);
    return (0, import_Node2.validateCode)(code, mode);
  }, updateFragment = (codeFragment, nodeId) => {
    const edge = edges.find((e) => e.source == nodeId);
    onAddSnippet({ code: codeFragment }, edge, nodeId);
  }, onNodeContextMenu = (0, import_react.useCallback)(
    (event, node) => {
      event.preventDefault();
      const pane = diagramRef.current?.getBoundingClientRect(), absoluteCY = event.clientY - pane.top, absoluteCX = event.clientX - pane.left, hasSpaceOnTop = absoluteCY > 450, hasSpaceFromBottom = absoluteCY - 450 > 0, hasSpaceOnLeft = absoluteCX > 360, hasSpaceFromRight = absoluteCY - 360 > 0;
      setMenu({
        id: node.id,
        top: absoluteCY < pane.height - 450 ? absoluteCY : hasSpaceOnTop && !hasSpaceFromBottom && 20,
        left: absoluteCX < pane.width - 360 ? absoluteCX : hasSpaceOnLeft && !hasSpaceFromRight && 20,
        right: absoluteCX >= pane.width - 360 && hasSpaceFromRight && pane.width - absoluteCX,
        bottom: absoluteCY >= pane.height - 450 && hasSpaceFromBottom && pane.height - absoluteCY
      });
    },
    [setMenu]
  ), onPaneClick = (0, import_react.useCallback)(() => setMenu(null), [setMenu]);
  return (0, import_react.useEffect)(() => {
    const edgesDiffs = (0, import_diff.getDiffs)(removeSizes(initialEdges), removeSizes(edges)), nodesDiffs = (0, import_diff.getDiffs)(removeSizes(initialNodes), removeSizes(nodes));
    nodesDiffs && nodesDiffs.length || edgesDiffs && edgesDiffs.length ? (showActionsBar || onGraphChanged(), setHasChanges(!0)) : setHasChanges(!1), setSaveStatus(null), handleRelayout();
  }, [nodes, edges]), (0, import_react.useEffect)(() => {
    setDataNotify(dataNotify);
  }, [dataNotify]), (0, import_react.useEffect)(() => {
    data[flowId + "/play"]?.ts && onPlayNodes();
  }, [data[flowId + "/play"]]), (0, import_react.useEffect)(() => {
    setCurrentPath(path);
  }, [path]), enableCommunicationInterface && enableCommunicationInterface({
    edges,
    nodeData,
    nodes,
    setEdges,
    createNode: import_Node.createNode,
    setNodeData,
    setNodes,
    setNodesData,
    deleteNodes: import_FlowsOperations.deleteNodes,
    onSaveNodes,
    _customComponents,
    flowId,
    data
  }), (0, import_react.useEffect)(() => {
    _customComponents.length != appendedCustomComponents.length && appendCustomComponents(_customComponents), setMetadata(metadata);
  }, [_customComponents.length]), (0, import_react.useEffect)(() => {
    sourceCode && reload();
  }, [sourceCode]), (0, import_react.useEffect)(() => {
    const diffableNodeData = (0, import_FlowsOperations.deleteAdditionalKeys)(nodeData);
    (0, import_diff.getDiffs)(prevNodeData, diffableNodeData)?.length && (setHasChanges(!0), onNodeDataChange(), setPrevNodeData(diffableNodeData), nodes.length && !showActionsBar && onGraphChanged());
  }, [nodeData]), typeof window !== void 0 && (window.reLayout = () => {
    (0, import_ActionsBar.reLayout)(currentLayout, nodes, edges, setNodes, setEdges, _getFirstNode, setNodesMetaData, nodeData);
  }), /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { ref: diagramRef, style: { height: "100%", width: "100%" }, children: display ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_Diagram.default,
    {
      autoFitView,
      primaryColor,
      defaultSelected,
      onViewPortChange,
      defaultViewPort,
      themeMode,
      onSelectionChange: (nodes2) => onSelectionChange(dumpSelection(nodes2), nodes2),
      nodeTypes,
      nodes,
      edges,
      zoomOnDoubleClick,
      onNodesChange,
      onEdgesChange,
      onNodesDelete: (nodesToDelete) => actionPublisher("delete-node", nodesToDelete),
      onConnect,
      edgeTypes,
      onInit: (instance) => {
        flowRef.current = instance;
      },
      style: { backgroundColor: bgColor },
      nodePreview,
      onNodeInitializationStatusChange: (status) => {
        status && rendered.current && (0, import_ActionsBar.reLayout)(currentLayout, nodes, edges, setNodes, setEdges, _getFirstNode, setNodesMetaData, nodeData);
      },
      componentsMenu: menuState != "closed" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Menu.default,
        {
          enabledNodes: getEnabledNodesForMode(),
          onEditDiagram: async (nodes2, edges2, focusElement) => {
            setNodes(nodes2), setEdges(edges2);
          },
          edges,
          diagramNodes: nodes,
          setNodes,
          setEdges,
          setNodeData,
          nodeData,
          onAddSnippet,
          style: {
            position: "absolute",
            top: "0px",
            left: "0px"
          },
          config: config?.menu,
          hideBaseComponents,
          customComponents: _customComponents,
          customSnippets,
          onAddNode: (node, newEdge, initialData) => actionPublisher("add-node", { node, newEdge, initialData })
        }
      ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {}),
      disableDots,
      disableMiniMap,
      theme,
      onNodeContextMenu,
      onPaneClick,
      children: [
        children,
        showActionsBar ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_reactflow.Panel, { position: "top-center", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_ActionsBar.default,
          {
            onSave: onSaveNodes,
            onReload: onReload ? onReloadNodes : null,
            onShowCode: onShowCode || null,
            hasChanges
          }
        ) }) : null,
        menu && nodeMenu && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ContextMenu.ContextMenu, { menuContent: nodeMenu, onClick: onPaneClick, ...menu, children: import_react.default.createElement(nodeMenu, {
          nodeId: menu.id,
          dumpFragment: () => getDumpedFragment(menu?.id),
          closeMenu: () => setMenu(!1),
          updateFragment: (code) => updateFragment(code, menu.id)
        }) })
      ]
    }
  ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {}) });
}, FlowsWrapper = (props) => {
  const store = (0, import_react.useMemo)(import_FlowsStore.useFlowsStore, []);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_FlowsStore.FlowStoreContext.Provider, { value: store, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(FlowsBase, { ...props }) });
};
var FlowBase_default = (props) => {
  const FlowsWithTopics = (0, import_react_topics.withTopics)(FlowsWrapper, { topics: [props.flowId + "/play", props.flowId + "/ui", "savenodes"] });
  return props.path && (props.path.endsWith(".json") ? props.mode = "json" : (props.path.endsWith("yml") || props.path.endsWith("yaml")) && (props.mode = "yaml")), /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_topics.TopicsProvider, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(FlowsWithTopics, { ...props }) });
};
const FlowConstructor = (flowId) => (0, import_react_topics.withTopics)(FlowsWrapper, { topics: [flowId + "/play", flowId + "/ui", "savenodes"] });
//# sourceMappingURL=FlowBase.js.map
