var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Node_exports = {};
__export(Node_exports, {
  NodePort: () => NodePort,
  default: () => Node_default,
  isHandleConnected: () => isHandleConnected,
  isNodeConnected: () => isNodeConnected
});
module.exports = __toCommonJS(Node_exports);
var import_react = __toESM(require("react"), 1), import_NodeText = __toESM(require("./NodeText"), 1), import_reactflow = require("reactflow"), import_chroma_js = __toESM(require("chroma-js"), 1), import_FlowsStore = require("../store/FlowsStore"), import_toggles = require("../toggles"), import_DiagramStore = require("../store/DiagramStore"), import_Theme = __toESM(require("./Theme"), 1), import_nodes = require("./../nodes"), import_memory = require("../lib/memory"), import_shadow = require("../lib/shadow"), import_usehooks_ts = require("usehooks-ts"), import_jsx_runtime = require("react/jsx-runtime");
const Node = ({ adaptiveTitleSize = !0, mode = "column", draggable = !0, icon = null, container = !1, title = "", children, isPreview = !1, id, color, node, headerContent = null, style = {}, contentStyle = {} }) => {
  const errorData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.errorData), flexRef = (0, import_react.useRef)(), boxRef = (0, import_react.useRef)(), isNodePreviewMode = node?.data?.preview == "node", nodeStyle = contentStyle, isError = id && id == errorData.id, isFloating = !id || id.indexOf("_") == -1, colorError = (0, import_Theme.default)("colorError");
  color = color ?? (0, import_Theme.useNodeColor)(node.type), color = isError ? colorError : !isPreview && isFloating ? import_chroma_js.default.scale([color, "white"])(0.5).hex() : color;
  const hColor = import_chroma_js.default.scale([color, "black"])(0.6).hex(), tColor = (0, import_Theme.default)("titleColor"), themeBorderColor = (0, import_Theme.default)("borderColor"), borderColor = isError ? colorError : themeBorderColor, borderWidth = (0, import_Theme.default)("borderWidth"), themeBackgroundColor = (0, import_Theme.default)("nodeBackgroundColor"), isHover = (0, import_usehooks_ts.useHover)(flexRef), titleSize = (0, import_Theme.default)("nodeFontSize") * 1.2, selectedColor = (0, import_Theme.default)("selectedColor"), fontSize = (0, import_Theme.default)("nodeFontSize"), innerRadius = "12px ", innerBorderRadius = mode == "column" ? innerRadius + innerRadius + " 0px 0px" : innerRadius + "0px 0px " + innerRadius;
  if (node && node.data && node.data.flowsHeight && isNodePreviewMode) {
    const maxHeight = node.data.flowsHeight - 20;
    nodeStyle.height = maxHeight + "px", nodeStyle.maxHeight = maxHeight + "px", nodeStyle.overflow = "scroll", nodeStyle.overflowX = "hidden";
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      id,
      ref: flexRef,
      style: {
        display: "flex",
        minHeight: isPreview ? "30px" : "80px",
        flexDirection: mode,
        borderRadius: 5,
        textAlign: "center",
        fontSize,
        boxShadow: isNodePreviewMode || container || !isPreview && node?.selected ? "none" : (0, import_shadow.generateBoxShadow)(isHover ? 10 : 3),
        outline: !isPreview && node?.selected ? `1px solid ${selectedColor}` : "none",
        outlineOffset: "0px",
        cursor: isNodePreviewMode ? "default" : void 0,
        ...style
      },
      className: draggable ? "" : "nodrag",
      children: [
        (title || headerContent) && !isNodePreviewMode ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
          "div",
          {
            ref: boxRef,
            style: {
              display: "flex",
              alignItems: "center",
              backgroundColor: color,
              borderRadius: isPreview ? "6px" : "5px 5px 0 0",
              borderBottom: mode === "column" && !isPreview ? `${borderWidth} solid ${borderColor}` : "0px",
              height: isPreview ? "30px" : "24px",
              padding: "0 12px",
              gap: "6px",
              position: "relative"
            },
            children: [
              icon && import_toggles.flowDirection === "LEFT" && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { style: { display: "flex" }, children: [
                typeof icon != "string" && import_react.default.createElement(icon, {
                  size: titleSize,
                  color: hColor
                }),
                typeof icon == "string" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("img", { src: "/public/icons/" + icon + ".svg", style: { opacity: 0.7, width: titleSize, height: titleSize, color: hColor }, alt: "icon" })
              ] }),
              title && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                import_NodeText.default,
                {
                  style: {
                    fontSize: titleSize - 1,
                    color: tColor,
                    flex: 1,
                    textAlign: "left",
                    fontFamily: "Jost-Medium",
                    whiteSpace: "nowrap",
                    overflow: "hidden",
                    textOverflow: "ellipsis",
                    lineHeight: "1",
                    paddingTop: "1px"
                  },
                  children: title
                }
              ),
              icon && import_toggles.flowDirection === "RIGHT" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: { display: "flex" }, children: import_react.default.createElement(icon, {
                size: titleSize,
                color: hColor
              }) }),
              headerContent
            ]
          }
        ) : null,
        !isPreview && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: isNodePreviewMode ? "nowheel" : "",
            style: {
              borderRadius: "0 0 5px 5px",
              backgroundColor: container ? "transparent" : themeBackgroundColor,
              flex: 1,
              paddingTop: "0.5ch",
              paddingBottom: "0.5ch",
              ...nodeStyle
            },
            children
          }
        )
      ]
    }
  );
}, NodePort = ({ id, type, style, label, sublabel, isConnected = !1, nodeId, position = import_reactflow.Position.Right, allowedTypes }) => {
  const textRef = (0, import_react.useRef)(), handleRef = (0, import_react.useRef)(), useFlowsStore = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), setMenu = useFlowsStore((state) => state.setMenu), instanceId = useFlowsStore((state) => state.flowInstance), labelWidth = 160, ml = position == import_reactflow.Position.Right ? `-${labelWidth}px` : "25px", edges = (0, import_DiagramStore.useProtoEdges)(), connected = isHandleConnected(edges, id), portSize = (0, import_Theme.default)("portSize"), plusColor = (0, import_Theme.default)("plusColor"), borderColor = (0, import_Theme.default)("nodeBorderColor"), borderWidth = (0, import_Theme.default)("nodeBorderWidth"), blockPortColor = (0, import_Theme.default)("blockPort"), flowPortColor = (0, import_Theme.default)("flowPort"), dataPorColor = (0, import_Theme.default)("dataPort"), isNodePreviewMode = edges[0]?.data && edges[0]?.data.preview == "node", onOpenMenu = () => {
    setMenu("open", [handleRef?.current.getBoundingClientRect().right + 200, handleRef?.current.getBoundingClientRect().top - 30], {
      targetHandle: id,
      target: nodeId
    });
  };
  let backgroundColor = allowedTypes ? allowedTypes.includes("block") ? blockPortColor : flowPortColor : null;
  allowedTypes.length == 1 && allowedTypes.includes("data") && (backgroundColor = dataPorColor), import_react.default.useEffect(() => {
    (0, import_memory.write)(instanceId, id, allowedTypes);
  }, [allowedTypes]);
  const marginRight = Math.floor(portSize / 3.5 * -1);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_reactflow.Handle,
    {
      ref: handleRef,
      tabIndex: connected ? -1 : 0,
      title: import_toggles.DEVMODE ? id : void 0,
      onClick: () => onOpenMenu(),
      onKeyDown: (e) => e.code == "Enter" ? onOpenMenu() : null,
      type: "target",
      position,
      style: {
        backgroundColor,
        display: isNodePreviewMode ? "none" : "flex",
        flexDirection: "row",
        alignItems: "center",
        border: borderWidth + " solid " + borderColor,
        width: portSize + "px",
        height: portSize + "px",
        marginLeft: position === import_reactflow.Position.Right ? "-4px" : void 0,
        marginRight: position === import_reactflow.Position.Left ? "-4px" : void 0,
        cursor: "pointer",
        ...style
      },
      id,
      isConnectable: !connected,
      isValidConnection: (c) => {
        const sourceId = c.source.split("_")[0], flowNode = import_nodes.NodeTypes[sourceId];
        if (flowNode) {
          const flowNodeType = flowNode.type ?? flowNode, dataOutput = flowNodeType && flowNodeType.dataOutput ? flowNodeType.dataOutput : "data";
          if (allowedTypes.indexOf(dataOutput) == -1) return !1;
        }
        return !isHandleConnected(edges, c.sourceHandle);
      },
      children: label || sublabel ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { style: { display: "flex", width: `${labelWidth}px`, marginLeft: ml, zIndex: -1, justifyContent: "flex-end" }, children: [
        sublabel && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_NodeText.default, { style: { opacity: 0.7, textAlign: position == import_reactflow.Position.Right ? "right" : "left" }, children: sublabel }),
        label && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_NodeText.default, { ref: textRef, style: { marginRight: "5px", textAlign: position == import_reactflow.Position.Right ? "right" : "left" }, children: label })
      ] }) : null
    }
  ) });
}, isHandleConnected = (edges, handleId) => edges.find((e) => e.targetHandle == handleId || e.sourceHandle == handleId), isNodeConnected = (edges, nodeId) => edges.find((e) => e.target == nodeId || e.source == nodeId);
var Node_default = (0, import_react.memo)(Node);
//# sourceMappingURL=Node.js.map
