var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Theme_exports = {};
__export(Theme_exports, {
  default: () => Theme_default,
  generateColorbyIndex: () => generateColorbyIndex,
  useColorFromPalette: () => useColorFromPalette,
  useNodeColor: () => useNodeColor,
  usePrimaryColor: () => usePrimaryColor
});
module.exports = __toCommonJS(Theme_exports);
var import_react = require("react"), import_FlowsStore = require("../store/FlowsStore"), import_nodes = __toESM(require("../nodes"), 1), import_color_convert = __toESM(require("color-convert"), 1), import_colord = require("colord");
const commonVars = {
  nodeBorderWidth: "1px",
  nodeFontSize: 12,
  nodeEdgeWidth: 3,
  nodeEdgeStyle: "7 5"
};
commonVars.portSize = 10;
commonVars.borderWidth = "1px";
commonVars.borderWidthSelected = 0;
commonVars.borderRadiusSelected = 6;
const outlineColorDark = "#888", Theme = {
  light: {
    ...commonVars,
    nodePalette: {
      gamut: {
        hue: 20,
        saturation: 30,
        value: 90
      },
      custom: {}
    },
    plusColor: "#999",
    edgeColor: "#888",
    nodeBackgroundColor: "#fdfdfd",
    inputBackgroundColor: "white",
    inputBorder: "1px solid #ccc",
    textColor: "#666",
    selectedColor: "#2680EB",
    disableTextColor: "#ccc",
    interactiveColor: "#4fc2f7",
    interactiveHoverColor: "rgba(79, 194, 247, 0.1)",
    borderColor: "#888",
    colorError: "#EF4444",
    handleBorderColor: "white",
    flowOutputColor: "white",
    dataOutputColor: "#AAA",
    highlightInputBackgroundColor: "#F1F1F1",
    blockPort: "#AAA",
    flowPort: "#fefefe",
    dataPort: "#fefefe",
    nodeBorderColor: "#aaa",
    titleColor: "#333",
    containerColor: "#00000005",
    separatorColor: "#D4D4D4",
    borderColorSelected: "#222",
    boxShadowSelected: "",
    //generateBoxShadow(12)
    menuBackground: "#FFFFF60"
  },
  dark: {
    ...commonVars,
    nodePalette: {
      gamut: {
        hue: 20,
        saturation: 60,
        value: 90
      },
      custom: {}
    },
    plusColor: "white",
    handleBorderColor: "black",
    edgeColor: outlineColorDark,
    nodeBackgroundColor: "#303030",
    //bg of nodes
    inputBackgroundColor: "#404040",
    inputBorder: "0",
    textColor: "#e5e5e5",
    selectedColor: "#2680EB",
    disableTextColor: "grey",
    interactiveColor: "#4772b3",
    interactiveHoverColor: "#252525",
    borderColor: outlineColorDark,
    colorError: "#EF4444",
    flowOutputColor: "#CCC",
    dataOutputColor: "#666",
    highlightInputBackgroundColor: "#222222",
    blockPort: "#666",
    flowPort: "#CCC",
    dataPort: "#CCC",
    nodeBorderColor: outlineColorDark,
    titleColor: "#000000EE",
    containerColor: "#FFFFFF05",
    separatorColor: "#424242",
    borderColorSelected: "white",
    boxShadowSelected: "",
    //generateBoxShadow(15, 255, 255, 255)
    menuBackground: "#44444460"
  }
}, useTheme = (key, defaultValue = null) => {
  const useFlowsStore = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), themeMode = useFlowsStore((state) => state.themeMode), themeOverride = useFlowsStore((state) => state.themeOverride), _theme = { ...Theme[themeMode], ...themeOverride };
  try {
    return _theme[key] ?? defaultValue;
  } catch {
    return defaultValue;
  }
}, keys = Object.keys(import_nodes.default), totalKeys = keys.length, generateColor = (type, gamut, index) => {
  try {
    const i = Math.max(typeof type < "u" ? keys.indexOf(type) : index, 0), h = 100 * (totalKeys / (i + 1)) + gamut?.hue % 100;
    return "#" + (import_color_convert.default?.hsv?.hex ? import_color_convert.default.hsv.hex(h, gamut?.saturation, gamut?.value) : "000000");
  } catch (e) {
    return console.error("Error generating color:", e), "#000000";
  }
}, generateColorbyIndex = (index, arrLength) => {
  const gamut = useTheme("nodePalette", {}).gamut;
  var i = index < 0 ? 0 : index;
  const h = 100 * (arrLength / (i + 1)) + gamut.hue % 100;
  return "#" + import_color_convert.default.hsv.hex(h, gamut.saturation, gamut.value);
}, useNodeColor = (type) => {
  const nodePalette = useTheme("nodePalette", {});
  return type && nodePalette?.custom && nodePalette?.custom[type] ? nodePalette.custom[type] : generateColor(type, nodePalette.gamut);
}, useColorFromPalette = (index) => {
  const nodePalette = useTheme("nodePalette", {});
  return generateColor(void 0, nodePalette.gamut, index);
}, usePrimaryColor = () => {
  const nodePalette = useTheme("nodePalette", {}), useFlowsStore = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), primaryColor = useFlowsStore((state) => state.primaryColor);
  return useFlowsStore((state) => state.themeMode) == "dark" ? "#" + import_color_convert.default.hsv.hex((0, import_colord.colord)(primaryColor).hue(), nodePalette?.gamut?.saturation - 10, nodePalette?.gamut?.value + 5) : "#" + import_color_convert.default.hsv.hex((0, import_colord.colord)(primaryColor).hue(), nodePalette?.gamut?.saturation, nodePalette?.gamut?.value);
};
var Theme_default = useTheme;
//# sourceMappingURL=Theme.js.map
