var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var CodeLayout_exports = {};
__export(CodeLayout_exports, {
  default: () => CodeLayout_default
});
module.exports = __toCommonJS(CodeLayout_exports);
var import_nodes = require("./../../nodes");
const getChildren = (nodes, edges, node) => nodes.filter((n) => edges.find((e) => e.source == n.id && e.target == node.id)).map((n) => ({
  node: n,
  edge: edges.find((e) => e.source == n.id && e.target == node.id)
})), defaultSpacingFactorX = 1, defaultSpacingFactorY = 1, marginX = 120, marginY = 100;
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
const computeLayout = (nodes, edges, node, pos = { x: 0, y: 0 }, metadata = {}, tracker = { x: 0 }) => {
  const children = getChildren(nodes, edges, node), flowNode = import_nodes.NodeTypes[node.type];
  if (node.position = {
    x: pos.x,
    y: pos.y
  }, node.data = {
    ...node.data,
    layouted: !0
  }, flowNode) {
    const flowNodeType = flowNode.type ?? flowNode;
    flowNodeType && flowNodeType.getPosition && (pos = flowNodeType.getPosition(pos, node.type));
  }
  const originalPosY = pos.y, originalPosX = pos.x;
  let nodeWidth = node.width;
  if (flowNode) {
    const flowNodeType = flowNode.type ?? flowNode;
    flowNodeType && flowNodeType.getWidth && (nodeWidth = flowNodeType.getWidth(node));
  }
  let spacingFactorX = defaultSpacingFactorX, spacingFactorY = defaultSpacingFactorY;
  if (flowNode) {
    const flowNodeType = flowNode.type ?? flowNode;
    if (flowNodeType && flowNodeType.getSpacingFactor) {
      const { factorX, factorY } = flowNodeType.getSpacingFactor(node);
      spacingFactorX = factorX, spacingFactorY = factorY;
    }
  }
  const deltaX = nodeWidth + marginX * spacingFactorX;
  pos.x += deltaX;
  const childHeights = [];
  let prevPos, childTracker, maxTracker = 0;
  children.forEach(async (c) => {
    if (flowNode) {
      const flowNodeType = flowNode.type ?? flowNode;
      flowNodeType && flowNodeType.getChildPosition && (pos = flowNodeType.getChildPosition(node, pos, { x: originalPosX, y: originalPosY }, c, node.type));
    }
    prevPos = { ...pos }, childTracker = { x: 0 }, computeLayout(nodes, edges, c.node, pos, metadata, childTracker), childHeights.push({
      pos: { ...prevPos },
      delta: { x: prevPos.x - node.position.x, y: prevPos.y - originalPosY },
      width: childTracker.x - tracker.x,
      height: pos.y - originalPosY,
      node: c
    }), childTracker.x > maxTracker && (maxTracker = childTracker.x);
  }), tracker.x += deltaX + maxTracker, metadata[node.id] = { layouted: !0, childWidth: tracker.x, childHeight: pos.y - originalPosY, childHeights }, pos.x -= nodeWidth + marginX * spacingFactorX;
  const nodeHeight = node.height;
  return pos.y += pos.y - originalPosY > nodeHeight + marginY * spacingFactorY ? 0 : nodeHeight + marginY * spacingFactorY - (pos.y - originalPosY), metadata;
}, getLayoutedElements = async (nodes, edges, node) => {
  const layoutedNodes = nodes.map((n) => ({ ...n }));
  await sleep(1);
  const metadata = computeLayout(layoutedNodes, edges, node);
  return await sleep(1), { nodes: layoutedNodes, edges, metadata };
};
var CodeLayout_default = getLayoutedElements;
//# sourceMappingURL=CodeLayout.js.map
