var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var ElkLayout_exports = {};
__export(ElkLayout_exports, {
  default: () => ElkLayout_default
});
module.exports = __toCommonJS(ElkLayout_exports);
var import_elk_bundled = __toESM(require("elkjs/lib/elk.bundled.js"), 1), import_toggles = require("../../toggles");
const layoutOptions = {
  "elk.algorithm": "layered",
  "elk.direction": import_toggles.flowDirection,
  "elk.layered.considerModelOrder.strategy": "NODES_AND_EDGES",
  "elk.hierarchyHandling": "SEPARATE_CHILDREN",
  "elk.layered.crossingMinimization.forceNodeModelOrder": !0,
  "elk.layered.crossingMinimization.strategy": "LAYER_SWEEP",
  "elk.layered.spacing.nodeNodeBetweenLayers": "350",
  "elk.spacing.nodeNode": "160"
}, toELK = (node, index = 0, edges) => {
  const numConnections = edges.filter((e) => e.target == node.id).length, connectionsOffset = Math.max(0, numConnections - 1) * 40;
  return {
    layoutOptions: node.children?.length ? layoutOptions : {},
    id: node.id,
    width: node.width + connectionsOffset,
    height: node.height,
    children: node.children ? node.children.map((c, index2) => toELK(c, index2, edges)) : []
  };
}, getLayoutedElements = async (nodes, edges, node) => {
  const elk = new import_elk_bundled.default(), graph = {
    id: "root",
    layoutOptions: {
      ...layoutOptions,
      "elk.hierarchyHandling": "INCLUDE_CHILDREN"
    },
    children: nodes.map((n) => toELK(n, 0, edges)),
    edges: []
  }, total = ((nodes2) => {
    const total2 = [], toFlow = (node2, graph2, parentNode) => {
      const obj = { ...node2 };
      if (delete obj.children, parentNode && (obj.parentNode = parentNode), total2.push(obj), node2.children && node2.children.length) {
        const link = edges.find((e) => e.source == node2.children[0].id);
        if (link) {
          const newLink = JSON.parse(JSON.stringify(link));
          newLink.source = node2.id, newLink.sourceHandle = node2.id + "-output", edges.push(newLink);
        }
        node2.children.forEach((childNode) => toFlow(childNode, graph2, node2.id));
      }
    };
    return nodes2.forEach((node2) => toFlow(node2, graph, null)), total2;
  })(nodes);
  edges.filter((e) => total.find((n) => n && n.id == e.source) && total.find((n) => n && n.id == e.target)).sort((a, b) => {
    const parts1 = a.targetHandle.split("_"), parts2 = b.targetHandle.split("_"), target1 = parts1[parts1.length - 1], target2 = parts2[parts2.length - 1];
    if (target1.startsWith("block") && target2.startsWith("block") && a.target == b.target) {
      const pos1 = parseInt(target1.substr(5), 10), pos2 = parseInt(target2.substr(5), 10);
      return pos1 - pos2;
    }
    return 0;
  }).forEach((edge, index) => {
    graph.edges.push({ id: edge.id, sources: [edge.source], targets: [edge.target] });
  }), await elk.layout(graph);
  let rootNode = graph.children[0];
  var metadata = {};
  const copyPositions = (children) => children.forEach((nodeWithPosition) => {
    const currentNode = total.find((c) => c.id == nodeWithPosition.id);
    if (currentNode) {
      metadata[currentNode.id] = { layouted: !0 };
      let x = nodeWithPosition.x, y = nodeWithPosition.y;
      currentNode.position = {
        x,
        y
      }, nodeWithPosition.children && nodeWithPosition.children.length && (currentNode.data.height = nodeWithPosition.height, currentNode.data.width = nodeWithPosition.width);
    }
    nodeWithPosition && nodeWithPosition.children && copyPositions(nodeWithPosition.children);
  });
  return copyPositions(graph.children), { nodes: total, edges, metadata };
};
var ElkLayout_default = getLayoutedElements;
//# sourceMappingURL=ElkLayout.js.map
