var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var fields_exports = {};
__export(fields_exports, {
  CustomField: () => CustomField,
  CustomFieldType: () => CustomFieldType,
  getAllFieldTypes: () => getAllFieldTypes,
  getCustomFields: () => getCustomFields
});
module.exports = __toCommonJS(fields_exports);
var import_react = __toESM(require("react"), 1), import_Theme = __toESM(require("../diagram/Theme"), 1), import_NodeText = __toESM(require("../diagram/NodeText"), 1), import_AlignmentFields = __toESM(require("./AlignmentFields"), 1), import_ColorFields = __toESM(require("./ColorFields"), 1), import_RangeFields = __toESM(require("./RangeFields"), 1), import_ToggleFields = __toESM(require("./ToggleFields"), 1), import_InputFields = __toESM(require("./InputFields"), 1), import_SelectFields = __toESM(require("./SelectFields"), 1), import_ui = require("@my/ui"), import_lucide_icons = require("@tamagui/lucide-icons"), import_FlowsStore = require("../store/FlowsStore"), import_jsx_runtime = require("react/jsx-runtime");
const getCustomFields = (data) => [...(data.find((i) => i.type == "custom-field")?.data ?? []).map((i) => i.field)], getAllFieldTypes = () => {
  const alignmentTypes = (0, import_AlignmentFields.getAlignmentTypes)(), colorTypes = (0, import_ColorFields.getColorTypes)(), rangeTypes = (0, import_RangeFields.getRangeTypes)(), toggleTypes = (0, import_ToggleFields.getToggleTypes)(), inputTypes = (0, import_InputFields.getInputTypes)(), selectTypes = (0, import_SelectFields.getSelectTypes)();
  return [...alignmentTypes, ...colorTypes, ...rangeTypes, ...toggleTypes, ...inputTypes, ...selectTypes];
}, CustomFieldType = ({ item, node, nodeData }) => {
  const deletePropNodeData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.deletePropNodeData);
  var itemData = {
    ...item,
    menuActions: [
      {
        text: "Default Value",
        icon: import_lucide_icons.RotateCcw,
        action: () => {
          deletePropNodeData(node.id, item.field);
        }
        // isVisible: (data) => true
      }
    ]
  };
  nodeData[item.field]?.kind == "Identifier" && !itemData.pre && !itemData.post && (itemData.type = "input");
  var type = itemData.type ?? "", category = type.split("-")[0];
  switch (category) {
    case "alignment":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AlignmentFields.default, { node, item: itemData, nodeData });
    case "color":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ColorFields.default, { node, item: itemData, nodeData });
    case "range":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_RangeFields.default, { node, item: itemData, nodeData });
    case "toggle":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ToggleFields.default, { node, item: itemData, nodeData });
    case "select":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_SelectFields.default, { node, item: itemData, nodeData });
    case "input":
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_InputFields.default, { node, item: itemData, nodeData });
    default:
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {});
  }
}, CustomField = ({ label, input, menuActions = void 0 }) => {
  const nodeFontSize = (0, import_Theme.default)("nodeFontSize"), [menuOpened, setMenuOpened] = import_react.default.useState(!1);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: { alignItems: "stretch", flexBasis: "auto", flexShrink: 0, listStyle: "none", position: "relative", display: "flex", flexDirection: "column" }, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { style: { fontSize: nodeFontSize + "px", padding: "8px 15px 8px 15px", display: "flex", flexDirection: "row", alignItems: "stretch" }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "handleKey", style: { display: "flex", flexDirection: "row", alignItems: "center", flex: 2, overflow: "hidden" }, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_NodeText.default, { title: label, style: { textOverflow: "ellipsis", overflow: "hidden" }, children: label }) }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "handleValue", style: { minWidth: "180px", marginRight: "10px", display: "flex", flexDirection: "row", alignItems: "center", flex: 3 }, children: input }),
    menuActions ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Popover, { onOpenChange: setMenuOpened, open: menuOpened, placement: "left", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Trigger, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "div",
        {
          onClick: () => setMenuOpened(!0),
          style: { padding: "4px", justifyContent: "center", cursor: "pointer", position: "absolute", right: -10, top: 2, alignSelf: "center", zIndex: 10 },
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.MoreVertical, { size: 16, color: (0, import_Theme.default)("textColor") })
        }
      ) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Content, { padding: 0, space: 0, shadowRadius: "$4", shadowColor: "black", shadowOpacity: 0.6, backgroundColor: (0, import_Theme.default)("nodeBackgroundColor"), children: menuActions.map((action, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
        import_ui.XStack,
        {
          gap: "$2",
          marginLeft: "$1",
          opacity: 1,
          borderRadius: "$5",
          alignItems: "center",
          padding: "$3",
          alignSelf: "flex-start",
          cursor: "pointer",
          onPress: (e) => {
            action.action(), setMenuOpened(!1);
          },
          hoverStyle: {
            backgroundColor: (0, import_Theme.default)("interactiveColor")
          },
          children: [
            import_react.default.createElement(action.icon, { size: "16px", strokeWidth: 2 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_NodeText.default, { style: { fontSize: "16px", fontFamily: "Jost-Medium" }, children: action.text })
          ]
        },
        i
      )) })
    ] }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {})
  ] }) });
};
//# sourceMappingURL=index.js.map
