var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var useUndoRedo_exports = {};
__export(useUndoRedo_exports, {
  default: () => useUndoRedo_default,
  useUndoRedo: () => useUndoRedo
});
module.exports = __toCommonJS(useUndoRedo_exports);
var import_react = require("react"), import_FlowsStore = require("../store/FlowsStore"), import_DiagramStore = require("../store/DiagramStore");
const defaultOptions = {
  maxHistorySize: 100,
  enableShortcuts: !1
}, useUndoRedo = ({
  maxHistorySize = defaultOptions.maxHistorySize,
  enableShortcuts = defaultOptions.enableShortcuts
} = defaultOptions) => {
  const useFlowsStore = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), nodeData = useFlowsStore((state) => state.nodeData), setNodesData = useFlowsStore((state) => state.setNodesData), [past, setPast] = (0, import_react.useState)([]), [future, setFuture] = (0, import_react.useState)([]), { setNodes, setEdges, getNodes, getEdges, deleteElements } = (0, import_DiagramStore.useProtoflow)(), takeSnapshot = (0, import_react.useCallback)((data) => {
    setPast((past2) => [
      ...past2.slice(past2.length - maxHistorySize + 1, past2.length),
      { nodes: getNodes(), edges: getEdges(), nodeData: data || nodeData }
    ]), setFuture([]);
  }, [getNodes, getEdges, maxHistorySize]), clearNodes = async (mode) => {
    var pastNodesData = past[past.length - 1]?.nodeData ?? {}, futureState = future[future.length - 1]?.nodeData ?? {};
    if (!(!Object.keys(pastNodesData).length && mode == "undo") && !(!Object.keys(futureState).length && mode == "redo"))
      return await setNodes([]);
  }, undo = (0, import_react.useCallback)(() => {
    const pastState = past[past.length - 1];
    pastState && (setPast((past2) => past2.slice(0, past2.length - 1)), setFuture((future2) => [...future2, { nodes: getNodes(), edges: getEdges(), nodeData }]), setNodes(pastState.nodes), setEdges(pastState.edges), Object.keys(pastState.nodeData).length && setNodesData(pastState.nodeData));
  }, [setNodes, setEdges, getNodes, getEdges, past, setNodesData]), redo = (0, import_react.useCallback)(() => {
    const futureState = future[future.length - 1];
    futureState && (setFuture((future2) => future2.slice(0, future2.length - 1)), setPast((past2) => [...past2, { nodes: getNodes(), edges: getEdges(), nodeData }]), setNodes(futureState.nodes), setEdges(futureState.edges), Object.keys(futureState.nodeData).length && setNodesData(futureState.nodeData));
  }, [setNodes, setEdges, getNodes, getEdges, future, setNodesData]);
  return {
    undo,
    redo,
    takeSnapshot,
    canUndo: !past.length,
    canRedo: !future.length,
    clearNodes
  };
};
var useUndoRedo_default = useUndoRedo;
//# sourceMappingURL=useUndoRedo.js.map
