var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var FlowsOperations_exports = {};
__export(FlowsOperations_exports, {
  addChildNodeDataAndReorder: () => addChildNodeDataAndReorder,
  addEdgeChildAndReorder: () => addEdgeChildAndReorder,
  deleteAdditionalKeys: () => deleteAdditionalKeys,
  deleteNodes: () => deleteNodes,
  dumpContent: () => dumpContent,
  findJsxElementByNodeId: () => findJsxElementByNodeId,
  findJsxElementDumpedPropValue: () => findJsxElementDumpedPropValue,
  getSource: () => getSource,
  moveEdgeChildAndReorder: () => moveEdgeChildAndReorder,
  removeDataChildAndReorder: () => removeDataChildAndReorder,
  reorderDataChilds: () => reorderDataChilds,
  reorderEdgeChilds: () => reorderEdgeChilds
});
module.exports = __toCommonJS(FlowsOperations_exports);
var import_nodes = require("../nodes"), import_IdGenerator = require("./IdGenerator"), import_ts_morph = require("ts-morph");
const removeDataChildAndReorder = (data = {}, posToRemove) => {
  let deletedElementData;
  return {
    data: Object.keys(data).reduce((total, key) => {
      if (key.startsWith("child-")) {
        const childIndex = Number(key.split("child-")[1]);
        return childIndex === posToRemove ? (deletedElementData = data[key], total) : childIndex > posToRemove ? { ...total, ["child-" + (childIndex - 1)]: data[key] } : { ...total, [key]: data[key] };
      } else
        return { ...total, [key]: data[key] };
    }, {}),
    deletedElementData
  };
}, addChildNodeDataAndReorder = (data, newChildPos, addChildData) => {
  var childLength = Object.keys(data)?.filter((k) => k.startsWith("child-")).length;
  return [...Object.keys(data), "child-" + (childLength + 1)].reduce((total, key) => {
    if (key.startsWith("child-")) {
      const childIndex = Number(key.split("child-")[1]);
      if (childIndex === newChildPos) return { ...total, ["child-" + newChildPos]: addChildData };
      if (childIndex > newChildPos) return { ...total, ["child-" + childIndex]: data["child-" + (childIndex - 1)] };
    }
    return { ...total, [key]: data[key] };
  }, {});
}, moveEdgeChildAndReorder = (edges, nodeId, oldParentId, oldChildPos, newParentId = void 0, newChildPos = void 0) => {
  let newEdges = [];
  if (edges.forEach((ed) => {
    const e = { ...ed }, childPreviousPos = Number(e.targetHandle.split(oldParentId + "-child-")[1]), childNewParentPos = Number(e.targetHandle.split(newParentId + "-child-")[1]);
    childPreviousPos ? childPreviousPos > oldChildPos ? (e.targetHandle = oldParentId + "-child-" + (childPreviousPos - 1), newEdges.push(e)) : childPreviousPos < oldChildPos && newEdges.push(e) : (childNewParentPos && childNewParentPos > newChildPos - 1 && (e.targetHandle = newParentId + "-child-" + (childNewParentPos + 1)), newEdges.push(e));
  }), newParentId && newChildPos) {
    const movedNodeEdge = {
      id: (0, import_IdGenerator.generateId)(),
      targetHandle: newParentId + "-child-" + newChildPos,
      target: newParentId,
      source: nodeId,
      sourceHandle: nodeId + "-output",
      animated: !1,
      type: "custom"
    };
    newEdges.push(movedNodeEdge);
  }
  return newEdges;
}, addEdgeChildAndReorder = (edges, nodeId, parent, newChildPos) => {
  let newEdges = [];
  edges.forEach((ed) => {
    const e = { ...ed };
    if (e.targetHandle.startsWith(parent + "-child-") && !(e.targetHandle.split(parent + "-child-")[1] < newChildPos)) {
      const childPos = e.targetHandle.split(parent + "-child-")[1];
      childPos >= newChildPos && (e.targetHandle = parent + "-child-" + (Number(childPos) + 1), newEdges.push(e));
    } else
      newEdges.push(e);
  });
  const addedComponentEdge = {
    id: (0, import_IdGenerator.generateId)(),
    targetHandle: parent + "-child-" + newChildPos,
    target: parent,
    source: nodeId,
    sourceHandle: nodeId + "-output",
    animated: !1,
    type: "custom"
  };
  return newEdges.push(addedComponentEdge), newEdges;
}, reorderEdgeChilds = (edges, parentId, offset, childrenIndexes) => {
  let newEdges = [];
  return edges.forEach((ed) => {
    const e = { ...ed }, childPreviousPos = e.targetHandle.split(parentId + "-child-")[1];
    e.targetHandle.startsWith(parentId + "-child-") && childrenIndexes.findIndex((ci) => ci + 1 === Number(childPreviousPos)) != -1 && (e.targetHandle = parentId + "-child-" + (offset + (childrenIndexes.findIndex((ci) => ci + 1 === Number(childPreviousPos)) + 1))), newEdges.push(e);
  }), newEdges;
}, reorderDataChilds = (data, newOrder, offset) => {
  const newData = { ...data };
  return newOrder.forEach((prevChildIndex, index) => {
    newData["child-" + (offset + index + 1)] = data["child-" + (prevChildIndex + 1)];
  }), newData;
}, deleteNodes = (nodesToDelete, parentId, nodeId, edges, nodeData) => {
  let updatedEdges;
  edges.forEach((e) => {
    nodesToDelete.includes(e.target) && nodesToDelete.push(e.source);
  });
  var edgesToDelete = edges.filter((e) => nodesToDelete.includes(e.source) && e.target == parentId);
  let newNodeData = { ...nodeData };
  return updatedEdges = edges, edgesToDelete.forEach((edgeToDelete) => {
    let childPosToDelete = edgeToDelete ? Number(edgeToDelete.targetHandle.split("child-")[1]) : null;
    updatedEdges = moveEdgeChildAndReorder(updatedEdges, nodeId, parentId, childPosToDelete);
    const { data: newNodeDataParent } = removeDataChildAndReorder(nodeData[parentId], childPosToDelete);
    newNodeData[parentId] = newNodeDataParent;
  }), {
    updatedEdges,
    newNodeData
  };
}, deleteAdditionalKeys = (data) => Object.keys(data).reduce((obj, nodeId) => {
  const currentNode = data[nodeId], rawData = Object.keys(currentNode).reduce((total, key) => (!key.startsWith("_") && key != "connections" && key != "SourceFile_0_0" && (total = { ...total, [key]: currentNode[key] }), total), {});
  return obj = { ...obj, [nodeId]: rawData }, obj;
}, {}), dumpContent = (nodes, edges, nodesData, nodeId, type) => {
  var element = import_nodes.NodeTypes[type].type;
  return element?.dump({ id: nodeId, type }, nodes, edges, nodesData);
}, findJsxElementByNodeId = (nodeId, edges) => {
  const connectedEdge = edges.find((e) => e.source == nodeId);
  if (!connectedEdge) return;
  const connectedNodePort = connectedEdge.targetHandle;
  return connectedNodePort.split("_")[0] === "JsxElement" ? connectedNodePort : findJsxElementByNodeId(connectedEdge.target, edges);
}, findJsxElementDumpedPropValue = (nodes, edges, nodeData, nodeId, nodeType, propKey) => {
  const dumpCode = dumpContent(nodes, edges, nodeData, nodeId, nodeType);
  return getSource(dumpCode).getFirstDescendantByKind(import_ts_morph.SyntaxKind.JsxElement)?.getOpeningElement()?.getAttributes()?.find((atr) => atr?.getName && atr.getName() == propKey)?.getInitializer()?.getText();
}, getSource = (sourceCode, filename = "customCode.tsx") => new import_ts_morph.Project({
  useInMemoryFileSystem: !0,
  manipulationSettings: { indentationText: import_ts_morph.IndentationText.Tab },
  compilerOptions: {
    target: import_ts_morph.ScriptTarget.Latest,
    scriptKind: import_ts_morph.ScriptKind.TSX,
    languageVariant: import_ts_morph.LanguageVariant.JSX
  }
}).createSourceFile(filename, sourceCode, { overwrite: !0 });
//# sourceMappingURL=FlowsOperations.js.map
