var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Mask_exports = {};
__export(Mask_exports, {
  filterCallback: () => filterCallback,
  filterCallbackNodes: () => filterCallbackNodes,
  filterCallbackProp: () => filterCallbackProp,
  filterConnection: () => filterConnection,
  filterObject: () => filterObject,
  restoreCallback: () => restoreCallback,
  restoreCallbackNodes: () => restoreCallbackNodes,
  restoreCallbackProp: () => restoreCallbackProp,
  restoreObject: () => restoreObject
});
module.exports = __toCommonJS(Mask_exports);
var import_Node = require("./Node"), import_Edge = require("./Edge");
const filterCallbackNodes = (paramId = "2", type = "param", handleId = "request") => (node, childScope, edges) => {
  const callbackId = edges.find((e) => e.targetHandle == (0, import_Node.getId)(node) + "-" + type + "-" + paramId)?.source, callBack = edges.find((e) => e.targetHandle == callbackId + "_call");
  return callBack && edges.push((0, import_Edge.connectNodes)(callBack.source, callBack.sourceHandle, (0, import_Node.getId)(node), (0, import_Node.getId)(node) + "_" + handleId)), childScope.filter((child) => child?.id != callbackId);
}, filterConnection = (portId, cb) => (node, childScope, edges, nodeData, setNodeData) => {
  const callbackId = edges.find((e) => e.targetHandle == (0, import_Node.getId)(node) + "-" + portId)?.source;
  return cb && cb(callbackId, nodeData, setNodeData), childScope.filter((child) => child?.id != callbackId);
}, filterObject = ({ port = "param-1", keys, skipArrow = !0 }) => {
  let toRemove = [];
  return (node, childScope, edges, nodeData, setNodeData) => {
    const id = edges.find((e) => e.targetHandle == (0, import_Node.getId)(node) + "-" + port)?.source, objData = nodeData[id];
    return objData && Object.keys(objData).forEach((key) => {
      const objEntry = objData[key], suffix = keys && keys[objEntry.key] && keys[objEntry.key] == "output" ? "_" : "-";
      if (key.startsWith("param-")) {
        let edge = edges.find((e) => e.targetHandle == id + "-" + key);
        edge && (edge.source.startsWith("ArrowFunction_") && skipArrow && (toRemove.push(edge.source), edge = edges.find((e) => e.targetHandle == edge.source + "_call")), edges.push((0, import_Edge.connectNodes)(edge.source, edge.sourceHandle, (0, import_Node.getId)(node), (0, import_Node.getId)(node) + suffix + "mask-" + objEntry.key))), setNodeData((0, import_Node.getId)(node), {
          ...nodeData[(0, import_Node.getId)(node)],
          ["mask-" + objEntry.key]: { value: objEntry.value, kind: objEntry.kind ?? "Identifier" }
        });
      }
    }), childScope.filter((child) => child?.id != id && !toRemove.includes(child.id));
  };
}, restoreObject = ({ port = "param-1", skipArrow = !0, keys = void 0 }) => (node, nodes, originalNodes, edges, originalEdges, nodeData) => {
  nodeData = { ...nodeData }, nodeData[node.id] || (nodeData = {
    ...nodeData,
    [node.id]: {}
  }), nodeData[node.id][port] || (nodeData = {
    ...nodeData,
    [node.id]: {
      ...nodeData[node.id],
      [port]: { value: "", kind: "Identifier" }
    }
  });
  const objEdge = originalEdges.find((e) => e.targetHandle == node.id + "-" + port);
  let recoveredEdges = [], recoveredNodes = [];
  if (objEdge) {
    const objNode2 = originalNodes?.find((n) => n.id == objEdge.source);
    objNode2 && recoveredNodes.push(objNode2), recoveredEdges = originalEdges.filter((e) => e.source == objNode2?.id || e.target == objNode2?.id);
  }
  let nodeEdges = edges.filter((e) => e.target == node.id), finalEdges = [...recoveredEdges, ...edges.filter((e) => e.target != node.id)];
  finalEdges = finalEdges.filter(
    (edge, index, self) => index === self.findIndex((t) => t.id === edge.id)
  ), finalEdges.filter((e) => !nodes.find((n) => n.id === e.source) && !recoveredNodes.find((n) => n.id === e.source)).map((e) => originalNodes.find((n) => n.id === e.source)).filter((n) => n).forEach((n) => recoveredNodes.push(n));
  let objNode = recoveredNodes.find((n) => n.id.startsWith("ObjectLiteralExpression_")), objNodeId = objNode?.id;
  objNodeId || (objNodeId = "ObjectLiteralExpression_" + node.id, objNode = {
    id: objNodeId,
    type: "ObjectLiteralExpression",
    data: {},
    draggable: !1,
    deletable: !0,
    selectable: !0,
    position: { x: 0, y: 0 }
  }, recoveredNodes.push(objNode), finalEdges.push((0, import_Edge.connectNodes)(objNode.id, "output", node.id, node.id + "-" + port)));
  const originalObjData = { ...nodeData[objNodeId] };
  Object.keys(originalObjData).forEach((k) => {
    if (k.startsWith("param-")) {
      const { [k]: _, ...rest } = nodeData[objNodeId];
      nodeData[objNodeId] = rest;
    }
  }), Object.keys(nodeData[node.id]).filter((k) => k.startsWith("mask-")).map((k) => ({ key: k, value: nodeData[node.id][k] })).forEach((param) => {
    const objParam = Object.keys(originalObjData).find((k) => originalObjData[k].key == param.key.split("-").slice(1).join("-")) ?? "param-" + param.key.split("-").slice(1).join("-");
    nodeData = {
      ...nodeData,
      [objNodeId]: {
        ...nodeData[objNodeId],
        [objParam]: param.value?.value !== void 0 ? { value: param.value.value, key: param.key.split("-").slice(1).join("-"), kind: param.value.kind } : { value: param.value, key: param.key.split("-").slice(1).join("-"), kind: "Identifier" }
      }
    }, finalEdges = finalEdges.filter((e) => e.targetHandle != objNodeId + "-" + objParam);
  }), nodeEdges.forEach((edge) => {
    let key = edge.targetHandle.split("-").slice(1).join("-"), parts = edge.targetHandle.split("_mask-");
    const objData2 = originalObjData;
    if (key.startsWith("mask-")) {
      key = key.split("-").slice(1).join("-");
      let objParam = Object.keys(objData2).find((k) => objData2[k] && objData2[k].key == key);
      objParam || (nodeData[objNodeId]["param-" + key] = {
        key,
        value: "",
        kind: "Identifier"
      }, objParam = "param-" + key), finalEdges = finalEdges.filter((e) => e.targetHandle != objNodeId + "-" + objParam), finalEdges.push((0, import_Edge.connectNodes)(edge.source, edge.sourceHandle, objNodeId, objNodeId + "-" + objParam));
    } else if (parts.length > 1) {
      key = parts[1];
      let objParam = Object.keys(objData2).find((k) => objData2[k] && objData2[k].key == key);
      if (objParam || (nodeData[objNodeId]["param-" + key] = {
        key,
        value: "",
        kind: "Identifier"
      }, objParam = "param-" + key), !skipArrow)
        finalEdges = finalEdges.filter((e) => e.targetHandle != objNodeId + "-" + objParam), finalEdges.push((0, import_Edge.connectNodes)(edge.source, edge.sourceHandle, objNodeId, objNodeId + "-" + objParam));
      else {
        finalEdges = finalEdges.filter((e) => e.targetHandle != objNodeId + "-" + objParam);
        const arrowId = "ArrowFunction_" + objNodeId + "_" + key;
        recoveredNodes.find((n) => n.id == arrowId) || (recoveredNodes.push({
          id: arrowId,
          type: "ArrowFunction",
          data: {},
          draggable: !1,
          deletable: !0,
          selectable: !0,
          position: { x: 0, y: 0 }
        }), nodeData[arrowId] = {
          async: !0,
          export: !1,
          isDefault: !1,
          name: "",
          ...keys && keys[key] && keys[key].params ? { ...keys[key].params } : {}
        });
        const objParamId = objParam && objParam != "undefined" ? objParam : "param-" + key;
        nodeData[objNodeId] && (nodeData[objNodeId][objParamId] = { key, value: "", kind: "Identifier" }), finalEdges.push((0, import_Edge.connectNodes)(edge.source, edge.sourceHandle, arrowId, arrowId + "_call")), finalEdges.push((0, import_Edge.connectNodes)(arrowId, arrowId + "_call", objNodeId, objNodeId + "-" + objParamId));
      }
    }
  });
  const objData = nodeData[objNodeId];
  return objData && (Object.keys(objData).forEach((key) => {
    key.startsWith("param-") && (nodeData[objNodeId][key].value == "" || nodeData[objNodeId][key].value == null) && (finalEdges.find((e) => e.targetHandle == objNodeId + "-" + key) || delete nodeData[objNodeId][key]);
  }), Object.keys(keys).forEach((key, index) => {
    const objKey = Object.keys(objData).find((k) => objData[k].key == key);
    if (objKey) {
      const value = objData[objKey];
      delete objData[objKey], objData[objKey] = value;
    }
  })), { nodes: [...recoveredNodes, ...nodes], edges: finalEdges, nodeData };
}, filterCallback = (numParam = "2", handleId = "request") => filterCallbackNodes(numParam, "param", handleId), filterCallbackProp = (paramId = "onPress") => {
  var type = "prop";
  return filterCallbackNodes(paramId, type, type + "-" + paramId);
}, restoreCallbackNodes = (paramId, type) => (node, nodes, originalNodes, edges, originalEdges) => {
  const arrowEdge = originalEdges.find((e) => e.targetHandle == node.id + "-" + type + "-" + paramId);
  let recoveredEdges = [], recoveredNodes = [];
  if (arrowEdge) {
    const arrowNode = originalNodes?.find((n) => n.id == arrowEdge.source);
    arrowNode && recoveredNodes.push(arrowNode), recoveredEdges = originalEdges.filter((e) => e.source == arrowNode?.id || e.target == arrowNode?.id);
  }
  return { nodes: [...recoveredNodes, ...nodes], edges: [...recoveredEdges, ...edges] };
}, restoreCallback = (numParam = "2") => restoreCallbackNodes(numParam, "param"), restoreCallbackProp = (paramId = "onPress") => restoreCallbackNodes(paramId, "prop");
//# sourceMappingURL=Mask.js.map
