var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Node_exports = {};
__export(Node_exports, {
  POKA_HANDLE_TYPES: () => POKA_HANDLE_TYPES,
  PORT_TYPES: () => PORT_TYPES,
  connectItem: () => connectItem,
  createNode: () => createNode,
  dumpConnection: () => dumpConnection,
  getConnectedNode: () => getConnectedNode,
  getId: () => getId,
  getScope: () => getScope,
  getSizeOfLastChild: () => getSizeOfLastChild,
  getTrivia: () => getTrivia,
  getValueTrivia: () => getValueTrivia,
  saveNodes: () => saveNodes,
  validateCode: () => validateCode
});
module.exports = __toCommonJS(Node_exports);
var import_Edge = require("./Edge"), import_nodes = require("../nodes"), import_IdGenerator = require("./IdGenerator"), import_parser_typescript = __toESM(require("prettier/parser-typescript.js"), 1), import_standalone = __toESM(require("prettier/standalone.js"), 1);
const disableFieldCompilation = !1, createNode = (position, type, id, data, deletable, edges, nodeStore) => {
  let nodeData = {
    id: id ?? (0, import_IdGenerator.generateId)(),
    position: { x: position[0], y: position[1] },
    data: data ?? {},
    type,
    deletable,
    selectable: deletable,
    draggable: !0
    // width: nodeWidth,
    // height: nodeHeight
  };
  return import_nodes.NodeTypes[type] && import_nodes.NodeTypes[type].onCreate ? import_nodes.NodeTypes[type].onCreate(nodeData, edges, nodeStore) : [nodeData];
};
function saveNodes(nodes, edges, nodesData, getFirstNode, mode) {
  const startNode = getFirstNode(nodes, nodesData);
  if (!startNode)
    return "";
  let start = import_nodes.NodeTypes[startNode.type];
  start.type && (start = start.type);
  const code = start.dump(startNode, nodes, edges, nodesData, null, mode != "json", "full");
  if (mode == "json")
    return JSON.stringify(JSON.parse(code), null, 4);
  if (validateCode(code, mode)) {
    const finalCode = start.dump(startNode, nodes, edges, nodesData, null, !1, "full");
    return validateCode(finalCode, mode);
  }
  return "";
}
function validateCode(content, mode) {
  return import_standalone.default.format(content, {
    quoteProps: "consistent",
    parser: "typescript",
    plugins: [import_parser_typescript.default]
  });
}
function getId(node) {
  try {
    return node.getKindName() + "_" + node._compilerNode.pos + "_" + node._compilerNode.end;
  } catch {
    return node;
  }
}
function getScope(node, scope = []) {
  return node.getParent() ? getScope(node.getParent(), scope.concat(node)) : scope;
}
const PORT_TYPES = {
  flow: "_",
  data: "-"
}, POKA_HANDLE_TYPES = {
  prop: ["ArrowFunction", "CallExpression", "JsxElement", "JsxFragment", "JsxSelfClosingElement", "ObjectBindingPattern", "ObjectLiteralExpression"],
  expression: ["ArrowFunction", "CallExpression", "JsxElement", "JsxFragment", "JsxSelfClosingElement", "ObjectBindingPattern", "ObjectLiteralExpression"],
  child: ["Block", "JsxElement", "JsxFragment", "JsxSelfClosingElement"],
  incrementor: ["BinaryExpression"],
  initializer: ["letNode", "varNode"],
  condition: ["BinaryExpression", "CallExpression"],
  declarationName: ["ObjectBindingPattern"],
  accessName: ["BinaryExpression", "CallExpression", "ElementAccessExpression"],
  setLeft: ["ElementAccessExpression"],
  // left is different when it's a set or operator
  left: ["ArrayLiteralExpression", "BinaryExpression", "CallExpression", "ElementAccessExpression"],
  right: ["ArrayLiteralExpression", "BinaryExpression", "CallExpression", "ElementAccessExpression"],
  to: ["ElementAccessExpression"],
  param: ["ArrayLiteralExpression", "ArrowFunction", "BinaryExpression", "CallExpression", "Function", "JsxElement", "JsxFragment", "JsxSelfClosingElement", "ObjectBindingPattern", "ObjectLiteralExpression", "ParenthesizedExpression"],
  key: ["SpreadAssignment"],
  name: ["ElementAccessExpression"],
  value: ["ArrayLiteralExpression", "CallExpression", "ElementAccessExpression"],
  block: [],
  // all
  request: ["Block", "CallExpression"],
  then: ["BinaryExpression", "Block", "CallExpression"],
  else: ["BinaryExpression", "Block", "CallExpression"],
  constructor: ["MethodDeclaration"],
  body: ["Block"],
  union: ["TypeLiteral"]
};
function connectItem(sourceNode, sourcePort, targetNode, targetPort, data, nodesData, edges, key = null, portTypes = [PORT_TYPES.data, PORT_TYPES.data]) {
  if (!sourceNode || !targetNode) return "";
  try {
    const sourceId = getId(sourceNode), targetId = getId(targetNode);
    let itemSource = data[sourceId], itemTarget = data[targetId];
    if (itemSource || (itemSource = { type: "node", value: { id: sourceId } }), itemTarget || (itemTarget = { type: "node", value: { id: targetId } }), itemSource.type == "node") {
      if (edges.push((0, import_Edge.connectNodes)(itemSource.value.id, `${itemSource.value.id}${portTypes[0]}${sourcePort}`, itemTarget.value.id, `${itemTarget.value.id}${portTypes[1]}${targetPort}`)), disableFieldCompilation) return "";
      var type = import_nodes.NodeTypes[sourceId.split("_")[0]];
      if (!type) return "";
      type = type.type ? type.type : type;
      const nodes = Object.keys(data).filter((k) => data[k] && data[k].type == "node").map((x) => data[x].value);
      return type.dump({ id: sourceId, type: sourceId.split("_")[0] }, nodes, edges, nodesData).replace(/(\r\n|\n|\r)/gm, "");
    } else {
      if (key && itemSource._astNode)
        try {
          nodesData[targetId]["trivia-" + key] = getTrivia(itemSource._astNode);
        } catch {
        }
      return itemSource ? itemSource.value : "";
    }
  } catch (e) {
    return console.error("Error connecting nodes: ", e, sourceNode, sourcePort, targetNode, targetPort), "";
  }
}
function getTrivia(astNode) {
  const fullText = astNode.getFullText();
  return astNode.getLeadingTriviaWidth() ? fullText.substring(0, astNode.getLeadingTriviaWidth()) : "";
}
function getValueTrivia(data, valKey) {
  return (data["trivia-" + valKey] ?? " ") + (data[valKey]?.value ?? data[valKey] ?? "");
}
const getSizeOfLastChild = (childHeights) => childHeights[childHeights.length - 1].height - (childHeights.length > 2 ? childHeights[childHeights.length - 2].height : 0);
function getConnectedNode(node, nodes, edges, portType, portName) {
  const port = node.id + portType + portName, valueEdge = edges.find((e) => e.targetHandle == port && e.source);
  return valueEdge ? nodes.find((n) => n.id == valueEdge.source) : !1;
}
function dumpConnection(node, connection, portName, portType, defaultValue, edges, nodes, nodesData, metadata = null, enableMarkers = !1, dumpType = "partial", level = 0, triviaInfo = {}, disableTrivia = !1) {
  const edgeKey = connection == "source" ? "sourceHandle" : "targetHandle", valueEdge = edges.find((e) => e[edgeKey] == node.id + portType + portName && e.source);
  if (valueEdge) {
    const valueNode = nodes.find((n) => n.id == (connection == "target" ? valueEdge.source : valueEdge.target));
    if (!valueNode) return defaultValue;
    let valueComponent = import_nodes.NodeTypes[valueNode.type];
    valueComponent.type && (valueComponent = valueComponent.type);
    const marker = enableMarkers ? "/* JSFLOWID(" + (valueNode && valueNode.id ? valueNode.id : "") + ") */" : "";
    let extraContent = "";
    if (triviaInfo.fromFile = !1, valueComponent) {
      if (!disableTrivia && nodesData[valueNode.id] && nodesData[valueNode.id]._astNode) {
        const astNode = nodesData[valueNode.id]._astNode;
        triviaInfo.fromFile = !0, extraContent = getTrivia(astNode), triviaInfo.content = extraContent;
      }
      const val = valueComponent.dump(valueNode, nodes, edges, nodesData, metadata, enableMarkers, dumpType, level, extraContent);
      return marker + (dumpType == "full" ? extraContent : "") + val;
    }
  }
  return defaultValue;
}
//# sourceMappingURL=Node.js.map
