var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var CallExpression_exports = {};
__export(CallExpression_exports, {
  default: () => CallExpression_default
});
module.exports = __toCommonJS(CallExpression_exports);
var import_react = require("react"), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_AddPropButton = __toESM(require("../AddPropButton"), 1), import_FlowsStore = require("../store/FlowsStore"), import_lucide_icons = require("@tamagui/lucide-icons"), import_Theme = require("../diagram/Theme"), import_ts_morph = require("ts-morph"), import_typesAndKinds = require("../utils/typesAndKinds"), import_jsx_runtime = require("react/jsx-runtime");
const CallExpression = (node) => {
  const { id, type } = node, color = (0, import_Theme.useNodeColor)(type), nodeData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.nodeData[id] ?? {}), paramsArray = Object.keys(nodeData).filter((key) => key.startsWith("param")), nextId = paramsArray.reduce((id2, param) => parseInt(param.replace(/\D/g, ""), 10) > id2 ? parseInt(param.replace(/\D/g, ""), 10) : id2, 1) + 1, nodeParams = [
    { label: "To", field: "to", type: "input", description: "Identifier name. Leave empty to access current scope" }
  ].concat(
    //@ts-ignore
    paramsArray.map((param, i) => ({ label: `Params[${i + 1}]`, field: param, type: "input", deleteable: !0 }))
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, { icon: import_lucide_icons.ArrowUpRight, node, isPreview: !id, title: (nodeData.to ? nodeData.to : "x") + "(" + (id ? paramsArray.map((p) => nodeData[p] ? (0, import_typesAndKinds.dumpArgumentsData)(nodeData[p]) : "...").join(",") : "") + ")", id, color, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: nodeParams }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "Await", field: "await", type: "boolean", static: !0 }] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AddPropButton.default, { keyId: "param-" + nextId, id, nodeData })
  ] });
};
CallExpression.keywords = ["call", "function", "execute"];
CallExpression.category = "common";
CallExpression.defaultHandle = import_Node.PORT_TYPES.data + "to";
CallExpression.getData = (node, data, nodesData, edges) => {
  const parentNode = node.getParent();
  return {
    to: (0, import_Node.connectItem)(node.getExpression(), "output", node, "to", data, nodesData, edges, "to"),
    await: parentNode && parentNode.getKind() === import_ts_morph.SyntaxKind.AwaitExpression,
    ...node.getArguments().reduce((obj, param, i) => {
      var paramKey = "param-" + (i + 1), paramData = (0, import_typesAndKinds.getArgumentsData)(param);
      return paramData || (paramData = {
        value: (0, import_Node.connectItem)(param, "output", node, paramKey, data, nodesData, edges, paramKey)
      }), {
        ...obj,
        [paramKey]: paramData
      };
    }, {})
  };
};
function getTriviaBeforeCloseParenToken(callNode) {
  if (!callNode) return "";
  const fullText = callNode.getSourceFile().getFullText(), lastChild = callNode.getLastChild();
  if (lastChild && lastChild.getKindName() === "CloseParenToken") {
    const leadingTriviaWidth = lastChild.getLeadingTriviaWidth();
    return fullText.substring(lastChild.getPos(), lastChild.getPos() + leadingTriviaWidth);
  }
  return "";
}
CallExpression.dump = (node, nodes, edges, nodesData, metadata = null, enableMarkers = !1, dumpType = "partial", level = 0) => {
  const data = nodesData[node.id] ?? {}, params = Object.keys(data).sort().filter((key) => key.startsWith("param")).sort((a, b) => a.localeCompare(b, "en", { numeric: !0 })).map((param) => {
    if (data[param]?._dump) return data[param]._dump(data, level);
    let part;
    const fallback = data._fallBack ? data._fallBack.find((f) => f.port == param) : null;
    if (fallback) {
      const content = (0, import_Node.dumpConnection)(node, fallback.type, fallback.fallbackPort, fallback.portType, null, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
      content ? part = fallback.preText + content + fallback.postText : part = fallback.fallbackText;
    } else
      part = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, null, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level), part || (part = (0, import_typesAndKinds.dumpArgumentsData)(data[param]));
    return part;
  }), callName = (0, import_Node.dumpConnection)(node, "target", "to", import_Node.PORT_TYPES.data, data?.to ?? "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
  return callName ? (data.await ? "await " : "") + callName + "(" + params.join(",") + getTriviaBeforeCloseParenToken(data._astNode) + ")" : "" + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
};
var CallExpression_default = (0, import_react.memo)(CallExpression);
//# sourceMappingURL=CallExpression.js.map
