var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Function_exports = {};
__export(Function_exports, {
  default: () => Function_default
});
module.exports = __toCommonJS(Function_exports);
var import_react = require("react"), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_AddPropButton = __toESM(require("../AddPropButton"), 1), import_IdGenerator = require("../lib/IdGenerator"), import_FlowsStore = require("../store/FlowsStore"), import_ts_morph = require("ts-morph"), import_lucide_icons = require("@tamagui/lucide-icons"), import_Theme = require("../diagram/Theme"), import_typesAndKinds = require("../utils/typesAndKinds"), import_jsx_runtime = require("react/jsx-runtime");
const Function = (node) => {
  const { id, type } = node, color = (0, import_Theme.useNodeColor)(type), isArrow = type == "ArrowFunction", nodeData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.nodeData[id] ?? {}), nodeParams = (isArrow ? [] : [{ label: "Name", static: !0, field: "name", type: "input", description: "Function name" }]).concat(Object.keys(nodeData).filter((p) => p.startsWith("param-")).map((param, i) => ({ label: nodeData[param].isBindingPattern ? `${"Params[" + (i + 1) + "]"}` : param.substr(6), field: param, fieldType: "parameter", deleteable: !0 })));
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, { icon: import_lucide_icons.FunctionSquare, node, isPreview: !id, title: isArrow ? "=>" : nodeData.name ? nodeData.name : "function", id, color, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "Call", field: "call", fieldType: "call", type: "input" }] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: nodeParams }),
    type != "FunctionExpression" ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "Async", field: "async", type: "boolean", static: !0 }], boxStyle: { marginTop: "40px" } }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "Export", field: "export", type: "boolean", static: !0 }] }),
      nodeData.export ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "isDefault", field: "isDefault", type: "boolean", static: !0 }] }) : null
    ] }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: { marginTop: "26px" } }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AddPropButton.default, { id, nodeData })
  ] });
};
Function.category = "program structure";
Function.keywords = ["function", "=>", "arrow"];
Function.getData = (node, data, nodesData, edges) => {
  let thenId = (0, import_Node.getId)(node.getBody());
  const body = (0, import_Node.connectItem)(thenId, "output", node, "call", data, nodesData, edges, null, [import_Node.PORT_TYPES.data, import_Node.PORT_TYPES.flow]);
  return {
    ...node.getParameters().reduce((obj, param, i) => {
      const uuid = (0, import_IdGenerator.generateId)();
      let sourceKey = param.getName();
      const nodeType = param.getTypeNode(), type = nodeType ? nodeType.getText() : null, isBindingPattern = !!param.getDescendantsOfKind(import_ts_morph.SyntaxKind.ObjectBindingPattern).length;
      isBindingPattern && (sourceKey = param.getDescendantsOfKind(import_ts_morph.SyntaxKind.ObjectBindingPattern)[0]);
      const initializer = param.getInitializer();
      var paramData = (0, import_typesAndKinds.getArgumentsData)(initializer);
      return paramData || (paramData = {
        value: initializer ? (0, import_Node.connectItem)(initializer, "output", node, "param-" + uuid, data, nodesData, edges, "value") : ""
      }), {
        ...obj,
        ["param-" + uuid]: {
          isBindingPattern,
          type,
          key: isBindingPattern ? (0, import_Node.connectItem)(sourceKey, "output", node, "param-" + uuid, data, nodesData, edges, "key") : param.getName(),
          ...paramData
        }
      };
    }, {
      name: node.getName && node.getName() != null ? node.getName() : "",
      export: node.getModifiers ? !!node.getModifiers().find((m) => m.getText() == "export") : !1,
      isDefault: node.getModifiers ? !!node.getModifiers().find((m) => m.getText() == "default") : !1,
      async: !!node.getModifiers().find((m) => m.getKindName() == "AsyncKeyword"),
      call: body,
      type: node.getReturnTypeNode() ? node.getReturnTypeNode().getText() : null
    })
  };
};
Function.dump = (node, nodes, edges, nodesData, metadata = null, enableMarkers = !1, dumpType = "partial", level = 0) => {
  const data = nodesData[node.id] ?? {}, params = Object.keys(data).filter((key) => key.startsWith("param")).map((param) => {
    let objParam;
    if (data[param].isBindingPattern)
      objParam = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, data[param].value, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level) + (data[param].type ? `:${data[param].type}` : "");
    else {
      let paramName = (0, import_Node.dumpConnection)(node, "target", param + "-key", import_Node.PORT_TYPES.data, data[param].key, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level), paramValue = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, data[param].value, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
      objParam = paramName + (data[param].type ? `:${data[param].type}` : "") + (paramValue ? "=" + paramValue : "");
    }
    return objParam;
  }), body = (0, import_Node.dumpConnection)(node, "target", "call", import_Node.PORT_TYPES.flow, data.call ?? "{}", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level, {}, !0);
  let total = (data.export ? "export " : "") + (data.export && data.isDefault ? "default " : "") + (data.async ? "async " : "");
  return node.type == "ArrowFunction" ? total += "(" + params.join(",") + ") => " + body : total += "function " + data.name + "(" + params.join(",") + ") " + (data.type ? ":" + data.type + " " : "") + body, total + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
};
var Function_default = (0, import_react.memo)(Function);
//# sourceMappingURL=Function.js.map
