var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Loop_exports = {};
__export(Loop_exports, {
  LoopFactory: () => LoopFactory,
  default: () => Loop_default
});
module.exports = __toCommonJS(Loop_exports);
var import_react = require("react"), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_lucide_icons = require("@tamagui/lucide-icons"), import_types = require("../lib/types"), import_Theme = __toESM(require("../diagram/Theme"), 1), import_jsx_runtime = require("react/jsx-runtime");
const LoopFactory = (mode, submode = "") => {
  const Loop = (node) => {
    const fontNodeSize = (0, import_Theme.default)("nodeFontSize"), { id, type } = node, color = (0, import_Theme.useNodeColor)(type), nodeParams = [];
    return mode == "for" && nodeParams.push({ label: "Initializer", field: "initializer", type: "input" }), nodeParams.push({ label: "Condition", field: "condition", type: "input" }), mode == "for" && nodeParams.push({ label: "Incrementor", field: "incrementor", type: "input" }), /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, { icon: import_lucide_icons.Repeat, node, isPreview: !id, title: submode || mode, id, color, dataOutput: import_types.DataOutput.flow, children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: nodeParams, boxStyle: { marginTop: "0px", marginBottom: fontNodeSize * 3 + "px" } }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.FlowPort, { id, type: "input", label: "Loop", style: { top: mode == "for" ? fontNodeSize * 11 : fontNodeSize * 6.5 + "px" }, handleId: "loop" })
    ] });
  };
  return Loop.keywords = ["for", "while", "do-while", "loop", "iterator", "iterate", "for each", "repeat"], Loop.category = "loops", Loop.getData = (node, data, nodesData, edges) => {
    node.getStatement() && (0, import_Node.connectItem)(node.getStatement(), "output", node, "loop", data, nodesData, edges, null, [import_Node.PORT_TYPES.data, import_Node.PORT_TYPES.flow]);
    let obj = {};
    return mode == "for" && (obj = {
      initializer: (0, import_Node.connectItem)(node.getInitializer(), "output", node, "initializer", data, nodesData, edges, "initializer"),
      incrementor: (0, import_Node.connectItem)(node.getIncrementor(), "output", node, "incrementor", data, nodesData, edges, "incrementor")
    }), {
      ...obj,
      condition: (0, import_Node.connectItem)(mode == "while" ? node.getExpression() : node.getCondition(), "output", node, "condition", data, nodesData, edges, "condition"),
      mode,
      submode
    };
  }, Loop.dataOutput = import_types.DataOutput.flow, Loop.dump = (node, nodes, edges, nodesData, metadata = null, enableMarkers = !1, dumpType = "partial", level = 0) => {
    const data = nodesData[node.id], condition = (0, import_Node.dumpConnection)(node, "target", "condition", import_Node.PORT_TYPES.data, data?.condition, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level), loop = (0, import_Node.dumpConnection)(node, "target", "loop", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
    let loopCode;
    if (node.type == "WhileStatement")
      loopCode = "while(" + condition + ") " + loop;
    else if (node.type == "DoStatement")
      loopCode = "do " + loop + " while (" + condition + ")";
    else if (node.type == "ForStatement") {
      const initializer = (0, import_Node.dumpConnection)(node, "target", "initializer", import_Node.PORT_TYPES.data, data?.initializer, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level), incrementor = (0, import_Node.dumpConnection)(node, "target", "incrementor", import_Node.PORT_TYPES.data, data?.incrementor, edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
      loopCode = "for(" + initializer.replace(/;$/, "") + ";" + condition.replace(/;$/, "") + ";" + incrementor.replace(/;$/, "") + ") " + loop;
    }
    return loopCode + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
  }, Loop;
};
var Loop_default = (0, import_react.memo)(LoopFactory("while"));
//# sourceMappingURL=Loop.js.map
