var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var MethodDeclaration_exports = {};
__export(MethodDeclaration_exports, {
  MethodFactory: () => MethodFactory,
  default: () => MethodDeclaration_default
});
module.exports = __toCommonJS(MethodDeclaration_exports);
var import_react = __toESM(require("react"), 1), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_IdGenerator = require("../lib/IdGenerator"), import_FlowsStore = require("../store/FlowsStore"), import_lucide_icons = require("@tamagui/lucide-icons"), import_types = require("../lib/types"), import_AddPropButton = __toESM(require("../AddPropButton"), 1), import_Theme = require("../diagram/Theme"), import_jsx_runtime = require("react/jsx-runtime");
const MethodFactory = (methodType) => {
  const component = (node) => {
    const { id, type } = node, color = (0, import_Theme.useNodeColor)(type), nodeData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.nodeData[id] ?? {}), nodeParams = Object.keys(nodeData).filter((p) => p.startsWith("param")).map((param, i) => ({ label: param.substr(6), field: param, fieldType: "parameter" }));
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, { icon: import_lucide_icons.Layers, node, isPreview: !id, title: methodType, id, color, dataOutput: import_types.DataOutput.method, children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: { height: "40px" } }),
      methodType == "method" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ label: "Name", field: "name", type: "input" }] }) : null,
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: nodeParams }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AddPropButton.default, { id, nodeData, type: "param-" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.FlowPort, { id, type: "input", label: "Body", style: { top: "60px" }, handleId: "body" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [
        { label: "Static", field: "static", type: "boolean", static: !0 },
        { label: "Async", field: "async", type: "boolean", static: !0 }
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: [{ field: "level", type: "select", data: ["public", "private", "protected"], static: !0 }] })
    ] });
  };
  return component.category = "program structure", component.keywords = ["method", "constructor", "class"], component.getData = (node, data, nodesData, edges) => {
    (0, import_Node.connectItem)(node.getBody(), "output", node, "body", data, nodesData, edges, null, [import_Node.PORT_TYPES.data, import_Node.PORT_TYPES.flow]);
    let level = "public";
    return node.getModifiers().find((m) => m.getKindName() == "PublicKeyword") ? level = "public" : node.getModifiers().find((m) => m.getKindName() == "PrivateKeyword") ? level = "private" : node.getModifiers().find((m) => m.getKindName() == "ProtectedKeyword") && (level = "protected"), {
      ...node.getParameters().reduce((obj, param, i) => {
        const uuid = (0, import_IdGenerator.generateId)(), source = param.getInitializer(), nodeType = param.getTypeNode(), type = nodeType ? nodeType.getText() : null;
        return node.getName && (obj.name = node.getName()), {
          ...obj,
          ["param-" + uuid]: {
            key: param.getName(),
            value: source ? (0, import_Node.connectItem)(source, "output", node, "param-" + uuid, data, nodesData, edges, "param-" + uuid) : "",
            type
          }
        };
      }, {
        static: !!node.getModifiers().find((m) => m.getKindName() == "StaticKeyword"),
        async: !!node.getModifiers().find((m) => m.getKindName() == "AsyncKeyword"),
        level,
        type: node.getReturnTypeNode() ? node.getReturnTypeNode().getText() : null
      })
    };
  }, component.dataOutput = import_types.DataOutput.method, component.dump = (node, nodes, edges, nodesData, methodName, enableMarkers, dumpType, level = 0) => {
    const data = nodesData[node.id] ?? {}, name = methodType == "constructor" ? "constructor" : data.name, params = Object.keys(data).filter((key) => key.startsWith("param")).map((param) => {
      let paramName = (0, import_Node.dumpConnection)(node, "target", param + "-key", import_Node.PORT_TYPES.data, data[param]?.key ?? "", edges, nodes, nodesData, null, enableMarkers, dumpType, level);
      const paramValue = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, data[param]?.value ?? "", edges, nodes, nodesData, null, enableMarkers, dumpType, level);
      return paramName + (data[param].type ? ":" + data[param].type + " " : "") + (paramValue ? "=" + paramValue : "");
    }), body = (0, import_Node.dumpConnection)(node, "target", "body", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, null, enableMarkers, dumpType, level);
    return (data.static ? "static " : "") + (data.async ? "async " : "") + name + "(" + params.join(",") + ") " + (data.type ? ":" + data.type + " " : "") + body + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, null, enableMarkers, dumpType, level);
  }, component;
}, MethodNode = MethodFactory("method");
var MethodDeclaration_default = import_react.default.memo(MethodNode);
//# sourceMappingURL=MethodDeclaration.js.map
