var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var ObjectBindingPattern_exports = {};
__export(ObjectBindingPattern_exports, {
  default: () => ObjectBindingPattern_default
});
module.exports = __toCommonJS(ObjectBindingPattern_exports);
var import_react = require("react"), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_IdGenerator = require("../lib/IdGenerator"), import_FlowsStore = require("../store/FlowsStore"), import_AddPropButton = __toESM(require("../AddPropButton"), 1), import_types = require("../lib/types"), import_lucide_icons = require("@tamagui/lucide-icons"), import_Theme = require("../diagram/Theme"), import_jsx_runtime = require("react/jsx-runtime");
const ObjectBindingPattern = (node) => {
  const { id, type } = node, color = (0, import_Theme.useNodeColor)(type), nodeData = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext)((state) => state.nodeData[id] ?? {}), nodeParams = Object.keys(nodeData).filter((p) => p.startsWith("param-")).map((param, i) => ({ label: param.substr(6), field: param, fieldType: "parameter", deleteable: !0 }));
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, { icon: import_lucide_icons.Combine, node, isPreview: !id, title: "object binding", id, color, dataOutput: import_types.DataOutput.binding, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, { id, params: nodeParams }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AddPropButton.default, { id, nodeData })
  ] });
};
ObjectBindingPattern.category = "operators";
ObjectBindingPattern.keywords = ["object", "binding", "object binding"];
ObjectBindingPattern.getData = (node, data, nodesData, edges) => ({
  ...node.getElements().reduce((obj, element, i) => {
    const uuid = (0, import_IdGenerator.generateId)(), sourcePropertyName = element?.getPropertyNameNode(), sourceName = element?.getName() ?? "", sourceInitializer = element?.getInitializer();
    var bindingObj = {};
    return sourceInitializer ? bindingObj = {
      key: sourceName,
      value: sourceInitializer.getText(),
      initializer: !0
    } : sourcePropertyName ? bindingObj = {
      key: sourcePropertyName.getText(),
      value: sourceName
    } : bindingObj = {
      key: sourceName
    }, {
      ...obj,
      ["param-" + uuid]: {
        ...bindingObj
      }
    };
  }, {
    // export: node.getModifiers().find(m => m.getKindName() == 'ExportKeyword')
  })
});
ObjectBindingPattern.dataOutput = import_types.DataOutput.binding;
ObjectBindingPattern.dump = (node, nodes, edges, nodesData, metadata = null, enableMarkers = !1, dumpType = "partial", level = 0) => {
  const data = nodesData[node.id] ?? {};
  return "{" + Object.keys(data).filter((key) => key.startsWith("param-")).reduce((total2, param) => {
    let objKey = data[param].key;
    const separator = data[param].initializer ? "=" : ":", objValue = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, data[param]?.value ?? "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level), objParam = objKey + (objValue ? separator + objValue : "") + ", ";
    return total2 + objParam;
  }, "") + "}" + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
};
var ObjectBindingPattern_default = ObjectBindingPattern;
//# sourceMappingURL=ObjectBindingPattern.js.map
