var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var SwitchStatement_exports = {};
__export(SwitchStatement_exports, {
  default: () => SwitchStatement_default
});
module.exports = __toCommonJS(SwitchStatement_exports);
var import_jsx_runtime = require("react/jsx-runtime"), import_react = require("react"), import_Node = require("../lib/Node"), import_Node2 = __toESM(require("../Node"), 1), import_AddPropButton = __toESM(require("../AddPropButton"), 1), import_FlowsStore = require("../store/FlowsStore"), import_lucide_icons = require("@tamagui/lucide-icons"), import_types = require("../lib/types"), import_Theme = require("../diagram/Theme");
function _define_property(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {}, ownKeys2 = Object.keys(source);
    typeof Object.getOwnPropertySymbols == "function" && (ownKeys2 = ownKeys2.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
      return Object.getOwnPropertyDescriptor(source, sym).enumerable;
    }))), ownKeys2.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _object_spread_props(target, source) {
  return source = source ?? {}, Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
  }), target;
}
var SwitchStatement = function(node) {
  var id = node.id, type = node.type, color = (0, import_Theme.useNodeColor)(type), useFlowsStore = (0, import_react.useContext)(import_FlowsStore.FlowStoreContext), nodeData = useFlowsStore(function(state) {
    var _state_nodeData_id;
    return (_state_nodeData_id = state.nodeData[id]) !== null && _state_nodeData_id !== void 0 ? _state_nodeData_id : {};
  }), nodeParams = [
    {
      label: "Expression",
      field: "expression",
      type: "input"
    }
  ].concat(
    //@ts-ignore
    Object.keys(nodeData).filter(function(key) {
      return key.startsWith("case-");
    }).reduce(function(params, param, i) {
      return params = params.concat({
        label: "case",
        field: param,
        type: "input",
        deleteable: !0
      }), params = params.concat({
        label: ":",
        field: "block".concat(i),
        fieldType: "clause"
      }), params;
    }, [])
  ), defaultParam = [
    {
      label: "default :",
      field: "defaultBlock",
      fieldType: "clause"
    }
  ];
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Node2.default, {
    icon: import_lucide_icons.Split,
    node,
    isPreview: !id,
    title: "switch",
    id,
    color,
    dataOutput: import_types.DataOutput.flow,
    children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, {
        id,
        params: nodeParams,
        boxStyle: {
          marginTop: "10px"
        }
      }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AddPropButton.default, {
        id,
        nodeData,
        type: "Case",
        style: {
          marginBottom: "20px"
        }
      }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Node2.NodeParams, {
        id,
        params: defaultParam,
        boxStyle: {
          marginBottom: "10px"
        }
      })
    ]
  });
};
SwitchStatement.category = "conditionals";
SwitchStatement.keywords = [
  "switch",
  "conditional",
  "case",
  "if"
];
SwitchStatement.getData = function(node, data, nodesData, edges) {
  var clauses = node.getCaseBlock().getClauses(), cases = {};
  return clauses && (cases = clauses.reduce(function(obj, clause, i) {
    if (clause.getKindName() == "CaseClause") {
      var key = "case-".concat(i + 1), clauseKey = "block".concat(i), source = clause.getExpression(), _obj;
      return _object_spread_props(_object_spread({}, obj), (_obj = {}, _define_property(_obj, key, (0, import_Node.connectItem)(source, "output", node, key, data, nodesData, edges, key)), _define_property(_obj, clauseKey, (0, import_Node.connectItem)(clause, "output", node, clauseKey + import_Node.PORT_TYPES.flow + "output", data, nodesData, edges, clauseKey, [
        import_Node.PORT_TYPES.data,
        import_Node.PORT_TYPES.flow
      ])), _obj));
    } else
      return _object_spread_props(_object_spread({}, obj), _define_property({}, "defaultBlock", (0, import_Node.connectItem)(clause, "output", node, "defaultBlock" + import_Node.PORT_TYPES.flow + "output", data, nodesData, edges, "defaultBlock", [
        import_Node.PORT_TYPES.data,
        import_Node.PORT_TYPES.flow
      ])));
  }, {})), _object_spread({
    expression: (0, import_Node.connectItem)(node.getExpression(), "output", node, "expression", data, nodesData, edges, "expression")
  }, cases);
};
SwitchStatement.dataOutput = import_types.DataOutput.flow;
SwitchStatement.dump = function(node, nodes, edges, nodesData) {
  var metadata = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null, enableMarkers = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : !1, dumpType = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : "partial", level = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : 0, _nodesData_node_id, data = (_nodesData_node_id = nodesData[node.id]) !== null && _nodesData_node_id !== void 0 ? _nodesData_node_id : {}, _data_expression, expression = (0, import_Node.dumpConnection)(node, "target", "expression", import_Node.PORT_TYPES.data, (_data_expression = data == null ? void 0 : data.expression) !== null && _data_expression !== void 0 ? _data_expression : "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level, {}), defaultPortName = "defaultBlock" + import_Node.PORT_TYPES.flow + "output", _data_defaultBlock, defaultBody = (0, import_Node.dumpConnection)(node, "target", defaultPortName, import_Node.PORT_TYPES.flow, (_data_defaultBlock = data.defaultBlock) !== null && _data_defaultBlock !== void 0 ? _data_defaultBlock : "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level, {}), defaultText = defaultBody ? `default: 
` + defaultBody + `
` : "", body = Object.keys(data).filter(function(key) {
    return key.startsWith("case");
  }).map(function(param, i) {
    var _data_param, paramValue = (0, import_Node.dumpConnection)(node, "target", param, import_Node.PORT_TYPES.data, (_data_param = data[param]) !== null && _data_param !== void 0 ? _data_param : "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level, {}, !1), clauseKey = "block".concat(i), portName = clauseKey + import_Node.PORT_TYPES.flow + "output", triviaInfo = {}, _data_clauseKey, paramBody = (0, import_Node.dumpConnection)(node, "target", portName, import_Node.PORT_TYPES.flow, (_data_clauseKey = data[clauseKey]) !== null && _data_clauseKey !== void 0 ? _data_clauseKey : "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level, triviaInfo);
    return `
` + "	".repeat(level) + "case " + paramValue + `:
` + paramBody.replace(/^[\n\r\t]+/, "");
  });
  return "switch(" + expression + ") {" + body.join("") + defaultText + `
}` + (0, import_Node.dumpConnection)(node, "source", "output", import_Node.PORT_TYPES.flow, "", edges, nodes, nodesData, metadata, enableMarkers, dumpType, level);
};
var SwitchStatement_default = /* @__PURE__ */ (0, import_react.memo)(SwitchStatement);
//# sourceMappingURL=SwitchStatement.js.map
