var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var DiagramStore_exports = {};
__export(DiagramStore_exports, {
  DiagramContext: () => DiagramContext,
  addProtoEdge: () => addProtoEdge,
  useProtoEdges: () => useProtoEdges,
  useProtoEdgesState: () => useProtoEdgesState,
  useProtoNodesState: () => useProtoNodesState,
  useProtoflow: () => useProtoflow
});
module.exports = __toCommonJS(DiagramStore_exports);
var import_react = require("react"), import_reactflow = require("reactflow");
const DiagramContext = (0, import_react.createContext)({
  nodePreview: "",
  flowsHeight: void 0
}), getExtraData = () => {
  const { nodePreview, flowsHeight } = (0, import_react.useContext)(DiagramContext);
  return {
    preview: nodePreview === "preview" ? "node" : "default",
    flowsHeight
  };
}, wrapDiagramItem = (payload, dataToAdd) => {
  var wrappedElements;
  return typeof payload == "function" ? wrappedElements = (ele) => payload(ele.map((e) => ({ ...e, data: { ...e.data, ...dataToAdd } }))) : wrappedElements = payload.map((e) => ({ ...e, data: { ...e.data, ...dataToAdd } })), wrappedElements;
}, useProtoflow = () => {
  const {
    setNodes: reactFlowSetNodes,
    setEdges: reactFlowSetEdges,
    project,
    setViewport,
    getNodes,
    getViewport,
    setCenter,
    getEdges,
    deleteElements,
    fitView
  } = (0, import_reactflow.useReactFlow)(), extraData = getExtraData();
  return {
    setNodes: (payload) => {
      reactFlowSetNodes(wrapDiagramItem(payload, extraData));
    },
    project,
    setViewport,
    getNodes,
    getViewport,
    setCenter,
    setEdges: (payload) => {
      reactFlowSetEdges(wrapDiagramItem(payload, extraData));
    },
    getEdges,
    deleteElements,
    fitView
  };
}, useProtoNodesState = (initialItems, extraData = {}) => {
  const [nodes, reactFlowSetNodes, onNodesChange] = (0, import_reactflow.useNodesState)(wrapDiagramItem(initialItems, extraData));
  return [nodes, (payload) => reactFlowSetNodes(wrapDiagramItem(payload, extraData)), onNodesChange];
}, useProtoEdgesState = (initialItems, extraData = {}) => {
  const [edges, reactFlowSetEdges, onEdgesChange] = (0, import_reactflow.useEdgesState)(wrapDiagramItem(initialItems, extraData));
  return [edges, (payload) => reactFlowSetEdges(wrapDiagramItem(payload, extraData)), onEdgesChange];
}, useProtoEdges = () => {
  const nodes = (0, import_reactflow.useNodes)();
  return (0, import_reactflow.useEdges)().filter((e) => nodes.find((n) => n.id === e.source) && nodes.find((n) => n.id === e.target));
}, addProtoEdge = (edgeParams, edges) => (0, import_reactflow.addEdge)({ ...edgeParams, type: "custom", animated: !1 }, edges);
//# sourceMappingURL=DiagramStore.js.map
