var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var FlowsStore_exports = {};
__export(FlowsStore_exports, {
  FlowStoreContext: () => FlowStoreContext,
  useFlowsStore: () => useFlowsStore
});
module.exports = __toCommonJS(FlowsStore_exports);
var import_react = require("react"), import_zustand = __toESM(require("zustand"), 1), import_immer = __toESM(require("immer"), 1);
const useFlowsStore = () => (0, import_zustand.default)((set, get) => ({
  errorData: {},
  nodeData: {},
  customComponents: [],
  initialEdges: [],
  initialNodes: [],
  saveStatus: null,
  menuState: "closed",
  menuPosition: [0, 0],
  menuOpener: "",
  themeMode: "light",
  primaryColor: "#ccc",
  themeOverride: {},
  flowInstance: Math.random(),
  currentPath: "Start",
  metadata: {},
  dataNotify: () => {
  },
  setDataNotify: (dataNotify) => set((0, import_immer.default)((draft) => {
    draft.dataNotify = dataNotify;
  })),
  clearError: () => set((0, import_immer.default)((draft) => {
    draft.errorData = {};
  })),
  setError: (id) => set((0, import_immer.default)((draft) => {
    draft.errorData = { id };
  })),
  setCurrentPath: (path) => set((0, import_immer.default)((draft) => {
    draft.currentPath = path;
  })),
  setMenu: (menuState, menuPosition, menuOpener) => set((0, import_immer.default)((draft) => {
    draft.menuState = menuState, draft.menuPosition = menuPosition || [-5e3, -5e3], draft.menuOpener = menuOpener || "";
  })),
  setInitialEdges: (initialEdges) => set((0, import_immer.default)((draft) => {
    draft.initialEdges = initialEdges;
  })),
  setInitialNodes: (initialNodes) => set((0, import_immer.default)((draft) => {
    draft.initialNodes = initialNodes;
  })),
  setCustomComponents: (customComponents) => set((0, import_immer.default)((draft) => {
    draft.customComponents = customComponents;
  })),
  appendCustomComponents: (customComponents) => set((0, import_immer.default)((draft) => {
    const objectExists = (arr, obj) => arr.some((item) => item.id === obj.id);
    customComponents.forEach((obj) => {
      objectExists(draft.customComponents, obj) || draft.customComponents.push(obj);
    });
  })),
  setNodeData: (id, data) => set((0, import_immer.default)((draft) => {
    draft.nodeData = { ...get().nodeData, [id]: { ...get().nodeData[id], ...data } };
  })),
  setNodesMetaData: (metadata) => set((0, import_immer.default)((draft) => {
    Object.keys(metadata).forEach((key) => {
      draft.nodeData[key] || (draft.nodeData[key] = {}), draft.nodeData[key]._metadata = metadata[key];
    });
  })),
  setNodesData: (data) => set((0, import_immer.default)((draft) => {
    draft.nodeData = data;
  })),
  deletePropNodeData: (id, prop) => set((0, import_immer.default)((draft) => {
    var nData = { ...get().nodeData[id] };
    Object.keys(nData).includes(prop) ? (delete nData[prop], draft.nodeData = { ...draft.nodeData, [id]: { ...nData } }) : (console.error('Error deleting the following "Property Node Data": ' + id), draft.nodeData = { ...draft.nodeData });
  })),
  clearNodesData: () => set((0, import_immer.default)((draft) => {
    const filteredData = {};
    Object.keys(get().nodeData).filter((key) => !(key.startsWith("Object") || key.startsWith("ArrowFunction") || key.startsWith("TypeAliasDeclaration") || key.startsWith("InterfaceDeclaration") || key.startsWith("ObjectBindingPattern") || key.startsWith("JsxElement") || key.startsWith("JsxExpression") || key.startsWith("PropertyAssignment") || key.startsWith("FunctionDeclaration"))).forEach((key) => {
      filteredData[key] = get().nodeData[key];
    }), draft.nodeData = filteredData;
  })),
  setSaveStatus: (status) => set((0, import_immer.default)((draft) => {
    draft.saveStatus = status;
  })),
  setThemeMode: (theme, themeOverride, primaryColor) => set((0, import_immer.default)((draft) => {
    draft.themeMode = theme, draft.themeOverride = themeOverride, draft.primaryColor = primaryColor ?? "#ccc";
  })),
  setMetadata: (payload) => set((0, import_immer.default)((draft) => {
    draft.metadata = payload;
  }))
})), FlowStoreContext = (0, import_react.createContext)(useFlowsStore());
//# sourceMappingURL=FlowsStore.js.map
