var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var FlowsStore_exports = {};
__export(FlowsStore_exports, {
  FlowStoreContext: () => FlowStoreContext,
  useFlowsStore: () => useFlowsStore
});
module.exports = __toCommonJS(FlowsStore_exports);
var import_react = require("react"), import_zustand = __toESM(require("zustand"), 1), import_immer = __toESM(require("immer"), 1);
function _define_property(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {}, ownKeys2 = Object.keys(source);
    typeof Object.getOwnPropertySymbols == "function" && (ownKeys2 = ownKeys2.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
      return Object.getOwnPropertyDescriptor(source, sym).enumerable;
    }))), ownKeys2.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _object_spread_props(target, source) {
  return source = source ?? {}, Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
  }), target;
}
var useFlowsStore = function() {
  return (0, import_zustand.default)(function(set, get) {
    return {
      errorData: {},
      nodeData: {},
      customComponents: [],
      initialEdges: [],
      initialNodes: [],
      saveStatus: null,
      menuState: "closed",
      menuPosition: [
        0,
        0
      ],
      menuOpener: "",
      themeMode: "light",
      primaryColor: "#ccc",
      themeOverride: {},
      flowInstance: Math.random(),
      currentPath: "Start",
      metadata: {},
      dataNotify: function() {
      },
      setDataNotify: function(dataNotify) {
        return set((0, import_immer.default)(function(draft) {
          draft.dataNotify = dataNotify;
        }));
      },
      clearError: function() {
        return set((0, import_immer.default)(function(draft) {
          draft.errorData = {};
        }));
      },
      setError: function(id) {
        return set((0, import_immer.default)(function(draft) {
          draft.errorData = {
            id
          };
        }));
      },
      setCurrentPath: function(path) {
        return set((0, import_immer.default)(function(draft) {
          draft.currentPath = path;
        }));
      },
      setMenu: function(menuState, menuPosition, menuOpener) {
        return set((0, import_immer.default)(function(draft) {
          draft.menuState = menuState, draft.menuPosition = menuPosition || [
            -5e3,
            -5e3
          ], draft.menuOpener = menuOpener || "";
        }));
      },
      setInitialEdges: function(initialEdges) {
        return set((0, import_immer.default)(function(draft) {
          draft.initialEdges = initialEdges;
        }));
      },
      setInitialNodes: function(initialNodes) {
        return set((0, import_immer.default)(function(draft) {
          draft.initialNodes = initialNodes;
        }));
      },
      setCustomComponents: function(customComponents) {
        return set((0, import_immer.default)(function(draft) {
          draft.customComponents = customComponents;
        }));
      },
      appendCustomComponents: function(customComponents) {
        return set((0, import_immer.default)(function(draft) {
          var objectExists = function(arr, obj) {
            return arr.some(function(item) {
              return item.id === obj.id;
            });
          };
          customComponents.forEach(function(obj) {
            objectExists(draft.customComponents, obj) || draft.customComponents.push(obj);
          });
        }));
      },
      setNodeData: function(id, data) {
        return set((0, import_immer.default)(function(draft) {
          draft.nodeData = _object_spread_props(_object_spread({}, get().nodeData), _define_property({}, id, _object_spread({}, get().nodeData[id], data)));
        }));
      },
      setNodesMetaData: function(metadata) {
        return set((0, import_immer.default)(function(draft) {
          Object.keys(metadata).forEach(function(key) {
            draft.nodeData[key] || (draft.nodeData[key] = {}), draft.nodeData[key]._metadata = metadata[key];
          });
        }));
      },
      setNodesData: function(data) {
        return set((0, import_immer.default)(function(draft) {
          draft.nodeData = data;
        }));
      },
      deletePropNodeData: function(id, prop) {
        return set((0, import_immer.default)(function(draft) {
          var nData = _object_spread({}, get().nodeData[id]);
          Object.keys(nData).includes(prop) ? (delete nData[prop], draft.nodeData = _object_spread_props(_object_spread({}, draft.nodeData), _define_property({}, id, _object_spread({}, nData)))) : (console.error('Error deleting the following "Property Node Data": ' + id), draft.nodeData = _object_spread({}, draft.nodeData));
        }));
      },
      clearNodesData: function() {
        return set((0, import_immer.default)(function(draft) {
          var filteredData = {}, keys = Object.keys(get().nodeData).filter(function(key) {
            return !(key.startsWith("Object") || key.startsWith("ArrowFunction") || key.startsWith("TypeAliasDeclaration") || key.startsWith("InterfaceDeclaration") || key.startsWith("ObjectBindingPattern") || key.startsWith("JsxElement") || key.startsWith("JsxExpression") || key.startsWith("PropertyAssignment") || key.startsWith("FunctionDeclaration"));
          });
          keys.forEach(function(key) {
            filteredData[key] = get().nodeData[key];
          }), draft.nodeData = filteredData;
        }));
      },
      setSaveStatus: function(status) {
        return set((0, import_immer.default)(function(draft) {
          draft.saveStatus = status;
        }));
      },
      setThemeMode: function(theme, themeOverride, primaryColor) {
        return set((0, import_immer.default)(function(draft) {
          draft.themeMode = theme, draft.themeOverride = themeOverride, draft.primaryColor = primaryColor ?? "#ccc";
        }));
      },
      setMetadata: function(payload) {
        return set((0, import_immer.default)(function(draft) {
          draft.metadata = payload;
        }));
      }
    };
  });
}, FlowStoreContext = (0, import_react.createContext)(useFlowsStore());
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FlowStoreContext,
  useFlowsStore
});
//# sourceMappingURL=FlowsStore.js.map
