var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var utils_exports = {};
__export(utils_exports, {
  getDataFromField: () => getDataFromField,
  getEmptyFieldData: () => getEmptyFieldData,
  getFieldType: () => getFieldType,
  getFieldValue: () => getFieldValue
});
module.exports = __toCommonJS(utils_exports);
const getFieldType = (field) => {
  const prefix = field.split("-")[0];
  var type;
  switch (prefix) {
    case "mask":
    case "prop":
    case "param":
      type = "detailed";
      break;
    default:
      type = "literal";
      break;
  }
  return type;
}, getDataFromField = (fieldValue, field = void 0, nodeData = void 0, metadata = {}, forceKind) => {
  if (!field) return fieldValue;
  const prefix = field.split("-")[0], type = getFieldType(prefix);
  var data = nodeData[field];
  const kind = forceKind ?? data?.kind ?? metadata.kind ?? "StringLiteral";
  var nodeDataField;
  switch (type) {
    case "detailed":
      var key = data?.key ?? field.split("-")[1];
      nodeDataField = { ...data, key, kind, value: fieldValue };
      break;
    case "literal":
    default:
      nodeDataField = fieldValue;
      break;
  }
  return nodeDataField;
}, getFieldValue = (field, nodeData) => {
  const prefix = field.split("-")[0], type = getFieldType(prefix);
  var value;
  switch (type) {
    case "detailed":
      value = nodeData[field]?.value;
      break;
    case "literal":
    default:
      value = nodeData[field];
      break;
  }
  return value;
}, getEmptyFieldData = (field) => {
  const prefix = field.split("-")[0], type = getFieldType(prefix);
  var value;
  switch (type) {
    case "detailed":
      value = { key: "", value: "", kind: "StringLiteral" };
      break;
    case "literal":
    default:
      value = "";
      break;
  }
  return value;
};
//# sourceMappingURL=index.js.map
