var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var typesAndKinds_exports = {};
__export(typesAndKinds_exports, {
  dumpArgumentsData: () => dumpArgumentsData,
  getArgumentsData: () => getArgumentsData,
  getKindIcon: () => getKindIcon,
  getNextKind: () => getNextKind,
  getTypeByKind: () => getTypeByKind
});
module.exports = __toCommonJS(typesAndKinds_exports);
var import_lucide_icons = require("@tamagui/lucide-icons"), types = {
  string: {
    StringLiteral: {
      get: function(node) {
        return node == null ? void 0 : node.getLiteralValue().replace(/\\/g, "\\\\").replace(/"/g, '\\"');
      },
      dump: function(value) {
        return '"' + value.replace(/\\/g, "\\\\").replace(/"/g, '\\"') + '"';
      }
    }
  },
  number: {
    NumericLiteral: {
      get: function(node) {
        return node == null ? void 0 : node.getLiteralValue();
      }
    }
  },
  // dump: () => { }
  boolean: {
    FalseKeyword: {
      get: function(node) {
        return node == null ? void 0 : node.getLiteralValue();
      }
    },
    // dump: () => { }
    TrueKeyword: {
      get: function(node) {
        return node == null ? void 0 : node.getLiteralValue();
      }
    }
  },
  // dump: () => { }
  // "object": {
  //     "ObjectLiteralExpression": {
  //         get: () => { },
  //         dump: () => { }
  //     }
  // },
  code: {
    Identifier: {
      get: function(node) {
        return node.getText();
      }
    },
    // dump: () => { }
    NullKeyword: {
      get: function(node) {
        return node.getText();
      }
    },
    // dump: () => { }
    PropertyAccessExpression: {
      get: function(node) {
        return node.getText();
      }
    }
  }
}, typeKinds = Object.values(types).reduce(function(acc, curr) {
  return Object.assign(acc, curr);
}, {}), getKindByType = function(type) {
  return Object.keys(types[type])[0];
}, getTypeByKind = function(kind) {
  return Object.keys(types).find(function(t) {
    return Object.keys(types[t]).includes(kind);
  });
}, getArgumentsData = function(node) {
  var kind = node == null ? void 0 : node.getKindName(), typeKind = typeKinds[kind], value;
  if (typeKind)
    return value = typeKind.get(node), {
      kind,
      value
    };
}, dumpArgumentsData = function(data) {
  if (data) {
    var kind = data.kind, typeKind = typeKinds[kind], value = data.value;
    return typeKind && typeKind.dump ? typeKind.dump(value) : String(value);
  }
}, getNextKind = function(currentKind) {
  var currentType = getTypeByKind(currentKind), nextTypeIndex = Object.keys(types).indexOf(currentType) + 1, length = Object.keys(types).length, nextPos = nextTypeIndex % length, nextType = Object.keys(types)[nextPos];
  return getKindByType(nextType);
}, getKindIcon = function(kind) {
  var type = getTypeByKind(kind);
  switch (type) {
    case "string":
      return import_lucide_icons.Type;
    case "number":
      return import_lucide_icons.Hash;
    case "boolean":
      return import_lucide_icons.ToggleLeft;
    case "object":
      return import_lucide_icons.Braces;
    case "code":
      return import_lucide_icons.Code;
    default:
      return;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  dumpArgumentsData,
  getArgumentsData,
  getKindIcon,
  getNextKind,
  getTypeByKind
});
//# sourceMappingURL=typesAndKinds.js.map
