var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var FileBrowser_exports = {};
__export(FileBrowser_exports, {
  FileBrowser: () => FileBrowser
});
module.exports = __toCommonJS(FileBrowser_exports);
var import_stacks = require("@tamagui/stacks"), import_ui = require("@my/ui"), import_next_theme = require("@tamagui/next-theme"), import_FilesWidget = require("../../features/components/FilesWidget"), import_IconContainer = require("../../../components/IconContainer"), import_lucide_icons = require("@tamagui/lucide-icons"), import_usehooks_ts = require("usehooks-ts"), import_navigation = require("solito/navigation"), import_react = require("react"), import_Explorer = require("./Explorer"), import_fileActions = __toESM(require("@extensions/files/fileActions")), import_protobase = require("protobase"), import_usePendingEffect = require("../../../lib/usePendingEffect"), import_PromptAtom = require("../../../context/PromptAtom"), import_dynamic = require("next/dynamic"), import_jsx_runtime = require("react/jsx-runtime");
const logger = (0, import_protobase.getLogger)(), FileBrowser = ({ router, initialPath = "/", initialFile = "", initialFilesState, onOpenFile, onChangeSelection, selection, fileFilter, explorer }) => {
  const externalPathname = router?.pathname ?? "/files", solitoEnabled = !router, basePath = router ? externalPathname : "files", rawSearch = solitoEnabled ? (0, import_navigation.useSearchParams)() : null, searchParams = rawSearch && typeof rawSearch.entries == "function" ? rawSearch : { entries: () => [] }, baseQuery = router ? router.query : Object.fromEntries(searchParams.entries()), externalPath = baseQuery.path ?? initialPath, externalFile = baseQuery.file ?? initialFile, [filesState, setFilesState] = (0, import_react.useState)(initialFilesState ?? (0, import_protobase.getPendingResult)("pending")), [dialogOpen, setDialogOpen] = (0, import_react.useState)(!!externalFile), [currentPath, setCurrentPath] = (0, import_react.useState)(externalPath), [currentFile, setCurrentFile] = (0, import_react.useState)(externalFile), currentFileName = currentFile.split("/")[currentFile.split("/").length - 1], [openAlert, setOpenAlert] = (0, import_react.useState)(!1), [isModified, setIsModified] = (0, import_react.useState)(!1);
  (0, import_PromptAtom.usePrompt)(() => currentFile ? "" : `At this moment the user is using a web file manager. The file manager allows to view and manage the files and directories of the project.
    The web file managers allow to create, view and edit files, has an integrated source code editor, an integrated visual programming editor and allows to upload and download files from the system.
    Using the file manager you have full control of the system because you can directly edit any system file. Be careful when editing sensible files, like source code or system directories, you may break the system.
    There are interesting directories:
    - /data/databases contain the databases (leveldb files)
    - /apps contain the system applications (next, expo, proxy and express apis)
    - /apps/next/public publicly accesible directory. The files you upload here can be accessed from the public system url (its the public directory of the next app)
    - /packages/app the custom bundle. The system encourages extension through bundles, and the custom bundle is the bundle for your specific system. You can extend the system from this bundle, or create other bundles. bundles can add apis, pages, tasks, objects and more things 
    
    Currently the user is in the directory: ${currentPath}. 
    ${currentFile ? "The user is viewing the file" + currentFile : `The directory contents are: ${JSON.stringify(filesState)}`}
    `);
  const navigate = (url, replace = !1) => {
    if (router)
      replace ? router.replace(url) : router.push(url);
    else {
      const qs = url.split("?")[1] ?? "", p = new URLSearchParams(qs);
      setCurrentPath(p.get("path") ?? "/"), setCurrentFile(p.get("file") ?? "");
    }
  };
  (0, import_usehooks_ts.useUpdateEffect)(() => {
    import_protobase.API.get({ url: "/api/core/v1/files/" + currentPath }, setFilesState);
  }, [currentPath]), (0, import_usePendingEffect.usePendingEffect)(
    (s) => {
      import_protobase.API.get({ url: "/api/core/v1/files/" + currentPath }, s);
    },
    setFilesState,
    initialFilesState
  ), (0, import_usehooks_ts.useUpdateEffect)(() => {
    const q = new URLSearchParams({ path: currentPath });
    currentFile && q.set("file", currentFile), navigate(`${basePath}?${q.toString()}`, !1);
  }, [currentPath, currentFile]), (0, import_usehooks_ts.useUpdateEffect)(() => {
    externalPath !== currentPath && setCurrentPath(externalPath), externalFile !== currentFile && setCurrentFile(externalFile);
  }, [externalPath, externalFile]), (0, import_usehooks_ts.useUpdateEffect)(() => {
    currentFile ? setDialogOpen(!0) : (setDialogOpen(!1), navigate(`${basePath}?path=${currentPath}`, !0));
  }, [currentFile]);
  const onOpen = (file) => {
    if (file.isDir) return setCurrentPath(file.path ?? file.id);
    if (onOpenFile) return onOpenFile(file);
    navigate(
      `${basePath}?path=${currentPath.startsWith("/") ? currentPath : "/" + currentPath}&file=${file.name}`
    );
  }, { resolvedTheme } = (0, import_next_theme.useThemeSetting)(), isFull = !!currentFile, getWidget = () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_FilesWidget.FileWidget,
    {
      hideCloseIcon: !!isFull,
      isModified,
      setIsModified,
      icons: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_IconContainer.IconContainer, { onPress: () => {
          if (isModified) return setOpenAlert(!0);
          setCurrentFile(""), setDialogOpen(!1);
        }, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.X, { color: "var(--color)", size: "$1" }) })
      ],
      currentFileName,
      backgroundColor: isFull ? "$colorTransparent" : resolvedTheme == "dark" ? "#1e1e1e" : "white",
      currentFile,
      mt: 20
    }
  );
  return isFull ? getWidget() : /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_stacks.YStack, { overflow: "hidden", f: 1, backgroundColor: "$colorTransparent", pt: 4, pl: 4, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Explorer.Explorer,
      {
        currentPath,
        filesState,
        customActions: [...import_fileActions.default, ...explorer?.extraActions ?? []],
        onOpen,
        onChangeSelection,
        selection,
        fileFilter,
        ...explorer
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Dialog, { open: dialogOpen, onOpenChange: (state) => {
      setDialogOpen(state), setCurrentFile("");
    }, children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Dialog.Portal, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Overlay, {}),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Dialog.Content, { p: 0, backgroundColor: resolvedTheme == "dark" ? "#1e1e1e" : "white", height: "90%", width: "90%", children: [
          getWidget(),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Close, {})
        ] })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Adapt, { when: "sm", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Dialog.Sheet, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Sheet.Frame, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Adapt.Contents, {}) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Dialog.Sheet.Overlay, {})
      ] }) })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.AlertDialog, { open: openAlert, onOpenChange: setOpenAlert, native: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.AlertDialog.Portal, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_ui.AlertDialog.Overlay,
        {
          opacity: 0.5
        },
        "overlay"
      ),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_ui.AlertDialog.Content,
        {
          bordered: !0,
          elevate: !0,
          x: 0,
          scale: 1,
          opacity: 1,
          y: 0,
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_stacks.YStack, { space: !0, children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.AlertDialog.Description, { children: "The current file contains unsaved changes. Are you sure you want to close it without saving?" }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { space: "$3", justifyContent: "flex-end", children: [
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.AlertDialog.Cancel, { asChild: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { children: "Cancel" }) }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.AlertDialog.Action, { asChild: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: () => {
                setIsModified(!1), setCurrentFile(""), setDialogOpen(!1), setOpenAlert(!1);
              }, theme: "active", children: "Close file" }) })
            ] })
          ] })
        },
        "content"
      )
    ] }) })
  ] });
};
//# sourceMappingURL=FileBrowser.js.map
