var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var DataSheet_exports = {};
__export(DataSheet_exports, {
  DataSheet: () => DataSheet
});
module.exports = __toCommonJS(DataSheet_exports);
var import_ui = require("@my/ui"), import_react = require("react"), import_table = require("@blueprintjs/table"), import_core = require("@blueprintjs/core"), import_Tinted = require("./Tinted"), import_DataTableList = require("./DataTableList"), import_next_theme = require("@tamagui/next-theme"), import_jsx_runtime = require("react/jsx-runtime");
const validTypes = ["ZodString", "ZodNumber", "ZodBoolean", "ZodDate"], widthTypes = {
  ZodString: 250,
  ZodNumber: 100,
  ZodBoolean: 100,
  ZodDate: 200
}, DataSheet = ({ items, model, sourceUrl, name, lineSelect, sheetProps, onRowSelect, fillWidth, ...props }) => {
  const containerRef = (0, import_react.useRef)(null), fields = model.getObjectSchema().isDisplay("sheet"), keys = Object.keys(fields.shape).filter((key) => {
    const def = fields.shape[key]._def?.innerType?._def ?? fields.shape[key]._def;
    return def?.typeName === "ZodArray" ? validTypes.includes(def?.type?._def?.typeName) : validTypes.includes(def?.typeName);
  }), columnsArr = keys.map((key) => {
    const def = fields.shape[key]._def?.innerType?._def ?? fields.shape[key]._def;
    return { type: def.typeName, width: def.columnWidth, key, def };
  });
  console.log("Columns", columnsArr);
  const [selectedRegions, setSelectedRegions] = (0, import_react.useState)([]), [columnWidths, setColumnWidths] = (0, import_react.useState)(columnsArr.map((element) => element.width ?? widthTypes[element.type] ?? 200)), [manualColumnWidths, setManualColumnWidths] = (0, import_react.useState)({}), [multiplier, setMultiplier] = (0, import_react.useState)(0), columns = columnsArr.reduce((acc, element) => ({ ...acc, [element.key]: element }), {}), { resolvedTheme } = (0, import_next_theme.useThemeSetting)();
  return (0, import_react.useLayoutEffect)(() => {
    const resizeObserver = new ResizeObserver(() => {
      if (fillWidth) {
        const totalWidth = columnWidths.reduce((acc, width) => acc + width, 0), availWidth = containerRef.current.offsetWidth - 32;
        totalWidth < availWidth ? setMultiplier(availWidth / totalWidth) : setMultiplier(1);
      }
    });
    return resizeObserver.observe(containerRef.current), () => {
      resizeObserver.disconnect();
    };
  }, []), /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Stack, { ref: containerRef, f: 1, ...props, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_core.HotkeysProvider, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: multiplier && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_table.Table2,
    {
      className: resolvedTheme == "dark" ? "bp5-dark" : "",
      cellRendererDependencies: [items],
      selectedRegions,
      onSelection: (regions) => {
        if (!lineSelect)
          setSelectedRegions(regions);
        else {
          if (!regions[0].rows) return;
          setSelectedRegions([{
            rows: regions[0].rows,
            cols: [0, keys.length - 1]
          }]), onRowSelect(model.load(items[regions[0].rows[0]]));
        }
      },
      enableMultipleSelection: !lineSelect,
      columnWidths: columnWidths.reduce((acc, width, i) => [...acc, manualColumnWidths[i] ?? width * multiplier], []),
      onColumnWidthChanged: (index, size) => {
        const newColumnsWidth = columnWidths.map((width, i) => i === index ? size : width);
        setColumnWidths(newColumnsWidth), setManualColumnWidths({ ...manualColumnWidths, [index]: size });
      },
      numRows: items.length,
      ...sheetProps,
      children: keys.map((key, index) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_table.Column, { name: key, cellRenderer: (rowIndex) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_table.Cell, { children: [
        " ",
        (0, import_DataTableList.getFieldPreview)(key, items[rowIndex], columns[key].def, !0)
      ] }) }, index))
    }
  ) }) }) });
};
//# sourceMappingURL=DataSheet.js.map
