var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Filters_exports = {};
__export(Filters_exports, {
  Filters: () => Filters,
  QueryFilters: () => QueryFilters
});
module.exports = __toCommonJS(Filters_exports);
var import_datepickers = require("./datepickers"), import_Tinted = require("./Tinted"), import_SelectList = require("./SelectList"), import_lucide_icons = require("@tamagui/lucide-icons"), import_ui = require("@my/ui"), import_react = require("react"), import_next = require("../next"), import_Chip = require("./Chip"), import_jsx_runtime = require("react/jsx-runtime");
const QueryFilters = ({ state, extraFilters }) => {
  const { removePush, query } = (0, import_next.usePageParams)(state), queryKeys = Object.keys(query), extraFiltersKeys = extraFilters?.map((extraFilter) => extraFilter.queryParam), queryFilters = queryKeys.filter((q) => q.startsWith("filter") || extraFiltersKeys?.includes(q));
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { gap: "$2", mt: "$2", flexWrap: "wrap", f: 1, children: queryFilters.map(
    (q, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Tooltip, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Tooltip.Trigger, { cursor: "pointer", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Chip.Chip, { color: "$color6", text: q.replace("filter[", "").replace("]", ""), textProps: { fontWeight: "600", fontSize: 12 }, gap: "$2", pl: "$1", pr: "$3", py: "$1", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: () => removePush(q), size: "$1", circular: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.X, { size: 12, color: "var(--color8)" }) }) }) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_ui.Tooltip.Content,
        {
          enterStyle: { x: 0, y: -5, opacity: 0, scale: 0.9 },
          exitStyle: { x: 0, y: -5, opacity: 0, scale: 0.9 },
          scale: 1,
          backgroundColor: "$color9",
          x: 0,
          y: 5,
          opacity: 1,
          zIndex: 9999999999,
          animation: [
            "quick",
            {
              opacity: {
                overshootClamping: !0
              }
            }
          ],
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fontSize: 12, color: "white", children: query[q] })
        }
      )
    ] })
  ) });
}, Filters = ({ model, state, customFilters, extraFilters }) => {
  const [open, setOpen] = (0, import_react.useState)(!1), { push, removePush, query } = (0, import_next.usePageParams)(state), schema = model.getObjectSchema(), onClear = () => {
    removePush(Object.keys(query).filter((q) => q.startsWith("filter")));
  }, getExtraFilter = (extraFilter) => {
    const key = extraFilter.queryParam, changesFilterExtra = (value) => {
      value !== void 0 ? push(key, value) : removePush(key);
    };
    var currentValue = query[key];
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      !extraFilter.hideLabel && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { children: extraFilter.label ?? key }),
      extraFilter.component(currentValue, changesFilterExtra)
    ] });
  }, getFilter = (def, key) => {
    var value = query[`filter[${key}]`];
    def?.typeName === "ZodBoolean" && (value = value == "true");
    const onFilter = (value2) => {
      value2 !== void 0 ? push(`filter[${key}]`, value2) : removePush(`filter[${key}]`);
    };
    if (def.filter == !1) return;
    const customFilter = customFilters[key];
    if (customFilters && customFilter && customFilter.component)
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        !customFilter.hideLabel && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { children: customFilter.label ?? key }),
        customFilter.component(value, onFilter)
      ] });
    if (def?.typeName === "ZodBoolean")
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { children: key }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_ui.Checkbox,
          {
            checked: value,
            onCheckedChange: (val) => onFilter(val),
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Checkbox.Indicator, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Check, {}) })
          }
        )
      ] });
    if (def?.typeName === "ZodDate")
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { children: key }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_datepickers.DatePicker,
          {
            selectedDates: value ? [new Date(value)] : [],
            onDatesChange: ([selectedDate]) => onFilter(selectedDate ? new Date(selectedDate).toISOString() : void 0)
          }
        )
      ] });
    if (def?.typeName === "ZodUnion") {
      const options = def.options?.map((option) => option._def.value);
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { children: key }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_SelectList.SelectList,
          {
            value,
            title: key,
            elements: options,
            setValue: (val) => onFilter(val)
          }
        )
      ] });
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_ui.Popover,
    {
      open,
      onOpenChange: setOpen,
      size: "$5",
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Trigger, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: () => setOpen(!open), transparent: !0, circular: !0, icon: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Filter, { fillOpacity: 0, color: "$color10", size: 16 }) }) }) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
          import_ui.Popover.Content,
          {
            backgroundColor: "$backgroundStrong",
            borderWidth: 1,
            borderColor: "$borderColor",
            elevate: !0,
            mr: "$4",
            maxWidth: "350px",
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Arrow, { ml: "$4", borderWidth: 1, borderColor: "$borderColor" }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { miw: "$20", gap: "$2", children: [
                /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fontWeight: "bold", children: "Filters" }),
                /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { gap: "$2", mt: "$2", flexWrap: "wrap", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(QueryFilters, { state, extraFilters }) }) }, "filter"),
                /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { overflow: "scroll", overflowX: "hidden", p: "2px", maxHeight: "300px", children: [
                  Object.keys(schema.shape).map((key) => {
                    const def = schema.shape[key]._def?.innerType?._def ?? schema.shape[key]._def;
                    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: getFilter(def, key) });
                  }),
                  extraFilters?.map((extraFilter) => {
                    if (!(!extraFilter.queryParam || !extraFilter.component))
                      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: getExtraFilter(extraFilter) });
                  })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { mt: "$4", jc: "flex-end", gap: "$3", p: "$3", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: onClear, children: "Clear" }) }) })
              ] })
            ]
          }
        )
      ]
    }
  );
};
//# sourceMappingURL=Filters.js.map
