var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Grid_exports = {};
__export(Grid_exports, {
  Grid: () => Grid,
  useScroller: () => useScroller,
  useSize: () => useSize
});
module.exports = __toCommonJS(Grid_exports);
var import_core = require("@tamagui/core"), import_stacks = require("@tamagui/stacks"), import_react = __toESM(require("react")), import_ui = require("@my/ui"), import_masonic = require("masonic"), import_jsx_runtime = require("react/jsx-runtime");
const defaultSize = { width: 0, height: 0 }, useSize = (ref, deps = []) => {
  const [size, setSize] = (0, import_react.useState)(defaultSize);
  return (0, import_react.useLayoutEffect)(() => {
    const { current } = ref;
    if (current) {
      const handleResize = () => {
        const computedStyle = getComputedStyle(current), float = parseFloat, width = current.clientWidth - float(computedStyle.paddingTop) - float(computedStyle.paddingBottom), height = current.clientHeight - float(computedStyle.paddingLeft) - float(computedStyle.paddingRight);
        setSize({ height, width });
      };
      return handleResize(), window.addEventListener("resize", handleResize), window.addEventListener("orientationchange", handleResize), () => {
        window.removeEventListener("resize", handleResize), window.removeEventListener("orientationchange", handleResize);
      };
    }
  }, deps.concat(ref.current)), size;
}, useScroller = (ref) => {
  const [isScrolling, setIsScrolling] = (0, import_react.useState)(!1), [scrollTop, setScrollTop] = (0, import_react.useState)(0);
  return (0, import_react.useLayoutEffect)(() => {
    const { current } = ref;
    let tick;
    if (current) {
      const scrollAbleNode = current, handleScroll = () => {
        tick || (tick = window.requestAnimationFrame(() => {
          setScrollTop(scrollAbleNode.scrollTop), tick = void 0;
        }));
      };
      return scrollAbleNode.addEventListener("scroll", handleScroll), () => {
        scrollAbleNode.removeEventListener("scroll", handleScroll), tick && window.cancelAnimationFrame(tick);
      };
    }
  }, [ref.current]), (0, import_react.useLayoutEffect)(() => {
    setIsScrolling(!0);
    const to = window.setTimeout(() => {
      setIsScrolling(!1);
    }, 1e3 / 6);
    return () => window.clearTimeout(to);
  }, [scrollTop]), { scrollTop, isScrolling };
}, Grid = import_react.default.forwardRef(({ overScanBy = 5, masonry = !0, containerRef, rightGap = 0, spacing, children, data, card, columns, itemMinWidth = 200, gap }, ref) => {
  if (import_core.isWeb && data && card) {
    if (masonry && containerRef) {
      const container = { current: containerRef.current?.container ? containerRef?.current?.container.firstChild : containerRef.current }, { width, height } = useSize(container), { scrollTop, isScrolling } = useScroller(container), positioner = (0, import_masonic.usePositioner)(
        { width: Math.max(0, width - rightGap), columnGutter: spacing, columnWidth: itemMinWidth }
      ), resizeObserver = (0, import_masonic.useResizeObserver)(positioner);
      return (0, import_masonic.useMasonry)(
        {
          positioner,
          scrollTop,
          isScrolling,
          height,
          items: data,
          overscanBy: overScanBy,
          resizeObserver,
          render: card
        }
      );
    }
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_stacks.XStack, { flexWrap: "wrap", children: data.map((ele, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Stack, { m: spacing / 2, children: [
      " ",
      import_react.default.createElement(card, { index: ele.index, data: { ...ele }, width: itemMinWidth, columns }),
      " "
    ] }, i)) });
  } else if (import_core.isWeb)
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "div",
      {
        ref,
        style: {
          gap,
          display: "grid",
          //   justifyContent: 'stretch',
          // gridTemplateRows: 'repeat(4, 1fr)',
          gridTemplateColumns: `repeat( auto-fill, minmax(${itemMinWidth}px, 1fr) )`
          // gridTemplateColumns: '1fr 1fr',
        },
        children
      }
    );
  const childrenList = import_react.default.Children.toArray(children);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_stacks.XStack, { alignItems: "center", justifyContent: "center", flexWrap: "wrap", children: childrenList.map((child, i) => child ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_stacks.XStack,
    {
      flex: 1,
      minWidth: itemMinWidth,
      marginRight: gap,
      marginBottom: gap,
      children: child
    },
    i
  ) : null) });
});
//# sourceMappingURL=Grid.js.map
