var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var LogPanel_exports = {};
__export(LogPanel_exports, {
  LogPanel: () => LogPanel
});
module.exports = __toCommonJS(LogPanel_exports);
var import_ui = require("@my/ui"), import_JSONView = require("./JSONView"), import_Tints = require("../lib/Tints"), import_GroupButton = require("./GroupButton"), import_ButtonGroup = require("./ButtonGroup"), import_InteractiveIcon = require("./InteractiveIcon"), import_lucide_icons = require("@tamagui/lucide-icons"), import_Tinted = require("./Tinted"), import_jotai = require("jotai"), import_react = require("react"), import_react2 = __toESM(require("react")), import_mqtt = require("../lib/mqtt"), import_jsx_runtime = require("react/jsx-runtime");
const types = {
  10: { name: "TRACE", color: "$green3", icon: import_lucide_icons.Microscope },
  20: { name: "DEBUG", color: "$color4", icon: import_lucide_icons.Bug },
  30: { name: "INFO", color: "$color7", icon: import_lucide_icons.Info },
  40: { name: "WARN", color: "$yellow7", icon: import_lucide_icons.AlertCircle },
  50: { name: "ERROR", color: "$red7", icon: import_lucide_icons.XCircle },
  60: { name: "FATAL", color: "$red10", icon: import_lucide_icons.Bomb }
}, MessageList = import_react2.default.memo(({ data, topic }) => {
  const from = topic.split("/")[1], type = topic.split("/")[2], Icon = types[type]?.icon, message = JSON.parse(data), { level, time, pid, hostname, msg, name, ...cleanData } = message;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_ui.XStack,
    {
      p: "$3",
      ml: "$0",
      ai: "center",
      jc: "center",
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { left: -12, hoverStyle: { bc: "$color6" }, cursor: "pointer", ai: "center", mb: "$2", py: 3, px: "$2", width: "fit-content", ml: "$3", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { ai: "center", hoverStyle: { o: 1 }, o: 0.9, children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { mr: "$2", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Icon, { size: 20, strokeWidth: 2, color: types[type]?.color }) }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Text, { o: 0.7, fontSize: 14, fontWeight: "500", children: [
            "[",
            from,
            "]"
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { ml: "$3", o: 0.9, fontSize: 14, fontWeight: "500", children: msg })
        ] }) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_JSONView.JSONView,
          {
            src: cleanData
          }
        )
      ] })
    }
  );
}), LogPanel = ({ AppState }) => {
  const [state, setAppState] = (0, import_jotai.useAtom)(AppState), appState = state, { messages, setMessages } = (0, import_mqtt.useSubscription)("logs/#"), [filteredMessages, setFilteredMessages] = (0, import_react.useState)([]), [search, setSearch] = (0, import_react.useState)(""), initialLevels = ["info", "warn", "error", "fatal"];
  (0, import_react.useEffect)(() => {
    setFilteredMessages(messages.filter((m) => {
      const topic = m?.topic, from = topic.split("/")[1], type = types[topic.split("/")[2]];
      return type && JSON.stringify(m).toLowerCase().includes(search.toLocaleLowerCase()) && appState.levels.includes(type.name.toLocaleLowerCase());
    }));
  }, [search, messages, appState.levels]), (0, import_react.useEffect)(() => {
    appState.levels || setAppState({ ...appState, levels: initialLevels });
  }, [appState.levels]);
  const { tint } = (0, import_Tints.useTint)(), toggleLevel = (level) => {
    const { levels } = appState;
    setAppState({
      ...appState,
      levels: levels.includes(level) ? levels.filter((l) => l !== level) : [...levels, level]
    });
  }, hoverStyle = import_react2.default.useMemo(() => ({ bc: "$" + tint + "4" }), [tint]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { ai: "center", backgroundColor: "$backgroundTransparent", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_ui.Input,
        {
          focusStyle: { borderLeftWidth: 0, borderRightWidth: 0, borderTopWidth: 0, borderBottomWidth: 1, outlineWidth: 0 },
          borderBottomWidth: 1,
          forceStyle: "focus",
          br: 0,
          backgroundColor: "$backgroundTransparent",
          value: search,
          width: "100%",
          onChangeText: (text) => {
            setSearch(text);
          },
          placeholder: "Filter logs...",
          bw: 0,
          paddingLeft: 80
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover, { placement: "bottom-start", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Trigger, { position: "absolute", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_InteractiveIcon.InteractiveIcon, { size: 20, Icon: import_lucide_icons.Ban, onPress: () => setMessages([]) }) }) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Popover, { placement: "bottom-start", children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Trigger, { position: "absolute", left: 35, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_InteractiveIcon.InteractiveIcon, { size: 20, Icon: import_lucide_icons.Filter }) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Popover.Content, { padding: 0, space: 0, bw: 1, boc: "$borderColor", bc: "$color1", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ButtonGroup.ButtonGroup, { mode: "vertical", children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("trace"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("trace"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Microscope, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Trace" })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("debug"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("debug"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Bug, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Debug" })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("info"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("info"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Info, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Info" })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("warn"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("warn"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.AlertCircle, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Warn" })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("error"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("error"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.XCircle, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Error" })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_GroupButton.GroupButton, { onPress: () => toggleLevel("fatal"), jc: "flex-start", inActive: !appState.levels || !appState.levels.includes("fatal"), children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Bomb, { size: "$1", strokeWidth: 1 }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Fatal" })
          ] })
        ] }) })
      ] })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.ScrollView, { bc: "transparent", f: 1, height: "calc( 100vh - 130px )", children: filteredMessages.map((m, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { bc: "transparent", hoverStyle, btw: 0, bbw: 1, boc: "$color4", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(MessageList, { data: m.message, topic: m.topic }) }) }, i)) })
  ] });
};
//# sourceMappingURL=LogPanel.js.map
