var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var MapViewGoogle_exports = {};
__export(MapViewGoogle_exports, {
  MapViewGoogle: () => MapViewGoogle
});
module.exports = __toCommonJS(MapViewGoogle_exports);
var import_ui = require("@my/ui"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_api = require("@react-google-maps/api"), import_next_theme = require("@tamagui/next-theme"), import_Tints = require("../lib/Tints"), import_Center = __toESM(require("./Center")), import_jsx_runtime = require("react/jsx-runtime");
const containerStyle = {
  width: "100%",
  height: "100%"
};
function metersToDegrees(lat, dx, dy) {
  const dLat = dy / 6378137 * (180 / Math.PI), dLon = dx / 6378137 * (180 / Math.PI) / Math.cos(lat * Math.PI / 180);
  return { dLat, dLon };
}
function createBox(lat, lon, w, h) {
  let { dLat, dLon } = metersToDegrees(lat, w / 2, h / 2);
  return [
    { lat: lat - dLat, lng: lon - dLon },
    { lat: lat - dLat, lng: lon + dLon },
    { lat: lat + dLat, lng: lon + dLon },
    { lat: lat + dLat, lng: lon - dLon },
    { lat: lat - dLat, lng: lon - dLon }
  ];
}
const MapViewGoogle = ({
  items,
  layerToggle = !0,
  model,
  ...props
}) => {
  const { resolvedTheme } = (0, import_next_theme.useThemeSetting)(), { tint } = (0, import_Tints.useTint)(), [satellite, setSatellite] = (0, import_react.useState)(!1), center = { lat: 41.3875, lng: 2.1688 }, { isLoaded, loadError } = (0, import_api.useLoadScript)({
    googleMapsApiKey: process.env.NEXT_PUBLIC_GOOGLE_MAPS_TOKEN || "",
    libraries: ["places"]
  }), locationItems = (0, import_react.useMemo)(
    () => items.data.items.map((raw) => ({ modelItem: model.load(raw) })).map((it) => ({ ...it, location: it.modelItem.getLocation() })).filter((it) => it.location),
    [items.data.items]
  ), pins = locationItems.filter((it) => it.location.options?.mode !== "geo").map((it, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_api.Marker,
    {
      position: {
        lat: parseFloat(it.location.lat),
        lng: parseFloat(it.location.lon)
      }
    },
    i
  )), polygons = (0, import_react.useMemo)(
    () => locationItems.filter((it) => it.location.options?.mode === "geo").map((it) => {
      const { lat, lon, options = {} } = it.location, width = options.width || 100, height = options.height || 100, box = createBox(parseFloat(lat), parseFloat(lon), width, height);
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_api.Polygon,
        {
          paths: box,
          options: {
            fillColor: "#00aaff",
            fillOpacity: 0.5,
            strokeColor: "#0088dd",
            strokeOpacity: 1,
            strokeWeight: 1
          }
        },
        it.modelItem.getId()
      );
    }),
    [locationItems]
  );
  return loadError ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { f: 1, ai: "center", jc: "center", space: "$4", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Center.default, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.AlertTriangle, { size: "$7" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.H2, { mt: "$6", children: "Google Maps failed to load" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Paragraph, { ta: "center", mt: "$6", size: "$7", children: "Please check your API key or internet connection." })
  ] }) }) : /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Stack, { f: 1, ...props, children: [
    layerToggle && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { pos: "absolute", t: 10, l: 10, zi: 10, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("button", { onClick: () => setSatellite(!satellite), children: satellite ? "\u{1F5FA}\uFE0F" : "\u{1F6F0}\uFE0F" }) }),
    isLoaded ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      import_api.GoogleMap,
      {
        mapContainerStyle: containerStyle,
        center,
        zoom: 16,
        mapTypeId: satellite ? "hybrid" : "roadmap",
        options: { tilt: 0, heading: 0, mapTypeControl: !1 },
        children: [
          pins,
          polygons
        ]
      }
    ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { f: 1, ai: "center", jc: "center", space: "$4", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Center.default, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Paragraph, { children: "Loading Google Maps..." }) }) })
  ] });
};
//# sourceMappingURL=MapViewGoogle.js.map
