var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var MapViewMapBox_exports = {};
__export(MapViewMapBox_exports, {
  MapViewMapBox: () => MapViewMapBox
});
module.exports = __toCommonJS(MapViewMapBox_exports);
var import_ui = require("@my/ui"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_react_map_gl = require("react-map-gl"), import_next_theme = require("@tamagui/next-theme"), import_EditableObject = require("./EditableObject"), import_protobase = require("protobase"), import_Tinted = require("./Tinted"), import_Tints = require("../lib/Tints"), import_Center = __toESM(require("./Center")), import_jsx_runtime = require("react/jsx-runtime");
function metersToDegrees(lat, dx, dy) {
  const dLat = dy / 6378137 * (180 / Math.PI), dLon = dx / 6378137 * (180 / Math.PI) / Math.cos(lat * Math.PI / 180);
  return { dLat, dLon };
}
function createBox(lat, lon, w, h) {
  const { dLat, dLon } = metersToDegrees(lat, w / 2, h / 2);
  return [
    [lon - dLon, lat - dLat],
    [lon + dLon, lat - dLat],
    [lon + dLon, lat + dLat],
    [lon - dLon, lat + dLat],
    [lon - dLon, lat - dLat]
  ];
}
const MapViewMapBox = ({
  items,
  layerToggle = !0,
  model,
  sourceUrl,
  extraFields,
  icons,
  customFields,
  onDelete,
  deleteable,
  extraMenuActions,
  ...props
}) => {
  const { resolvedTheme } = (0, import_next_theme.useThemeSetting)(), { tint } = (0, import_Tints.useTint)(), mapRef = (0, import_react.useRef)(null), [popupInfo, setPopupInfo] = (0, import_react.useState)(null), [satellite, setSatellite] = (0, import_react.useState)(!1), [viewport, setViewport] = (0, import_react.useState)({
    latitude: 41.3875,
    longitude: 2.1688,
    zoom: 16
  }), locationItems = (0, import_react.useMemo)(
    () => items.data.items.map((raw) => ({ modelItem: model.load(raw) })).map((it) => ({ ...it, location: it.modelItem.getLocation() })).filter((it) => it.location),
    [items.data.items]
  ), pins = (0, import_react.useMemo)(
    () => locationItems.filter((it) => it.location.options?.mode !== "geo").map((it, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_react_map_gl.Marker,
      {
        longitude: parseFloat(it.location.lon),
        latitude: parseFloat(it.location.lat),
        anchor: "center",
        onClick: (e) => {
          e.originalEvent.stopPropagation(), setPopupInfo(it);
        },
        children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: {
          width: 20,
          height: 20,
          borderRadius: "50%",
          backgroundColor: `var(--${tint}10)`,
          border: `2px solid var(--${tint}8)`,
          boxShadow: `0 0 4px var(--${tint}6)`,
          cursor: "pointer",
          ...it.location.style
        } })
      },
      i
    )),
    [locationItems, tint]
  ), geojson = (0, import_react.useMemo)(() => ({
    type: "FeatureCollection",
    features: locationItems.filter((it) => it.location.options?.mode === "geo").map((it) => {
      const { lat, lon, options = {} } = it.location, width = options.width || 100, height = options.height || 100;
      return {
        type: "Feature",
        geometry: {
          type: "Polygon",
          coordinates: [createBox(parseFloat(lat), parseFloat(lon), width, height)]
        },
        properties: { id: it.modelItem.getId() }
      };
    })
  }), [locationItems]), addGeoLayer = (0, import_react.useCallback)(() => {
    const map = mapRef.current;
    if (!map || !map.isStyleLoaded()) return;
    try {
      map.getLayer("geo-areas-layer") && map.removeLayer("geo-areas-layer"), map.getSource("geo-areas") && map.removeSource("geo-areas");
    } catch {
    }
    map.addSource("geo-areas", {
      type: "geojson",
      data: geojson
    });
    const symbolLayer = map.getStyle().layers?.find((l) => l.type === "symbol");
    map.addLayer({
      id: "geo-areas-layer",
      type: "fill",
      source: "geo-areas",
      paint: {
        "fill-color": "#00aaff",
        "fill-opacity": 0.5,
        "fill-outline-color": "#0088dd"
      }
    }, symbolLayer?.id);
  }, [geojson]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Stack, { f: 1, ...props, children: [
    layerToggle && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { pos: "absolute", t: 10, l: 10, zi: 10, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("button", { onClick: () => setSatellite((s) => !s), children: satellite ? "\u{1F5FA}\uFE0F" : "\u{1F6F0}\uFE0F" }) }),
    process.env.NEXT_PUBLIC_MAPBOX_TOKEN && process.env.NEXT_PUBLIC_MAPBOX_TOKEN !== "PUT_HERE_YOUR_API_KEY" ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      import_react_map_gl.Map,
      {
        ref: (map) => {
          map && map.getMap && (mapRef.current = map.getMap());
        },
        onLoad: () => addGeoLayer(),
        onMove: (evt) => {
          const v = evt.viewState;
          setViewport({ latitude: v.latitude, longitude: v.longitude, zoom: v.zoom });
        },
        mapboxAccessToken: process.env.NEXT_PUBLIC_MAPBOX_TOKEN,
        mapLib: import("mapbox-gl"),
        initialViewState: viewport,
        mapStyle: satellite ? "mapbox://styles/mapbox/satellite-streets-v12" : resolvedTheme === "dark" ? "mapbox://styles/mapbox/dark-v11" : "mapbox://styles/mapbox/light-v11",
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_map_gl.GeolocateControl, { position: "top-right" }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_map_gl.FullscreenControl, { position: "top-right" }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_map_gl.NavigationControl, { position: "top-right" }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: pins }),
          popupInfo && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_react_map_gl.Popup,
            {
              anchor: "top",
              longitude: +popupInfo.location.lon,
              latitude: +popupInfo.location.lat,
              onClose: () => setPopupInfo(null),
              closeButton: !1,
              style: { minWidth: 320 },
              children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { f: 1, ai: "center", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                import_EditableObject.EditableObject,
                {
                  initialData: (0, import_protobase.getPendingResult)("loaded", popupInfo.modelItem.read()),
                  name: popupInfo.modelItem.getId(),
                  spinnerSize: 15,
                  loadingText: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { ai: "center", children: "Loading..." }),
                  objectId: popupInfo.modelItem.getId(),
                  sourceUrl: `${sourceUrl}/${popupInfo.modelItem.getId()}`,
                  mode: "preview",
                  model,
                  extraFields,
                  icons,
                  customFields,
                  columnWidth: 290,
                  onDelete,
                  deleteable,
                  extraMenuActions,
                  onSave: () => {
                  }
                }
              ) })
            }
          )
        ]
      },
      `map-${satellite}-${resolvedTheme}`
    ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { f: 1, ai: "center", jc: "center", space: "$4", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Center.default, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.AlertTriangle, { size: "$7" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.H2, { mt: "$6", children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Missing " }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { color: "var(--color10)", children: "API Key" }) })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Paragraph, { ta: "center", mt: "$6", size: "$7", children: "Map rendering is unavailable without a Mapbox access token." })
    ] }) })
  ] });
};
//# sourceMappingURL=MapViewMapBox.js.map
