var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Monaco_exports = {};
__export(Monaco_exports, {
  Monaco: () => Monaco
});
module.exports = __toCommonJS(Monaco_exports);
var import_react = __toESM(require("@monaco-editor/react")), import_react_use_keypress = __toESM(require("react-use-keypress")), import_next_theme = require("@tamagui/next-theme"), import_ui = require("@my/ui"), import_Tints = require("../lib/Tints"), import_Tinted = require("./Tinted"), import_react2 = require("react"), import_jsx_runtime = require("react/jsx-runtime");
function hslToRgb(h, s, l) {
  let r, g, b;
  if (s === 0)
    r = g = b = l;
  else {
    const hue2rgb = (p2, q2, t) => (t < 0 && (t += 1), t > 1 && (t -= 1), t < 0.16666666666666666 ? p2 + (q2 - p2) * 6 * t : t < 0.5 ? q2 : t < 0.6666666666666666 ? p2 + (q2 - p2) * (0.6666666666666666 - t) * 6 : p2), q = l < 0.5 ? l * (1 + s) : l + s - l * s, p = 2 * l - q;
    r = hue2rgb(p, q, h + 1 / 3), g = hue2rgb(p, q, h), b = hue2rgb(p, q, h - 1 / 3);
  }
  return [Math.round(r * 255), Math.round(g * 255), Math.round(b * 255)];
}
function hslStringToHex(hslStr) {
  const matches = hslStr.match(/^hsl\((\d+),\s*([\d.]+)%,\s*([\d.]+)%\)$/i);
  if (!matches) return null;
  const [h, s, l] = [matches[1] / 360, matches[2] / 100, matches[3] / 100], [r, g, b] = hslToRgb(h, s, l);
  return `#${((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1).toUpperCase()}`;
}
const Monaco = ({
  path = "",
  sourceCode,
  onChange = () => {
  },
  onSave = () => {
  },
  onEscape = () => {
  },
  colors = {},
  ...props
}) => {
  const { resolvedTheme } = (0, import_next_theme.useThemeSetting)(), monaco = (0, import_react.useMonaco)(), customThemeName = "myCustomTheme", theme = (0, import_ui.useTheme)(), { tint } = (0, import_Tints.useTint)();
  let tokenColor = theme[tint + "10"].val;
  tokenColor = tokenColor.startsWith("hsl") ? hslStringToHex(tokenColor) : tokenColor;
  let lightTokenColor = theme[tint + "7"].val;
  lightTokenColor = lightTokenColor.startsWith("hsl") ? hslStringToHex(lightTokenColor) : lightTokenColor, (0, import_react2.useEffect)(() => {
    monaco && (monaco.editor.defineTheme(customThemeName, {
      base: resolvedTheme === "dark" ? "vs-dark" : "vs",
      inherit: !0,
      rules: [
        { token: "keyword", foreground: tokenColor },
        { token: "inKeyword", foreground: lightTokenColor },
        { token: "punctuation", foreground: tokenColor }
      ],
      colors: {
        "editor.background": resolvedTheme === "dark" ? "#151515" : "#FFFFFF",
        ...colors
      }
    }), monaco.languages.getLanguages().some((lang) => lang.id === "gherkin") || (monaco.languages.register({ id: "gherkin" }), monaco.languages.setMonarchTokensProvider("gherkin", {
      tokenizer: {
        root: [
          [/(Feature:|Scenario:|Rule:|Example:)/, "comment"],
          [/(Given|When|Then|And|But)/, "keyword"],
          [/"[^"]*"/, "string"],
          [/#.*/, "comment"]
        ]
      }
    })));
  }, [monaco, resolvedTheme, tokenColor, lightTokenColor]);
  const handleEditorDidMount = (editor, monaco2) => {
    monaco2.languages.typescript.javascriptDefaults.setDiagnosticsOptions({
      noSemanticValidation: !0,
      noSyntaxValidation: !0
    }), monaco2.languages.typescript.typescriptDefaults.setDiagnosticsOptions({
      noSemanticValidation: !0,
      noSyntaxValidation: !0
    });
  };
  onSave && (0, import_react_use_keypress.default)(["s", "S"], (event) => {
    (event.key === "s" || event.key === "S") && (event.ctrlKey || event.metaKey) && (event.preventDefault(), onSave());
  }), onEscape && (0, import_react_use_keypress.default)(["Escape"], (event) => {
    event.key === "Escape" && (event.preventDefault(), onEscape());
  });
  const extensionToLang = {
    feature: "gherkin"
  }, ext = path.split(".").pop();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_react.default,
    {
      onMount: handleEditorDidMount,
      path,
      theme: monaco ? customThemeName : void 0,
      value: sourceCode,
      onChange,
      defaultLanguage: extensionToLang[ext],
      ...props
    }
  ) });
};
//# sourceMappingURL=Monaco.js.map
