var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var ObjectForm_exports = {};
__export(ObjectForm_exports, {
  ObjectForm: () => ObjectForm
});
module.exports = __toCommonJS(ObjectForm_exports);
var import_react = __toESM(require("react")), import_EditableObject = require("./EditableObject"), import_protobase = require("protobase"), import_protobase2 = require("protobase"), import_ui = require("@my/ui"), import_jsx_runtime = require("react/jsx-runtime");
const ObjectForm = import_react.default.forwardRef(({ mode = "edit", elementId, model, ...props }, ref) => {
  const toast = (0, import_ui.useToastController)();
  if (typeof model == "string" || !model || !model?.getApiOptions() || !elementId && mode != "add")
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { ref, padding: "$4", gap: "$2", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fontWeight: "bold", children: "ObjectForm:" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "Model or Element ID is empty." })
    ] });
  const { name, prefix } = model?.getApiOptions() ?? {}, apiUrl = prefix + name;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { ref, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_EditableObject.EditableObject,
    {
      objectId: elementId,
      name,
      title: "",
      sourceUrl: apiUrl + "/" + elementId,
      numColumns: 2,
      mode,
      disableAutoChangeMode: !0,
      onSave: async (original, data) => {
        try {
          if (mode == "add") {
            const obj = model.load(data), result = await import_protobase.API.post(apiUrl, obj.create().getData());
            if (result.isError)
              throw result.error;
            toast.show(name + " created", {
              message: obj.getId()
            });
          } else if (mode == "edit") {
            const id = model.load(data).getId(), result = await import_protobase.API.post(apiUrl + "/" + id, model.load(original).update(model.load(data)).getData());
            if (result.isError)
              throw result.error;
            toast.show(name + " updated", {
              message: "Saved new settings for: " + id
            });
          }
        } catch (e) {
          throw (0, import_protobase2.getPendingResult)("error", null, e instanceof import_protobase2.z.ZodError ? e.flatten() : e);
        }
      },
      model
    }
  ) });
});
//# sourceMappingURL=ObjectForm.js.map
