var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var ObjectGrid_exports = {};
__export(ObjectGrid_exports, {
  ObjectGrid: () => ObjectGrid
});
module.exports = __toCommonJS(ObjectGrid_exports);
var import_ui = require("@my/ui"), import_Grid = require("./Grid"), import_EditableObject = require("./EditableObject"), import_protobase = require("protobase"), import_ItemCard = require("./ItemCard"), import_Tints = require("../lib/Tints"), import_react = require("react"), import_Tinted = require("./Tinted"), import_jsx_runtime = require("react/jsx-runtime");
const GridElementCard = ({ index, data, width }) => {
  const element = data.element.data, modelItem = data.model.load(element), tint = (0, import_Tints.useTint)(), Icon = data?.icon ?? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {});
  return data.getCard ? data.getCard(element, width) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_ItemCard.ItemCard,
    {
      height: data.itemHeight,
      cursor: data.disableItemSelection ? "default" : "pointer",
      topBarOutSideScrollArea: !1,
      backgroundColor: "$bgPanel",
      elevation: "$0",
      hoverStyle: { ...data.disableItemSelection ? {} : { o: 0.8, backgroundColor: "$" + tint.tint + "1", elevation: "$1" } },
      borderWidth: 1,
      pointerEvents: "none",
      pointerEventsControls: "none",
      onPress: (e) => {
        data.disableItemSelection || (console.log("onPress", e.target, e.currentTarget, e), e.target.closest(".is_DialogContent")) || data.onSelectItem(modelItem);
      },
      ...data.getPicture ? {
        image: data.getPicture(element, width),
        hasPicture: !0
      } : {},
      children: data.getBody ? data.getBody(element, width) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Stack, { mb: "$4", width, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_EditableObject.EditableObject,
        {
          initialData: data.element,
          name: modelItem.getId(),
          spinnerSize: 75,
          loadingText: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { ai: "center", jc: "center", children: [
            "Loading data...",
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Paragraph, { fontWeight: "bold" })
          ] }),
          objectId: modelItem.getId(),
          sourceUrl: data.sourceUrl + "/" + modelItem.getId(),
          mode: "preview",
          model: data.model,
          extraFields: data.extraFields,
          icons: data.icons,
          customFields: data.customFields,
          columnWidth: width - data.contentMargin,
          onDelete: data.onDelete,
          deleteable: data.deleteable,
          extraMenuActions: data.extraMenuActions,
          title: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { mt: "$4", ml: "$4", ai: "center", children: [
            data?.icon && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Stack, { mr: "$2", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Icon, { color: "var(--color7)" }) }) }),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.H3, { children: data?.name })
          ] })
        }
      ) }, element.key)
    }
  );
}, ObjectGrid = ({
  overScanBy = 5,
  gridElementCard = void 0,
  itemMinWidth = 400,
  emptyMessage = /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, {}),
  itemHeight,
  rightGap = 30,
  contentMargin = 50,
  onSelectItem = (id) => {
  },
  disableItemSelection = !1,
  extraMenuActions,
  spacing = 20,
  getPicture,
  getBody,
  getCard,
  model,
  items,
  sourceUrl,
  customFields,
  onDelete,
  deleteable,
  extraFields,
  icons,
  children,
  name,
  icon,
  ...props
}) => {
  const containerRef = (0, import_react.useRef)(null), data = items.map((element, i) => ({
    id: "item_" + i,
    element: (0, import_protobase.getPendingResult)("loaded", element),
    model,
    sourceUrl,
    customFields,
    extraFields,
    icons,
    itemMinWidth,
    getPicture,
    getBody,
    getCard,
    spacing,
    contentMargin,
    onSelectItem,
    onDelete,
    deleteable,
    itemHeight,
    extraMenuActions,
    disableItemSelection,
    name,
    icon
  })), [ready, setReady] = (0, import_react.useState)(0);
  return (0, import_react.useEffect)(() => {
    setReady(1);
  }, []), /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Stack, { f: 1, o: ready ? 1 : 0, ref: containerRef, ...props, children: [
    data && data.length > 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Grid.Grid,
      {
        overScanBy,
        rightGap,
        containerRef,
        spacing,
        data,
        card: gridElementCard ?? GridElementCard,
        itemMinWidth
      },
      data.length + ready
    ) : emptyMessage,
    children
  ] });
};
//# sourceMappingURL=ObjectGrid.js.map
