var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var PieChart_exports = {};
__export(PieChart_exports, {
  PieChart: () => PieChart
});
module.exports = __toCommonJS(PieChart_exports);
var import_ui = require("@my/ui"), import_recharts = require("recharts"), import_jsx_runtime = require("react/jsx-runtime");
const PieChart = ({
  title,
  data,
  dataKey,
  nameKey,
  colors,
  tooltipFormatter = (value) => `${value}`,
  labelFormatter,
  isAnimationActive = !1,
  aspect = 1
}) => {
  const renderCustomizedLabel = ({ cx, cy, midAngle, innerRadius, outerRadius, percent }) => {
    const RADIAN = Math.PI / 180, radius = innerRadius + (outerRadius - innerRadius) * 0.5, x = cx + radius * Math.cos(-midAngle * RADIAN), y = cy + radius * Math.sin(-midAngle * RADIAN);
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { x, y, fill: "white", textAnchor: x > cx ? "start" : "end", dominantBaseline: "central", children: `${(percent * 100).toFixed(0)}%` });
  };
  return Array.isArray(data) && data.length > 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.ResponsiveContainer, { aspect: parseFloat(aspect), children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_recharts.PieChart, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_recharts.Pie,
      {
        data,
        dataKey,
        nameKey,
        cx: "50%",
        cy: "50%",
        outerRadius: 150,
        fill: "#8884d8",
        label: labelFormatter ?? renderCustomizedLabel,
        labelLine: !1,
        isAnimationActive,
        children: data.map((entry, index) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.Cell, { fill: colors[index % colors.length] }, `cell-${index}`))
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.Tooltip, { formatter: tooltipFormatter }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_recharts.Legend,
      {
        layout: "vertical",
        verticalAlign: "middle",
        align: "right",
        wrapperStyle: {
          marginTop: -100,
          // reduce la separación entre gráfico y leyenda
          lineHeight: "20px"
        }
      }
    )
  ] }) }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "No data available" }) });
};
//# sourceMappingURL=PieChart.js.map
