var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var RadialBartChart_exports = {};
__export(RadialBartChart_exports, {
  RadialBarChart: () => RadialBarChart
});
module.exports = __toCommonJS(RadialBartChart_exports);
var import_ui = require("@my/ui"), import_recharts = require("recharts"), import_jsx_runtime = require("react/jsx-runtime");
const RadialBarChart = ({
  title,
  id,
  data,
  dataKey,
  nameKey,
  colors,
  tooltipFormatter = (value) => `${value}`,
  isAnimationActive = !1,
  displayLegend = !0,
  displayTooltip = !0,
  displayLabel = !0,
  startAngle = 90,
  endAngle = -270,
  aspect = 1.7,
  innerRadius = "50%",
  outerRadius = "100%"
}) => {
  const legendStyle = {
    top: "50%",
    right: 0,
    transform: "translateY(-50%)",
    lineHeight: "24px"
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_ui.YStack,
    {
      borderRadius: 10,
      backgroundColor: "$bgColor",
      padding: 10,
      flex: 1,
      justifyContent: "center",
      alignItems: "center",
      children: Array.isArray(data) && data.length > 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.ResponsiveContainer, { aspect: parseFloat(aspect, 10), children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
        import_recharts.RadialBarChart,
        {
          cx: "50%",
          cy: "50%",
          innerRadius,
          outerRadius,
          barSize: 10,
          data,
          startAngle: parseFloat(startAngle),
          endAngle: parseFloat(endAngle),
          children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_recharts.RadialBar,
              {
                ...displayLabel && displayLabel !== "false" ? { label: { position: "insideStart", fill: "#fff" } } : {},
                background: { fill: "#ddd" },
                dataKey,
                isAnimationActive,
                children: data.map((_, index) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.Cell, { fill: colors[index % colors.length] }, `cell-${index}`))
              }
            ),
            displayLegend && displayLegend !== "false" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_recharts.Legend,
              {
                iconSize: 10,
                layout: "vertical",
                verticalAlign: "middle",
                align: "right",
                wrapperStyle: legendStyle
              }
            ),
            displayTooltip && displayTooltip !== "false" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_recharts.Tooltip, { formatter: tooltipFormatter })
          ]
        }
      ) }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { children: "No data available" }) })
    }
  );
};
//# sourceMappingURL=RadialBartChart.js.map
