var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var SelectList_exports = {};
__export(SelectList_exports, {
  SelectList: () => SelectList
});
module.exports = __toCommonJS(SelectList_exports);
var import_ui = require("@my/ui"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_jsx_runtime = require("react/jsx-runtime");
function SelectList({ title, value, elements, setValue, triggerProps, valueProps, rawDisplay, placeholder = "choose an option", ...props }) {
  let displaySelected = elements.find((element) => element.value && element.value === value);
  return displaySelected ? displaySelected = displaySelected.caption : displaySelected = value, /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_ui.Select,
    {
      id: "select",
      defaultValue: value,
      onValueChange: setValue,
      disablePreventBodyScroll: !0,
      ...props,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { id: "eo-select-list-" + title }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Select.Trigger, { f: 1, iconAfter: import_lucide_icons.ChevronDown, ...triggerProps, children: [
          !rawDisplay && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Select.Value, { ...valueProps, placeholder, children: displaySelected }),
          rawDisplay && displaySelected
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Adapt, { when: "sm", platform: "touch", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
          import_ui.Sheet,
          {
            native: !!props.native,
            modal: !0,
            dismissOnSnapToBottom: !0,
            animationConfig: {
              type: "spring",
              damping: 20,
              mass: 1.2,
              stiffness: 250
            },
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Sheet.Frame, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Sheet.ScrollView, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Adapt.Contents, {}) }) }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                import_ui.Sheet.Overlay,
                {
                  animation: "lazy",
                  enterStyle: { opacity: 0 },
                  exitStyle: { opacity: 0 }
                }
              )
            ]
          }
        ) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Select.Content, { zIndex: 2e5, children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_ui.Select.ScrollUpButton,
            {
              alignItems: "center",
              justifyContent: "center",
              position: "relative",
              width: "100%",
              height: "$3",
              children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { zIndex: 10, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronUp, { size: 20 }) })
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
            import_ui.Select.Viewport,
            {
              minWidth: 200,
              children: [
                /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Select.Group, { children: [
                  /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Select.Label, { children: title }),
                  (0, import_react.useMemo)(
                    () => elements.map((item, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
                      import_ui.Select.Item,
                      {
                        index: i,
                        value: item.value ?? item,
                        style: { display: "flex", flexDirection: "row", justifyContent: "flex-start", alignItems: "center" },
                        children: [
                          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { id: "eo-select-list-" + title + "-item-" + i }),
                          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Select.ItemText, { children: item.caption ?? item }),
                          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Select.ItemIndicator, { marginLeft: "auto", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Check, { size: 16 }) })
                        ]
                      },
                      item.value ?? item
                    )),
                    [elements]
                  )
                ] }),
                props.native && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                  import_ui.YStack,
                  {
                    position: "absolute",
                    right: 0,
                    top: 0,
                    bottom: 0,
                    alignItems: "center",
                    justifyContent: "center",
                    width: "$4",
                    pointerEvents: "none",
                    children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronDown, { size: (0, import_ui.getFontSize)(props.size ?? "$true") })
                  }
                )
              ]
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_ui.Select.ScrollDownButton,
            {
              alignItems: "center",
              justifyContent: "center",
              position: "relative",
              width: "100%",
              height: "$3",
              children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { zIndex: 10, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronDown, { size: 20 }) })
            }
          )
        ] })
      ]
    }
  );
}
//# sourceMappingURL=SelectList.js.map
