var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var SequenceView_exports = {};
__export(SequenceView_exports, {
  SequenceView: () => SequenceView
});
module.exports = __toCommonJS(SequenceView_exports);
var import_react = require("react"), import_Chip = require("../components/Chip"), import_ui = require("@my/ui"), import_dnd = require("@hello-pangea/dnd"), import_protobase = require("protobase"), import_next = require("../next"), import_jsx_runtime = require("react/jsx-runtime");
const SequenceCard = ({ model, item, index, onSelectItem, getCard }) => {
  const modelItem = model.load(item), validProps = model.getObjectFields().filter((field) => {
    const fieldDef = model.getObjectSchema().getFieldDefinition(field);
    return fieldDef.typeName == "ZodString" && !fieldDef.id;
  });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_dnd.Draggable,
    {
      draggableId: modelItem.getId(),
      isDragDisabled: !modelItem.canTransition(),
      index,
      children: (provided) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "div",
        {
          ref: provided.innerRef,
          ...provided.draggableProps,
          ...provided.dragHandleProps,
          style: {
            userSelect: "none",
            margin: "0 0 8px 0",
            ...provided.draggableProps.style
          },
          children: getCard ? getCard(item, index) : /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
            import_ui.YStack,
            {
              onPress: () => onSelectItem(modelItem),
              p: "$3",
              br: "$4",
              bc: "$backgroundStrong",
              boc: "$gray4",
              bw: "$0.5",
              hoverStyle: { elevation: 5, scale: 1.01 },
              pressStyle: { elevation: 0.01 },
              animation: "bouncy",
              transition: "all 0.2s",
              gap: "$2",
              children: [
                /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fos: "$3", fontStyle: "italic", color: "$color9", children: modelItem.getId() }),
                validProps.map((field) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { mb: "$4", fos: "$4", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.Text, { color: "$color8", fontWeight: "600", fontSize: "$3", children: [
                    field,
                    ": "
                  ] }),
                  /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fontWeight: "400", fontSize: "$3", children: modelItem.get(field) })
                ] }, field))
              ]
            }
          )
        }
      )
    },
    modelItem.getId()
  );
}, SequenceView = ({
  items,
  onStageChange = () => {
  },
  onSelectItem = () => {
  },
  model,
  getCard,
  onDragEnd = () => {
  },
  getStageBottom,
  getDroppableStageStyle = (col, provided) => ({}),
  getStageContainerProps = (stage) => ({}),
  sort = (a, b) => !0,
  ...props
}) => {
  const [positions, setPositions] = (0, import_react.useState)({}), { query } = (0, import_next.usePageParams)({}), queryString = new URLSearchParams(query).toString(), positionsOrder = Object.keys(positions).reduce((acc, key) => acc.concat(positions[key]), []), itemsList = (items.data.items ?? []).sort((a, b) => {
    const aIndex = positionsOrder.indexOf(a[model.getIdField()]), bIndex = positionsOrder.indexOf(b[model.getIdField()]);
    return aIndex === -1 && bIndex === -1 ? 0 : aIndex === -1 ? 1 : bIndex === -1 ? -1 : aIndex - bIndex;
  }).sort(sort), sequenceField = model.getSequeceField(), sequenceFieldDefRaw = model.getObjectSchema().getFieldDefinition(sequenceField), columns = {
    ...sequenceFieldDefRaw,
    ...sequenceFieldDefRaw?.innerType?._def
  }.options?.map(
    (option) => option.value
  ), getItemsBySequenceStages = (stageName) => itemsList?.filter((item) => item[model.getSequeceField()] === stageName), saveNewOrder = (finalItems, movedItem, newItemData) => {
    const positionsByColumn = finalItems.reduce((acc, item) => {
      const col = item[sequenceField];
      return acc[col] || (acc[col] = []), acc[col].push(item[model.getIdField()]), acc;
    }, {});
    setPositions(positionsByColumn), import_protobase.API.post("/api/core/v1/sequences/" + model.getModelName() + "?" + queryString, positionsByColumn), onStageChange(model.load(movedItem), { positionsByColumn }), onDragEnd({
      error: !1,
      sourceData: movedItem,
      destinationData: newItemData,
      updatedItems: finalItems,
      message: "Item moved",
      positionsByColumn
    });
  }, onDragFinish = (result) => {
    const { source, destination } = result;
    if (!destination || destination.droppableId === source.droppableId && destination.index === source.index)
      return;
    const updatedItems = [...itemsList], itemsInSourceCol = updatedItems.filter((i) => i[sequenceField] === source.droppableId), [movedItem] = itemsInSourceCol.splice(source.index, 1), modelItem = model.load(movedItem), newItemData = { ...movedItem, [sequenceField]: destination.droppableId };
    if (!modelItem.canTransition(newItemData))
      return onDragEnd({
        error: !0,
        message: "Invalid transition",
        sourceData: movedItem,
        destinationData: newItemData
      });
    if (movedItem[sequenceField] = newItemData[sequenceField], source.droppableId === destination.droppableId) {
      itemsInSourceCol.splice(destination.index, 0, movedItem);
      const merged = updatedItems.filter((i) => i[sequenceField] !== source.droppableId).concat(itemsInSourceCol);
      saveNewOrder(merged, movedItem, newItemData);
    } else {
      const itemsInDestinationCol = updatedItems.filter((i) => i[sequenceField] === destination.droppableId), indexInAll = updatedItems.findIndex((i) => i[model.getIdField()] === movedItem[model.getIdField()]);
      updatedItems.splice(indexInAll, 1), itemsInDestinationCol.splice(destination.index, 0, movedItem);
      const merged = updatedItems.filter((i) => i[sequenceField] !== source.droppableId && i[sequenceField] !== destination.droppableId).concat(itemsInSourceCol, itemsInDestinationCol);
      saveNewOrder(merged, movedItem, newItemData);
    }
  }, themeNames = ["orange", "yellow", "green", "blue", "purple", "pink", "red"], getTheme = (index) => themeNames[index % themeNames.length], getPostions = async () => {
    const sequenceName = model.getModelName(), res = await import_protobase.API.get("/api/core/v1/sequences/" + sequenceName + "?" + queryString);
    !res.isError && res.data && setPositions(res.data);
  };
  return (0, import_react.useEffect)(() => {
    getPostions();
  }, [queryString]), /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dnd.DragDropContext, { onDragEnd: onDragFinish, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.XStack, { gap: "$2", padding: "$4", f: 1, overflow: "scroll", ...props, children: columns ? columns.map((col, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { theme: getTheme(i), bc: "$background", br: "$4", bw: "$0.5", p: "$2", pt: "$2.5", borderColor: "$gray4", ...getStageContainerProps(col), children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { gap: "$2", mb: "$2", ac: "center", jc: "flex-start", p: "2px", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Chip.Chip, { text: col, textProps: { fow: "600" }, gap: "$2", ai: "center", px: "$2", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Circle, { size: 10, bc: "$color8" }) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fos: "$3", color: "$gray8", children: getItemsBySequenceStages(col).length })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dnd.Droppable, { droppableId: col, children: (provided) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      "div",
      {
        ref: provided.innerRef,
        ...provided.droppableProps,
        style: {
          width: "250px",
          minWidth: "250px",
          minHeight: "300px",
          padding: "2px",
          height: "100%",
          overflowY: "auto",
          ...getDroppableStageStyle(col, provided)
        },
        children: [
          getItemsBySequenceStages(col).map((item, index) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(SequenceCard, { model, item, index, onSelectItem, getCard }, item.id)),
          provided.placeholder
        ]
      }
    ) }),
    getStageBottom && getStageBottom(col, getItemsBySequenceStages(col))
  ] }, col)) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { textAlign: "center", f: 1, mt: "$10", fow: "400", color: "$color10", children: "No sequence stages defined. Check if the sequence defined has stages or options." }) }) });
};
//# sourceMappingURL=SequenceView.js.map
