var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var AutopilotEditor_exports = {};
__export(AutopilotEditor_exports, {
  AutopilotEditor: () => AutopilotEditor
});
module.exports = __toCommonJS(AutopilotEditor_exports);
var import_react_resizable_panels = require("react-resizable-panels"), import_ui = require("@my/ui"), import_Tinted = require("../../components/Tinted"), import_CustomPanelResizeHandle = __toESM(require("../MainPanel/CustomPanelResizeHandle")), import_Rules = require("./Rules"), import_next_theme = require("@tamagui/next-theme"), import_Monaco = require("../Monaco"), import_JSONView = require("../JSONView"), import_react = require("react"), import_lucide_icons = require("@tamagui/lucide-icons"), import_useSetting = require("protolib/lib/useSetting"), import_jsx_runtime = require("react/jsx-runtime");
function flattenObject(obj, prefix = "") {
  let result = [];
  for (let key in obj) {
    if (!obj.hasOwnProperty(key)) continue;
    const value = obj[key], newPath = prefix ? prefix + " -> " + key : key;
    if (typeof value == "object" && value !== null) {
      const nested = flattenObject(value, newPath);
      result.push(...nested);
    } else
      result.push([[newPath], [value]]);
  }
  return result;
}
function filterObjectBySearch(data, search) {
  if (data == null) return;
  const lowerSearch = search.toLowerCase();
  if (typeof data != "object")
    return String(data).toLowerCase().includes(lowerSearch) ? data : void 0;
  if (Array.isArray(data)) {
    const filteredArr = [];
    for (const item of data) {
      const filteredItem = filterObjectBySearch(item, search);
      filteredItem !== void 0 && filteredArr.push(filteredItem);
    }
    return filteredArr.length > 0 ? filteredArr : void 0;
  }
  const result = {};
  for (const [key, value] of Object.entries(data)) {
    const keyMatches = key.toLowerCase().includes(lowerSearch), filteredValue = filterObjectBySearch(value, search);
    (keyMatches || filteredValue !== void 0) && (result[key] = filteredValue === void 0 ? value : filteredValue);
  }
  return Object.keys(result).length > 0 ? result : void 0;
}
const FormattedView = ({ data }) => {
  const [hovered, setHovered] = (0, import_react.useState)(null), [showCopied, setShowCopied] = (0, import_react.useState)(null), list = flattenObject(data);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: list.map((line, index) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_ui.XStack,
    {
      cursor: "pointer",
      p: "$2",
      px: "$4",
      bg: "$gray2",
      gap: "$2",
      br: "$4",
      hoverStyle: { backgroundColor: "$color5" },
      onMouseEnter: () => setHovered(index),
      onMouseLeave: () => setHovered(null),
      onPress: () => {
        navigator.clipboard.writeText(line[0]), setShowCopied(index), setTimeout(() => setShowCopied(null), 700);
      },
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { display: showCopied == index ? "flex" : "none", fos: "$4", color: "$color7", pos: "absolute", left: "$4", children: "copied to clipboard!" }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { o: showCopied == index ? 0 : 1, children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fos: "$4", children: line[0] + " : " }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { fos: "$4", color: "$color7", children: line[1] })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_lucide_icons.Copy,
          {
            display: hovered == index ? "flex" : "none",
            color: "$blue8",
            pos: "absolute",
            r: "$2",
            top: "$2.5",
            size: 14
          }
        )
      ]
    },
    index
  )) });
}, AutopilotEditor = ({ data, rules, rulesCode, setRulesCode, value, valueReady = !0, onAddRule = (e, rule) => {
}, onDeleteRule = (index) => {
} }) => {
  const { resolvedTheme } = (0, import_next_theme.useThemeSetting)(), [inputMode, setInputMode] = (0, import_react.useState)("json"), [search, setSearch] = (0, import_react.useState)(""), isAIEnabled = (0, import_useSetting.useSettingValue)("ai.enabled", !1), filteredData = filterObjectBySearch(data, search);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_react_resizable_panels.PanelGroup, { direction: "horizontal", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 30, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_react_resizable_panels.PanelGroup, { direction: "vertical", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 66, minSize: 20, maxSize: 80, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { flex: 1, height: "100%", borderRadius: "$3", p: "$3", gap: "$2", backgroundColor: "$gray3", overflow: "hidden", children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { jc: "space-between", width: "100%", children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)("p", { children: "Input" }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { gap: "$2", children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_ui.Button,
              {
                icon: import_lucide_icons.AlignLeft,
                bc: inputMode === "formatted" ? "$color5" : "$gray4",
                scaleIcon: 1.6,
                size: "$2",
                onPress: () => setInputMode("formatted")
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_ui.Button,
              {
                icon: import_lucide_icons.Braces,
                bc: inputMode === "json" ? "$color5" : "$gray4",
                scaleIcon: 1.6,
                size: "$2",
                onPress: () => setInputMode("json")
              }
            )
          ] })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.ScrollView, { flex: 1, width: "100%", height: "100%", overflow: "auto", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Tinted.Tinted, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { miw: "600px", gap: "$2", ai: "flex-start", children: [
          inputMode === "formatted" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(FormattedView, { data: filteredData }),
          inputMode == "json" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_JSONView.JSONView, { collapsed: 1, style: { backgroundColor: "var(--gray3)" }, src: filteredData })
        ] }) }) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { pb: 8, children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.Search, { pos: "absolute", left: "$3", top: 14, size: 16 }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_ui.Input,
            {
              bg: "$gray1",
              color: "$gray12",
              paddingLeft: "$7",
              bw: 0,
              h: "47px",
              boc: "$gray6",
              w: "100%",
              placeholder: "search...",
              placeholderTextColor: "$gray9",
              outlineColor: "$gray8",
              value: search,
              onChangeText: setSearch
            }
          )
        ] })
      ] }) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_CustomPanelResizeHandle.default, { direction: "horizontal" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 34, minSize: 20, maxSize: 80, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { flex: 1, height: "100%", borderRadius: "$3", p: "$3", backgroundColor: "$gray3", overflow: "hidden", children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("p", { children: "Output" }),
        !valueReady && rules.length !== 0 && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { f: 1, jc: "center", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Spinner, {}) }),
        !valueReady && rules.length === 0 && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Text, { opacity: 0.6, children: "No output available. Create a rule to get started." }),
        valueReady && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.ScrollView, { flex: 1, width: "100%", height: "100%", overflow: "auto", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Tinted.Tinted, { children: [
          valueReady && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { style: { minWidth: "600px" }, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_JSONView.JSONView, { style: { backgroundColor: "var(--gray3)" }, src: value }) }),
          !valueReady && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Spinner, {})
        ] }) })
      ] }) })
    ] }) }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_CustomPanelResizeHandle.default, { direction: "vertical" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 70, minSize: 50, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_react_resizable_panels.PanelGroup, { direction: "vertical", children: [
      isAIEnabled && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 66, minSize: 0, maxSize: 100, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_ui.YStack,
        {
          flex: 1,
          height: "100%",
          alignItems: "center",
          justifyContent: "center",
          backgroundColor: "$gray3",
          borderRadius: "$3",
          p: "$3",
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_Rules.Rules,
            {
              rules,
              onAddRule,
              onDeleteRule,
              loadingIndex: -1
            }
          )
        }
      ) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_CustomPanelResizeHandle.default, { direction: "horizontal" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: isAIEnabled ? 34 : 100, minSize: 0, maxSize: 100, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { flex: 1, height: "100%", alignItems: "center", justifyContent: "center", backgroundColor: "$gray3", borderRadius: "$3", p: "$3", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Monaco.Monaco,
        {
          path: "autopilot-rules.ts",
          darkMode: resolvedTheme === "dark",
          sourceCode: rulesCode,
          onChange: setRulesCode,
          options: {
            folding: !1,
            lineDecorationsWidth: 0,
            lineNumbersMinChars: 0,
            lineNumbers: !1,
            minimap: { enabled: !1 }
          }
        }
      ) }) })
    ] }) })
  ] });
};
//# sourceMappingURL=AutopilotEditor.js.map
