var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var ParamsEditor_exports = {};
__export(ParamsEditor_exports, {
  ParamsEditor: () => ParamsEditor
});
module.exports = __toCommonJS(ParamsEditor_exports);
var import_ui = require("@my/ui"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_InteractiveIcon = require("../InteractiveIcon"), import_nanoid = require("nanoid"), import_usehooks_ts = require("usehooks-ts"), import_jsx_runtime = require("react/jsx-runtime");
const ParamsEditor = ({
  params = {},
  setParams,
  configParams = {},
  setConfigParams = (x) => {
  },
  mode = "action"
}) => {
  const [rows, setRows] = (0, import_react.useState)(() => {
    const allKeys = /* @__PURE__ */ new Set([...Object.keys(params), ...Object.keys(configParams)]);
    return Array.from(allKeys).map((key) => ({
      rowId: (0, import_nanoid.nanoid)(),
      paramKey: key,
      description: params[key] ?? "",
      visible: configParams[key]?.visible ?? !0,
      defaultValue: configParams[key]?.defaultValue ?? ""
    }));
  });
  (0, import_usehooks_ts.useUpdateEffect)(() => {
    const newParams = {}, newConfigParams = {};
    console.log("rows", rows), rows.forEach(({ paramKey, description, visible, defaultValue }) => {
      paramKey.trim() && (newParams[paramKey] = description, newConfigParams[paramKey] = { visible, defaultValue });
    }), console.log("params", newParams), setParams(newParams), mode == "action" && (console.log("configParams", newConfigParams), setConfigParams(newConfigParams));
  }, [rows]);
  const handleAddParam = (0, import_react.useCallback)(() => {
    setRows((prev) => [
      ...prev,
      {
        rowId: (0, import_nanoid.nanoid)(),
        paramKey: "",
        description: "",
        visible: !0,
        defaultValue: ""
      }
    ]);
  }, []), handleRemoveParam = (0, import_react.useCallback)((rowIdToRemove) => {
    setRows((prev) => prev.filter((row) => row.rowId !== rowIdToRemove));
  }, []), handleChangeParamKey = (0, import_react.useCallback)((rowId, newKey) => {
    setRows(
      (prev) => prev.map(
        (row) => row.rowId === rowId ? { ...row, paramKey: newKey } : row
      )
    );
  }, []), handleChangeDescription = (0, import_react.useCallback)((rowId, newDescription) => {
    setRows(
      (prev) => prev.map(
        (row) => row.rowId === rowId ? { ...row, description: newDescription } : row
      )
    );
  }, []), handleChangeDefaultValue = (0, import_react.useCallback)((rowId, newValue) => {
    setRows(
      (prev) => prev.map((row) => {
        if (row.rowId !== rowId) return row;
        const nextVisible = newValue ? row.visible : !0;
        return { ...row, defaultValue: newValue, visible: nextVisible };
      })
    );
  }, []), handleToggleVisible = (0, import_react.useCallback)((rowId) => {
    setRows(
      (prev) => prev.map((row) => row.rowId !== rowId || !row.defaultValue && row.visible ? row : { ...row, visible: !row.visible })
    );
  }, []);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.YStack, { flex: 1, height: "100%", borderRadius: "$3", p: "$3", backgroundColor: "$gray3", overflow: "hidden", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { alignItems: "center", justifyContent: "space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Label, { size: "$4", children: "Parameters" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: handleAddParam, children: "Add param" })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.ScrollView, { mt: "$3", flex: 1, children: rows.map(({ rowId, paramKey, description, visible, defaultValue }) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { space: "$2", alignItems: "center", padding: "$2", borderRadius: "$2", children: [
      mode == "action" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_InteractiveIcon.InteractiveIcon, { Icon: import_lucide_icons.Eye, IconColor: visible ? "var(--color10)" : "var(--gray9)", onPress: () => handleToggleVisible(rowId) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Input, { placeholder: mode == "action" ? "Param Key" : "name", flex: 2, value: paramKey, onChange: (e) => handleChangeParamKey(rowId, e.target.value) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Input, { placeholder: mode == "action" ? "Description" : "value", flex: 4, value: description, onChange: (e) => handleChangeDescription(rowId, e.target.value) }),
      mode == "action" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Input, { placeholder: "Default Value", flex: 2, value: defaultValue, onChange: (e) => handleChangeDefaultValue(rowId, e.target.value) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_InteractiveIcon.InteractiveIcon, { Icon: import_lucide_icons.Trash, IconColor: "var(--red10)", onPress: () => handleRemoveParam(rowId) })
    ] }, rowId)) })
  ] });
};
//# sourceMappingURL=ParamsEditor.js.map
