var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var RulesSideMenu_exports = {};
__export(RulesSideMenu_exports, {
  RulesSideMenu: () => RulesSideMenu
});
module.exports = __toCommonJS(RulesSideMenu_exports);
var import_protobase = require("protobase"), import_ui = require("@my/ui"), import_Tinted = require("../../components/Tinted"), import_Rules = require("../../components/autopilot/Rules"), import_react = require("react"), import_react_resizable_panels = require("react-resizable-panels"), import_CustomPanelResizeHandle = __toESM(require("../MainPanel/CustomPanelResizeHandle")), import_useSetting = require("../../lib/useSetting"), import_code = require("protonode/dist/lib/code"), import_ts_morph = require("ts-morph"), import_intents = require("@extensions/files/intents"), import_jsx_runtime = require("react/jsx-runtime");
function generateStateDeclarations(obj) {
  const recurse = (o) => `{
` + Object.entries(o ?? {}).map(([key, val]) => typeof val == "object" && val !== null ? `  ${key}: ${recurse(val)};` : `  ${key}: any;`).join(`
`) + `
}`;
  return `declare const states: ${recurse(obj)};`;
}
const RulesSideMenu = ({ automationInfo, boardRef, board, actions, states, resolvedTheme }) => {
  const [savedRules, setSavedRules] = (0, import_react.useState)(board.rules), boardStates = states.boards ? states.boards[board.name] : {}, boardActions = actions.boards ? actions.boards[board.name] : {}, boardStatesDeclarations = (0, import_react.useMemo)(() => generateStateDeclarations(boardStates), [boardStates]), boardDeclaration = (0, import_react.useMemo)(() => `declare const board: {
  onChange: (params: { key: string, changed: (value: any) => void }) => void;
  execute_action: (params: { name: ${Object.keys(boardActions ?? {}).map((name) => `"${name}"`).join(" | ")}, params?: Record<string, any> }) => Promise<any>;
  id: string;
  log: (...args: any[]) => void;
};
};`, [board.name]), code = (0, import_react.useMemo)(() => {
    const sourceFile = (0, import_code.toSourceFile)(automationInfo.code), definition = (0, import_code.getDefinition)(sourceFile, '"code"');
    return definition && import_ts_morph.ArrowFunction.isArrowFunction(definition) ? definition.getBodyText() : "";
  }, [automationInfo.code]), savedCode = (0, import_react.useRef)(code), editedCode = (0, import_react.useRef)(code), [generatingBoardCode, setGeneratingBoardCode] = (0, import_react.useState)(!1), toast = (0, import_ui.useToastController)(), isAIEnabled = (0, import_useSetting.useSettingValue)("ai.enabled", !1), theme = (0, import_ui.useTheme)(), flows = (0, import_react.useMemo)(() => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_intents.CodeView,
    {
      viewPort: { x: 20, y: window.innerHeight / 8, zoom: 0.8 },
      onFlowChange: (code2) => {
        editedCode.current = code2;
      },
      onCodeChange: (code2) => {
        editedCode.current = code2;
      },
      path: "/data/boards/" + board.name + ".ts",
      sourceCode: editedCode,
      monacoOnMount: (editor, monaco) => {
        monaco.languages.typescript.typescriptDefaults.addExtraLib(
          boardDeclaration + `
` + boardStatesDeclarations,
          "ts:filename/customTypes.d.ts"
        );
      },
      monacoOptions: {
        folding: !0,
        lineDecorationsWidth: 0,
        lineNumbersMinChars: 0,
        lineNumbers: !0,
        minimap: { enabled: !1 }
      }
    }
  ), [resolvedTheme, board.name, theme, editedCode.current]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { w: "100%", backgroundColor: "transparent", backdropFilter: "blur(5px)", borderWidth: 2, p: "$3", br: "$5", elevation: 60, shadowOpacity: 0.2, shadowColor: "black", bw: 1, boc: "$gray6", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_Tinted.Tinted, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_react_resizable_panels.PanelGroup, { direction: "vertical", children: [
      isAIEnabled && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: 50, minSize: 0, maxSize: 100, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
        import_ui.YStack,
        {
          flex: 1,
          height: "100%",
          alignItems: "center",
          justifyContent: "center",
          boxShadow: "0 0 10px rgba(0,0,0,0.1)",
          borderRadius: "$3",
          p: "$3",
          children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_Rules.Rules,
              {
                rules: savedRules ?? [],
                onAddRule: (e, rule) => {
                  setSavedRules([...savedRules ?? [], rule]);
                },
                onDeleteRule: (index) => {
                  setSavedRules(savedRules.filter((_, i) => i != index));
                },
                onEditRule: (index, rule) => {
                  const newRules = [...savedRules];
                  newRules[index] = rule, setSavedRules(newRules);
                },
                loadingIndex: -1
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { mt: "auto", pt: "$3" })
          ]
        }
      ) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_CustomPanelResizeHandle.default, { direction: "horizontal" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_resizable_panels.Panel, { defaultSize: isAIEnabled ? 50 : 100, minSize: 0, maxSize: 100, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.YStack, { flex: 1, height: "100%", alignItems: "center", justifyContent: "center", boxShadow: "0 0 10px rgba(0,0,0,0.1)", borderRadius: "$3", p: "$3", children: flows }) })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.XStack, { mt: "auto", pt: "$3", gap: 30, jc: "center", ai: "center", children: [
      isAIEnabled && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: async () => {
        setGeneratingBoardCode(!0);
        try {
          boardRef.current.rules = savedRules;
          const rulesCode = await import_protobase.API.post("/api/core/v1/autopilot/getBoardCode", { rules: savedRules, states: boardStates, actions: actions.boards ? actions.boards[board.name] : {} });
          if (rulesCode.error || !rulesCode.data?.jsCode) {
            toast.show(`Error generating board code: ${rulesCode.error}`);
            return;
          }
          savedCode.current = rulesCode.data.jsCode, editedCode.current = rulesCode.data.jsCode, await import_protobase.API.post(`/api/core/v1/boards/${board.name}`, boardRef.current);
          const sourceFile = (0, import_code.toSourceFile)(automationInfo.code);
          (0, import_code.getDefinition)(sourceFile, '"code"').getBody().replaceWithText(`{
` + editedCode.current + `
}`), import_protobase.API.post(`/api/core/v1/boards/${board.name}/automation`, { code: sourceFile.getFullText() }), toast.show("Rules applied successfully!");
        } catch (e) {
          toast.show(`Error generating board code: ${e.message}`), console.error(e);
        } finally {
          setGeneratingBoardCode(!1);
        }
      }, children: generatingBoardCode ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Spinner, {}) : "Apply Rules" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { onPress: () => {
        const sourceFile = (0, import_code.toSourceFile)(automationInfo.code);
        (0, import_code.getDefinition)(sourceFile, '"code"').getBody().replaceWithText(`{
` + editedCode.current + `
}`), import_protobase.API.post(`/api/core/v1/boards/${board.name}/automation`, { code: sourceFile.getFullText() });
      }, children: "Save" })
    ] })
  ] }) });
};
//# sourceMappingURL=RulesSideMenu.js.map
