var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var SystemMessage_exports = {};
__export(SystemMessage_exports, {
  default: () => SystemMessage
});
module.exports = __toCommonJS(SystemMessage_exports);
var import_framer_motion = require("framer-motion"), import_store = require("../../store/store"), import_react = require("react"), import_jsx_runtime = require("react/jsx-runtime");
const varinats = {
  hidden: { opacity: 0, scale: 0.8 },
  visible: { opacity: 1, scale: 1 },
  exit: { opacity: 0, scale: 0.8, transition: { duration: 0.15 } }
};
function SystemMessage() {
  const [
    systemMessage,
    useSystemMessageForAllChats,
    setSystemMessage,
    setSystemMessageModalVisible
  ] = (0, import_store.useSettings)((state) => [
    state.settings.systemMessage,
    state.settings.useSystemMessageForAllChats,
    state.setSystemMessage,
    state.setSystemMessageModalVisible
  ]), [message, setMessage] = (0, import_react.useState)(systemMessage), [useForAllChats, setUseForAllChats] = (0, import_react.useState)(
    useSystemMessageForAllChats
  );
  function handleOnSubmit(e) {
    e.preventDefault(), setSystemMessage({ message, useForAllChats }), setSystemMessageModalVisible(!1);
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_framer_motion.motion.div,
    {
      variants: varinats,
      initial: "hidden",
      animate: "visible",
      exit: "exit",
      className: "sys-msg p-2  rounded-md bg-white dark:bg-gray-800 mx-2 md:mx-0 text-gray-500 dark:text-gray-300 w-full max-w-xl py-4",
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("form", { onSubmit: handleOnSubmit, children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("label", { htmlFor: "sysmsg", className: " inline-block mb-2", children: "System Message" }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "textarea",
          {
            name: "sysmsg",
            id: "sysmsg",
            value: message,
            onChange: (e) => setMessage(e.target.value),
            className: " w-full focus:outline-none outline outline-gray-200 focus:ring-2 focus:ring-green-600 dark:focus:ring-green-400 dark:bg-gray-700 dark:text-gray-300 rounded-md p-2",
            placeholder: "Your system message here",
            maxLength: 1500
          }
        ),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "mt-2 flex items-center mb-4 justify-between border border-gray-200 rounded dark:border-gray-700 p-2", children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "label",
            {
              htmlFor: "default-checkbox",
              className: "ml-2  font-medium  dark:text-gray-300",
              children: "Use for all chats"
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("label", { className: "relative inline-flex items-center cursor-pointer", children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              "input",
              {
                type: "checkbox",
                value: "",
                checked: useForAllChats,
                onChange: (e) => setUseForAllChats(e.target.checked),
                className: "sr-only peer"
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "w-11 h-6 bg-gray-200 peer-focus:outline-none peer-focus:ring-4 peer-focus:ring-blue-300 dark:peer-focus:ring-blue-800 rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-blue-600" })
          ] })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "flex justify-end mt-2", children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "button",
            {
              className: " bg-teal-700 hover:bg-teal-900 text-white px-4 py-2 rounded mr-2",
              type: "submit",
              children: "Save"
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "button",
            {
              className: "bg-gray-200 hover:bg-gray-400 text-gray-700 px-4 py-2 rounded",
              onClick: () => setSystemMessageModalVisible(!1),
              children: "Cancel"
            }
          )
        ] })
      ] })
    }
  );
}
//# sourceMappingURL=SystemMessage.js.map
