var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var useBot_exports = {};
__export(useBot_exports, {
  default: () => useBot
});
module.exports = __toCommonJS(useBot_exports);
var import_react = require("react"), import_store = __toESM(require("../store/store")), import_chatService = require("../services/chatService"), import_use_debounce = require("use-debounce"), import_createMessage = require("../utils/createMessage");
function useBot({ index, chat, prompt }) {
  const resultRef = (0, import_react.useRef)(chat.content), cursorRef = (0, import_react.useRef)(null), [result, setResult] = (0, import_react.useState)(chat.content), [error, setError] = (0, import_react.useState)(""), [isStreamCompleted, setIsStreamCompleted] = (0, import_react.useState)(!1), query = (0, import_store.default)((state) => state.chats[index - 1].content), [chats, addChat] = (0, import_store.default)((state) => [state.chats, state.addChat]), [sendHistory, selectedModal, systemMessage, useForAllChats] = (0, import_store.useSettings)((state) => [
    state.settings.sendChatHistory,
    state.settings.selectedModal,
    state.settings.systemMessage,
    state.settings.useSystemMessageForAllChats
  ]), chatsRef = (0, import_react.useRef)(chats);
  chatsRef.current = chats;
  const scrollToBottom = (0, import_use_debounce.useDebouncedCallback)(() => {
    cursorRef.current && cursorRef.current.scrollIntoView(!0);
  }, 50);
  return (0, import_react.useEffect)(() => {
    function handleOnData(data) {
      resultRef.current += data, setResult((prev) => prev + data), scrollToBottom();
    }
    function handleOnError(error2) {
      const errorMessage = typeof error2 == "string" ? error2 : error2.message;
      setError(errorMessage), resultRef.current = "Error processing the request: " + errorMessage, setResult(resultRef.current), setIsStreamCompleted(!0), addChat((0, import_createMessage.createMessage)("assistant", resultRef.current, chat.type), index);
    }
    function handleOnCompletion() {
      resultRef.current.trim() !== "" && addChat((0, import_createMessage.createMessage)("assistant", resultRef.current, chat.type), index), setIsStreamCompleted(!0);
    }
    if (chat.content || isStreamCompleted) return;
    let mounted = !0;
    const controller = new AbortController();
    let signal = controller.signal;
    return setResult(""), resultRef.current = "", setIsStreamCompleted(!1), setError(""), (async () => {
      try {
        let prevChats = sendHistory ? chatsRef.current.slice(0, index).filter((m) => m.type === "text").map((chat2) => ({
          role: chat2.role,
          content: chat2.content
        })) : [
          {
            role: chatsRef.current[index - 1].role,
            content: chatsRef.current[index - 1].content
          }
        ];
        useForAllChats && systemMessage && (prevChats = [{ role: "system", content: systemMessage }, ...prevChats]), await (0, import_chatService.fetchResults)(
          prevChats,
          { context: prompt },
          selectedModal,
          signal,
          handleOnData,
          handleOnCompletion
        );
      } catch (error2) {
        (error2 instanceof Error || typeof error2 == "string") && mounted && handleOnError(error2);
      }
    })(), () => {
      controller.abort(), mounted = !1;
    };
  }, [
    query,
    addChat,
    index,
    scrollToBottom,
    chat.content,
    chat.id,
    chat.type,
    sendHistory,
    selectedModal,
    systemMessage,
    useForAllChats
  ]), { query, result, error, isStreamCompleted, cursorRef };
}
//# sourceMappingURL=useBot.js.map
