var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var chatService_exports = {};
__export(chatService_exports, {
  fetchResults: () => fetchResults,
  generateImage: () => generateImage
});
module.exports = __toCommonJS(chatService_exports);
var import_store = require("../store/store");
const IMAGE_GENERATION_API_URL = "https://api.openai.com/v1/images/generations";
async function fetchResults(messages, metadata, model, signal, onData, onCompletion) {
  try {
    const apiUrl = import_store.useSettings.getState().settings.apiUrl, response = await fetch(apiUrl, {
      method: "POST",
      signal,
      headers: {
        "content-type": "application/json",
        accept: "text/event-stream",
        Authorization: `Bearer ${localStorage.getItem("apikey")}`
      },
      body: JSON.stringify({
        model: import_store.useSettings.getState().settings.selectedModal,
        temperature: 0.7,
        stream: !0,
        messages,
        metadata
      })
    });
    if (response.status !== 200)
      throw console.error(response), new Error("Error fetching results");
    const reader = response.body?.getReader();
    let hasReceivedAnyData = !1;
    for (; ; ) {
      const { done, value } = await reader.read();
      if (done) {
        hasReceivedAnyData || onData(""), onCompletion();
        break;
      }
      new TextDecoder("utf-8").decode(value, { stream: !0 }).split(`
`).filter((x) => x !== "").forEach((chunk2) => {
        if (chunk2.trim() === "data: [DONE]" || !chunk2.startsWith("data: ")) return;
        chunk2 = chunk2.replace("data: ", "");
        const data = JSON.parse(chunk2);
        if (data.choices) {
          if (data.choices[0].finish_reason === "stop") return;
          hasReceivedAnyData = !0, onData(data.choices[0].delta.content);
        }
        if (data.error)
          throw new Error(data.error.message);
      });
    }
  } catch (error) {
    if (console.error(error), error instanceof DOMException || error instanceof Error)
      throw new Error(error.message);
  }
}
async function generateImage(prompt, size, numberOfImages) {
  const selectedModal = import_store.useSettings.getState().settings.selectedModal;
  return await (await fetch(IMAGE_GENERATION_API_URL, {
    method: "POST",
    // signal: signal,
    headers: {
      "content-type": "application/json",
      accept: "text/event-stream",
      Authorization: `Bearer ${localStorage.getItem("apikey")}`
    },
    body: JSON.stringify({
      model: selectedModal,
      prompt,
      n: numberOfImages,
      size: import_store.useSettings.getState().settings.dalleImageSize[selectedModal]
    })
  })).json();
}
//# sourceMappingURL=chatService.js.map
