var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var store_exports = {};
__export(store_exports, {
  chatsLength: () => chatsLength,
  default: () => store_default,
  isChatSelected: () => isChatSelected,
  months: () => months,
  priority: () => priority,
  selectChatsHistory: () => selectChatsHistory,
  selectUser: () => selectUser,
  useAuth: () => useAuth,
  useSettings: () => useSettings
});
module.exports = __toCommonJS(store_exports);
var import_zustand = require("zustand"), import_middleware = require("zustand/middleware"), import_traditional = require("zustand/traditional"), import_shallow = require("zustand/shallow"), import_immer = require("immer"), import_moment = __toESM(require("moment"));
const modalsList = [
  "gpt-4",
  "gpt-4-0613",
  "gpt-4-1106-preview",
  "gpt-4-turbo",
  "gpt-3.5-turbo",
  "gpt-3.5-turbo-16k",
  "dall-e-3"
], useChat = (0, import_zustand.create)((set, get) => ({
  chats: [],
  chatHistory: localStorage.getItem("chatHistory") ? JSON.parse(localStorage.getItem("chatHistory")) : {},
  addChat: (chat, index) => {
    set(
      (0, import_immer.produce)((state) => {
        index !== void 0 ? state.chats[index] = chat : state.chats.push(chat);
      })
    ), chat.role === "assistant" && chat.content && get().saveChats();
  },
  editChatMessage: (content, updateIndex) => {
    set(
      (0, import_immer.produce)((state) => {
        state.chats[updateIndex] && (state.chats[updateIndex].content = content);
      })
    );
  },
  addNewChat: () => {
    set(
      (0, import_immer.produce)((state) => {
        state.chats = [];
      })
    );
  },
  saveChats: () => {
    const { settings } = useSettings.getState(), chatName = settings.apiUrl.split("/").pop();
    if (!chatName) return;
    const chatId = get().chats[0]?.id;
    if (!chatId) return;
    const data = {
      id: chatId,
      createdAt: (/* @__PURE__ */ new Date()).toISOString(),
      chats: get().chats,
      title: get().chats[0]?.content || "Untitled",
      isTitleEdited: !1
    };
    localStorage.setItem(chatId, JSON.stringify(data));
    const currentChatHistory = get().chatHistory, updatedChatHistory = {
      ...currentChatHistory,
      [chatName]: [...currentChatHistory[chatName] || [], chatId]
    };
    localStorage.setItem("chatHistory", JSON.stringify(updatedChatHistory)), set(
      (0, import_immer.produce)((state) => {
        state.chatHistory = updatedChatHistory;
      })
    );
  },
  viewSelectedChat: (chatId) => {
    set(
      (0, import_immer.produce)((state) => {
        const chatData = localStorage.getItem(chatId);
        chatData && (state.chats = JSON.parse(chatData)?.chats || []);
      })
    );
  },
  resetChatAt: (index) => {
    set(
      (0, import_immer.produce)((state) => {
        state.chats[index] && (state.chats[index].content = "");
      })
    );
  },
  handleDeleteChats: (chatId) => {
    const { settings } = useSettings.getState(), chatName = settings.apiUrl.split("/").pop();
    chatName && set(
      (0, import_immer.produce)((state) => {
        const currentChatHistory = { ...state.chatHistory };
        currentChatHistory[chatName] && (currentChatHistory[chatName] = currentChatHistory[chatName].filter(
          (id) => id !== chatId
        ), currentChatHistory[chatName].length === 0 && delete currentChatHistory[chatName]), state.chatHistory = currentChatHistory, localStorage.removeItem(chatId), localStorage.setItem("chatHistory", JSON.stringify(currentChatHistory));
      })
    );
  },
  editChatsTitle: (id, title) => {
    set(
      (0, import_immer.produce)((state) => {
        const chatData = localStorage.getItem(id);
        if (chatData) {
          const parsedChat = JSON.parse(chatData);
          parsedChat.title = title, parsedChat.isTitleEdited = !0, localStorage.setItem(id, JSON.stringify(parsedChat));
        }
      })
    );
  },
  clearAllChats: () => {
    set(
      (0, import_immer.produce)((state) => {
        const currentChatHistory = state.chatHistory;
        Object.values(currentChatHistory).forEach((chatIds) => {
          chatIds.forEach((id) => {
            localStorage.removeItem(id);
          });
        }), state.chatHistory = {}, state.chats = [], localStorage.removeItem("chatHistory");
      })
    );
  }
})), useAuth = (0, import_zustand.create)()(
  (0, import_middleware.persist)(
    (set) => ({
      token: localStorage.getItem("token") || "",
      apikey: localStorage.getItem("apikey") || "",
      user: {
        name: "Your name?",
        email: "",
        avatar: "/images/avatar.png"
      },
      setToken: (token) => {
        set(
          (0, import_immer.produce)((state) => {
            state.token = token;
          })
        );
      },
      setUser: (user) => {
        set(
          (0, import_immer.produce)((state) => {
            state.user = user;
          })
        );
      },
      setApiKey: (apikey) => {
        set(
          (0, import_immer.produce)((state) => {
            state.apikey = apikey;
          })
        ), localStorage.setItem("apikey", apikey);
      }
    }),
    {
      name: "auth"
    }
  )
), useSettings = (0, import_traditional.createWithEqualityFn)()(
  (0, import_middleware.persist)(
    (set) => ({
      settings: {
        sendChatHistory: !0,
        systemMessage: "",
        useSystemMessageForAllChats: !1,
        selectedModal: "gpt-4-turbo",
        dalleImageSize: { "dall-e-3": "1024x1024" },
        apiUrl: ""
      },
      modalsList,
      isSystemMessageModalVisible: !1,
      isModalVisible: !1,
      setSystemMessage: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.settings.systemMessage = value.message, state.settings.useSystemMessageForAllChats = value.useForAllChats;
          })
        );
      },
      setSystemMessageModalVisible: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.isSystemMessageModalVisible = value;
          })
        );
      },
      setSendChatHistory: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.settings.sendChatHistory = value;
          })
        );
      },
      setModal: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.settings.selectedModal = value;
          })
        );
      },
      setModalVisible: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.isModalVisible = value;
          })
        );
      },
      setModalsList: (value) => {
        set(
          (0, import_immer.produce)((state) => {
            state.modalsList = value;
          })
        );
      },
      setDalleImageSize: (value, type) => {
        set(
          (0, import_immer.produce)((state) => {
            state.settings.dalleImageSize[type] = value;
          })
        );
      },
      setApiUrl: (url) => {
        set(
          (0, import_immer.produce)((state) => {
            state.settings.apiUrl = url;
          })
        );
      }
    }),
    {
      name: "settings",
      version: 1,
      partialize: (state) => ({ settings: state.settings }),
      migrate: (persistedState, version) => (version === 0 && (persistedState.dalleImageSize = {
        "dall-e-3": "1024x1024"
      }), persistedState)
    }
  ),
  import_shallow.shallow
), months = [
  "Januray",
  "February",
  "March",
  "April",
  "May",
  "June",
  "July",
  "August",
  "September",
  "October",
  "November",
  "December"
], priority = [
  "Today",
  "Previous 7 Days",
  "Previous 30 Days",
  "This month"
].concat(months), selectChatsHistory = (state) => {
  const { settings } = useSettings.getState(), sortedData = {}, currentAssistant = (settings.apiUrl || "").split("/").pop();
  return !currentAssistant || !state.chatHistory[currentAssistant] || state.chatHistory[currentAssistant].forEach((chatId) => {
    const chatData = localStorage.getItem(chatId);
    if (!chatData) return;
    const { title, id, createdAt } = JSON.parse(chatData), myDate = (0, import_moment.default)(createdAt, "YYYY-MM-DD"), currentDate = (0, import_moment.default)(), month = myDate.toDate().getMonth(), data = {
      title,
      id,
      month: months[month],
      month_id: month
    };
    myDate.isSame(currentDate, "day") ? (sortedData.Today || (sortedData.Today = []), sortedData.Today.push(data)) : currentDate.subtract(7, "days").isBefore(myDate) ? (sortedData["Previous 7 Days"] || (sortedData["Previous 7 Days"] = []), sortedData["Previous 7 Days"].push(data)) : currentDate.subtract(30, "days").isBefore(myDate) ? (sortedData["Previous 30 Days"] || (sortedData["Previous 30 Days"] = []), sortedData["Previous 30 Days"].push(data)) : (sortedData[months[month]] || (sortedData[months[month]] = []), sortedData[months[month]].push(data));
  }), sortedData;
}, selectUser = (state) => state.user, chatsLength = (state) => state.chats.length > 0, isChatSelected = (id) => (state) => state.chats[0]?.id === id;
var store_default = useChat;
//# sourceMappingURL=store.js.map
