var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var datepickers_exports = {};
__export(datepickers_exports, {
  DatePicker: () => DatePicker
});
module.exports = __toCommonJS(datepickers_exports);
var import_react = require("react"), import_dateParts = require("./dateParts"), import_datePicker = require("./datePicker"), import_rangePicker = require("./rangePicker"), import_multiSelectPicker = require("./multiSelectPicker"), import_yearPicker = require("./yearPicker"), import_monthPicker = require("./monthPicker"), import_jsx_runtime = require("react/jsx-runtime");
function DatePicker({ onDatesChange, selectedDates, mode = "single", config = {}, placeholder, onOffsetChange, offsetDate }) {
  const [selected, onChange] = (0, import_react.useState)([]), [offset, setOffset] = (0, import_react.useState)(), [open, setOpen] = (0, import_react.useState)(!1);
  var dates = selectedDates ?? selected, offsetValue = offsetDate ?? offset, onValueChange = (d) => {
    onDatesChange && onDatesChange(d), onChange(d);
  }, onOffChange = (d) => {
    onOffsetChange && onOffsetChange(d), setOffset(d);
  };
  const data = {
    single: {
      placeholder: "Select Date",
      value: dates[0]?.toDateString() || "",
      body: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_datePicker.DatePickerBody, {})
    },
    multiple: {
      placeholder: "Start date, End date",
      value: `${dates[0]?.toDateString() || ""}${dates[0] && dates[1] ? " , " : dates[0] ? " , end date" : ""}${dates[1]?.toDateString() || ""}`,
      body: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_multiSelectPicker.DatePickerBody, {})
    },
    range: {
      placeholder: "Start date - End date",
      value: `${dates[0]?.toDateString() || ""}${dates[0] && dates[1] ? " - " : ""}${dates[1]?.toDateString() || ""}`,
      body: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_rangePicker.DatePickerBody, {})
    },
    year: {
      placeholder: "Select year",
      value: offsetValue?.toLocaleDateString("en-US", {
        year: "numeric"
      }) || "",
      body: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_yearPicker.DatePickerBody, {})
    },
    month: {
      placeholder: "Select Month",
      value: offsetValue?.toLocaleDateString("en-US", {
        year: "numeric",
        month: "short"
      }) || "",
      body: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_monthPicker.DatePickerBody, {})
    }
  };
  return ["single", "multiple", "range"].includes(mode) ? (0, import_react.useEffect)(() => {
    (mode == "single" && dates.length || dates.length === 2) && setOpen(!1);
  }, [dates]) : (0, import_react.useEffect)(() => {
    (["month", "year"].includes(mode) && dates.length || dates.length === 2) && setOpen(!1);
  }, [offsetValue]), /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_dateParts.DatePicker,
    {
      open,
      onOpenChange: setOpen,
      config: {
        selectedDates: dates,
        onDatesChange: onValueChange,
        onOffsetChange: onOffChange,
        offsetDate: offsetValue,
        calendar: {
          offsets: [-1, 1]
        },
        ...config,
        dates: {
          mode: ["year", "month"].includes(mode) ? "single" : mode,
          toggle: !0,
          ...config?.dates
        }
      },
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.DatePicker.Trigger, { asChild: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_dateParts.DatePickerInput,
          {
            placeholder: placeholder ?? data[mode].placeholder,
            value: data[mode].value,
            onReset: () => {
              onValueChange([]), onOffChange(void 0);
            },
            onButtonPress: () => setOpen(!0)
          }
        ) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_dateParts.DatePicker.Content, { children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.DatePicker.Content.Arrow, {}),
          data[mode].body
        ] })
      ]
    }
  );
}
//# sourceMappingURL=index.js.map
