var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var inputsParts_exports = {};
__export(inputsParts_exports, {
  Input: () => Input,
  InputContainerFrame: () => InputContainerFrame,
  InputContext: () => InputContext,
  InputIconFrame: () => InputIconFrame,
  InputInfo: () => InputInfo,
  InputLabel: () => InputLabel,
  InputNew: () => InputNew,
  defaultInputGroupStyles: () => defaultInputGroupStyles,
  inputSizeVariant: () => inputSizeVariant
});
module.exports = __toCommonJS(inputsParts_exports);
var import_get_font_sized = require("@tamagui/get-font-sized"), import_get_token = require("@tamagui/get-token"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_ui = require("@my/ui"), import_jsx_runtime = require("react/jsx-runtime");
const defaultContextValues = {
  size: "$true",
  scaleIcon: 1.2,
  color: void 0
}, InputContext = (0, import_ui.createStyledContext)(defaultContextValues), defaultInputGroupStyles = {
  size: "$true",
  fontFamily: "$body",
  borderWidth: 1,
  outlineWidth: 0,
  color: "$color",
  ...import_ui.isWeb ? {
    tabIndex: 0
  } : {
    focusable: !0
  },
  borderColor: "$borderColor",
  backgroundColor: "$color2",
  // this fixes a flex bug where it overflows container
  minWidth: 0,
  hoverStyle: {
    borderColor: "$borderColorHover"
  },
  focusStyle: {
    outlineColor: "$outlineColor",
    outlineWidth: 2,
    outlineStyle: "solid",
    borderColor: "$borderColorFocus"
  }
}, InputGroupFrame = (0, import_ui.styled)(import_ui.XGroup, {
  justifyContent: "space-between",
  context: InputContext,
  variants: {
    unstyled: {
      false: defaultInputGroupStyles
    },
    scaleIcon: {
      ":number": {}
    },
    applyFocusStyle: {
      ":boolean": (val, { props }) => {
        if (val)
          return props.focusStyle || defaultInputGroupStyles.focusStyle;
      }
    },
    size: {
      "...size": (val, { tokens }) => ({
        borderRadius: tokens.radius[val]
      })
    }
  },
  defaultVariants: {
    unstyled: process.env.TAMAGUI_HEADLESS === "1"
  }
}), FocusContext = (0, import_ui.createStyledContext)({
  setFocused: (val) => {
  },
  focused: !1
}), InputGroupImpl = InputGroupFrame.styleable((props, forwardedRef) => {
  const { children, ...rest } = props, [focused, setFocused] = (0, import_react.useState)(!1);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(FocusContext.Provider, { focused, setFocused, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(InputGroupFrame, { applyFocusStyle: focused, ref: forwardedRef, ...rest, children }) });
}), inputSizeVariant = (val = "$true", extras) => {
  const radiusToken = extras.tokens.radius[val] ?? extras.tokens.radius.$true, paddingHorizontal = (0, import_get_token.getSpace)(val, {
    shift: -1,
    bounds: [2]
  }), fontStyle = (0, import_get_font_sized.getFontSized)(val, extras);
  return !import_ui.isWeb && fontStyle && delete fontStyle.lineHeight, {
    ...fontStyle,
    height: val,
    borderRadius: extras.props.circular ? 1e5 : radiusToken,
    paddingHorizontal
  };
}, InputFrame = (0, import_ui.styled)(import_ui.Input, {
  unstyled: !0,
  context: InputContext
}), InputImpl = InputFrame.styleable((props, ref) => {
  const { setFocused } = FocusContext.useStyledContext(), { size } = InputContext.useStyledContext(), { ...rest } = props;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, { flex: 1, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    InputFrame,
    {
      ref,
      onFocus: () => {
        setFocused(!0);
      },
      onBlur: () => setFocused(!1),
      size,
      ...rest
    }
  ) });
}), InputSection = (0, import_ui.styled)(import_ui.XGroup.Item, {
  justifyContent: "center",
  alignItems: "center",
  context: InputContext
}), Button = (0, import_ui.styled)(import_ui.Button, {
  context: InputContext,
  justifyContent: "center",
  alignItems: "center",
  variants: {
    size: {
      "...size": (val = "$true", { tokens }) => typeof val == "number" ? {
        paddingHorizontal: 0,
        height: val,
        borderRadius: val * 0.2
      } : {
        paddingHorizontal: 0,
        height: val,
        borderRadius: tokens.radius[val]
      }
    }
  }
}), InputIconFrame = (0, import_ui.styled)(import_ui.View, {
  justifyContent: "center",
  alignItems: "center",
  context: InputContext,
  variants: {
    size: {
      "...size": (val, { tokens }) => ({
        paddingHorizontal: tokens.space[val]
      })
    }
  }
}), getIconSize = (size, scale) => (typeof size == "number" ? size * 0.5 : (0, import_ui.getFontSize)(size)) * scale, InputIcon = InputIconFrame.styleable((props, ref) => {
  const { children, color: colorProp, ...rest } = props, inputContext = InputContext.useStyledContext(), { size = "$true", color: contextColor, scaleIcon = 1 } = inputContext, theme = (0, import_ui.useTheme)(), color = (0, import_ui.getVariable)(
    contextColor || theme[contextColor]?.get("web") || theme.color10?.get("web")
  ), iconSize = getIconSize(size, scaleIcon), getThemedIcon = (0, import_ui.useGetThemedIcon)({ size: iconSize, color });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(InputIconFrame, { ref, ...rest, children: getThemedIcon(children) });
}), InputContainerFrame = (0, import_ui.styled)(import_ui.View, {
  context: InputContext,
  flexDirection: "column",
  variants: {
    size: {
      "...size": (val, { tokens }) => ({
        gap: tokens.space[val].val * 0.3
      })
    },
    color: {
      "...color": () => ({})
    },
    gapScale: {
      ":number": {}
    }
  },
  defaultVariants: {
    size: "$4"
  }
}), InputLabel = (0, import_ui.styled)(import_ui.Label, {
  context: InputContext,
  variants: {
    size: {
      "...fontSize": import_get_font_sized.getFontSized
    }
  }
}), InputInfo = (0, import_ui.styled)(import_ui.Text, {
  context: InputContext,
  color: "$color10",
  variants: {
    size: {
      "...fontSize": (val, { font }) => {
        if (!font) return;
        const fontSize = font.size[val].val * 0.8, lineHeight = font.lineHeight?.[val].val * 0.8, fontWeight = font.weight?.$2, letterSpacing = font.letterSpacing?.[val], textTransform = font.transform?.[val], fontStyle = font.style?.[val];
        return {
          fontSize,
          lineHeight,
          fontWeight,
          letterSpacing,
          textTransform,
          fontStyle
        };
      }
    }
  }
}), InputXGroup = (0, import_ui.styled)(import_ui.XGroup, {
  context: InputContext,
  variants: {
    size: {
      "...size": (val, { tokens }) => ({
        borderRadius: tokens.radius[val] ?? tokens.radius.$true
      })
    }
  }
}), Input = (0, import_ui.withStaticProperties)(InputContainerFrame, {
  Box: InputGroupImpl,
  Area: InputImpl,
  Section: InputSection,
  Button,
  Icon: InputIcon,
  Info: InputInfo,
  Label: InputLabel,
  XGroup: (0, import_ui.withStaticProperties)(InputXGroup, { Item: import_ui.XGroup.Item })
}), InputNew = () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input, { w: 400, size: "$3", children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(Input.Box, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Section, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.User, {}) }) }),
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Section, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Area, { paddingLeft: 0 }) }),
  /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Section, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Button, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Input.Icon, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.User, {}) }) }) })
] }) });
//# sourceMappingURL=inputsParts.js.map
