var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var rangePicker_exports = {};
__export(rangePicker_exports, {
  Calendar: () => Calendar,
  DatePickerBody: () => DatePickerBody,
  RangePicker: () => RangePicker
});
module.exports = __toCommonJS(rangePicker_exports);
var import_datepicker = require("@rehookify/datepicker"), import_lucide_icons = require("@tamagui/lucide-icons"), import_react = require("react"), import_ui = require("@my/ui"), import_dateParts = require("./dateParts"), import_react_native = require("react-native-web"), import_jsx_runtime = require("react/jsx-runtime");
const RANGE_STYLE = {
  "in-range": {
    ...import_react_native.Platform.OS === "web" ? { borderStyle: "dashed" } : {},
    backgroundColor: "$background",
    borderWidth: 1,
    borderLeftWidth: 0,
    borderRightWidth: 0,
    borderRadius: 0
  },
  "range-start": {
    borderColor: "$gray8",
    borderWidth: 1,
    borderStyle: "solid",
    borderLeftWidth: 1,
    borderRightWidth: 0,
    borderTopRightRadius: 0,
    borderBottomRightRadius: 0
  },
  "range-end": {
    borderColor: "$gray8",
    borderWidth: 1,
    borderStyle: "solid",
    borderLeftWidth: 0,
    borderRightWidth: 1,
    btlr: 0,
    bblr: 0
  },
  "range-start range-end": {
    borderWidth: 1,
    borderStyle: "solid"
  },
  "will-be-in-range": {
    borderColor: "$gray8",
    borderWidth: 1,
    borderStyle: "dashed",
    borderLeftWidth: 0,
    borderRightWidth: 0,
    borderRadius: 0
  },
  "will-be-range-start": {
    borderColor: "$gray8",
    borderWidth: 1,
    borderStyle: "solid",
    borderLeftWidth: 1,
    borderRightWidth: 0,
    borderTopRightRadius: 0,
    borderBottomRightRadius: 0
  },
  "will-be-range-end": {
    borderColor: "$gray8",
    borderWidth: 1,
    borderStyle: "solid",
    borderLeftWidth: 0,
    borderRightWidth: 1,
    btlr: 0,
    bblr: 0
  },
  "": {}
};
function Calendar({
  calenderIndex = 0,
  order
}) {
  const { setHeader } = (0, import_dateParts.useHeaderType)(), {
    data: { calendars, weekDays },
    propGetters: { dayButton, subtractOffset }
  } = (0, import_datepicker.useDatePickerContext)(), { days, year, month } = calendars[calenderIndex], subDays = (0, import_react.useMemo)(
    () => days.reduce((acc, day, i) => (i % 7 === 0 && acc.push([]), acc[acc.length - 1].push(day), acc), []),
    [days]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.View, { flexDirection: "column", gap: "$4", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      import_ui.View,
      {
        flexDirection: "row",
        minWidth: "100%",
        height: 50,
        alignItems: "center",
        justifyContent: "space-between",
        children: [
          order === "first" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { circular: !0, ...(0, import_dateParts.swapOnClick)(subtractOffset({ months: 1 })), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronLeft, { fillOpacity: 0 }) }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, {}),
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.View, { flexDirection: "column", height: 50, alignItems: "center", children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_dateParts.SizableText,
              {
                onPress: () => setHeader("year"),
                selectable: !0,
                tabIndex: 0,
                size: "$4",
                cursor: "pointer",
                color: "$color11",
                hoverStyle: {
                  color: "$color12"
                },
                children: year
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              import_dateParts.SizableText,
              {
                onPress: () => setHeader("month"),
                selectable: !0,
                tabIndex: 0,
                size: "$6",
                cursor: "pointer",
                color: "$color11",
                hoverStyle: {
                  color: "$color12"
                },
                children: month
              }
            )
          ] }),
          import_react_native.Platform.select({
            web: order === "last" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { circular: !0, ...(0, import_dateParts.swapOnClick)(subtractOffset({ months: -1 })), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronRight, { fillOpacity: 0 }) }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, {}),
            native: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button, { circular: !0, size: "$4", ...(0, import_dateParts.swapOnClick)(subtractOffset({ months: -1 })), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Button.Icon, { scaleIcon: 1.5, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_lucide_icons.ChevronRight, {}) }) })
          })
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      import_ui.View,
      {
        animation: "medium",
        enterStyle: {
          opacity: 0
        },
        gap: "$3",
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, { flexDirection: "row", gap: "$1", children: weekDays.map((day) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.SizableText, { theme: "alt1", ta: "center", width: 45, size: "$6", children: day }, day)) }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, { flexDirection: "column", gap: "$1", flexWrap: "wrap", children: subDays.map((days2) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.View, { flexDirection: "row", gap: "$1", children: days2.map((d) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_ui.Button,
            {
              chromeless: !0,
              circular: !0,
              padding: 0,
              width: 45,
              ...(0, import_dateParts.swapOnClick)(dayButton(d)),
              backgroundColor: d.selected && d.inCurrentMonth ? "$background" : "transparent",
              themeInverse: d.selected,
              ...RANGE_STYLE[d.range],
              "data-range": d.range,
              disabled: !d.inCurrentMonth,
              children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                import_ui.Button.Text,
                {
                  color: d.selected ? "$color" : d.inCurrentMonth ? "$gray11" : "$gray6",
                  children: d.day
                }
              )
            },
            d.$date.toString()
          )) }, days2[0].$date.toString())) })
        ]
      }
    )
  ] });
}
function DatePickerBody() {
  const [header, setHeader] = (0, import_react.useState)("day"), {
    data: { calendars, years },
    propGetters: { subtractOffset, previousYearsButton, nextYearsButton }
  } = (0, import_datepicker.useDatePickerContext)();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.HeaderTypeProvider, { type: header, setHeader, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.View, { flexDirection: "row", gap: "$3", children: [
    header === "day" && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Calendar, { order: "first", calenderIndex: 1 }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Separator, { vertical: !0 }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Calendar, { order: "last", calenderIndex: 0 })
    ] }),
    header === "year" && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.View, { alignItems: "center", gap: "$2", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.YearRangeSlider, {}),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.YearPicker, { onChange: () => setHeader("day") })
    ] }),
    header === "month" && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ui.View, { gap: "$4", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.H3, { size: "$7", alignSelf: "center", children: "Select a month" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_dateParts.MonthPicker,
        {
          onChange: () => {
            setHeader("day");
          }
        }
      )
    ] })
  ] }) });
}
function RangePicker() {
  const now = /* @__PURE__ */ new Date(), [selectedDates, onDatesChange] = (0, import_react.useState)([]), [offsetDate, onOffsetChange] = (0, import_react.useState)(now), [open, setOpen] = (0, import_react.useState)(!1);
  return (0, import_react.useEffect)(() => {
    selectedDates.length === 2 && setOpen(!1);
  }, [selectedDates]), /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_dateParts.DatePicker,
    {
      open,
      onOpenChange: setOpen,
      config: {
        selectedDates,
        onDatesChange,
        offsetDate,
        onOffsetChange,
        dates: {
          mode: "range"
          // limit years to 2 years before and after current year
          //   minDate: new Date(Y, M - 2, 1),
          //   maxDate: new Date(Y, M + 2, 0),
        },
        calendar: {
          offsets: [-1, 1]
        }
      },
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.DatePicker.Trigger, { asChild: !0, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_dateParts.DatePickerInput,
          {
            value: `${selectedDates[0]?.toDateString() || ""}${selectedDates[0] && selectedDates[1] ? " - " : ""}${selectedDates[1]?.toDateString() || ""}`,
            placeholder: "Start date - End date",
            onReset: () => {
              onDatesChange([]);
            },
            onButtonPress: () => setOpen(!0),
            width: 260
          }
        ) }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_dateParts.DatePicker.Content, { children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dateParts.DatePicker.Content.Arrow, {}),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(DatePickerBody, {})
        ] })
      ]
    }
  );
}
//# sourceMappingURL=rangePicker.js.map
