var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
}, __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var SSR_exports = {};
__export(SSR_exports, {
  DataSSR: () => DataSSR,
  PaginatedData: () => PaginatedData,
  PaginatedDataSSR: () => PaginatedDataSSR,
  SSR: () => SSR
});
module.exports = __toCommonJS(SSR_exports);
var import_AppConfig = require("@my/config/dist/AppConfig");
__reExport(SSR_exports, require("../components/AdminPage"), module.exports);
var import_protobase = require("protobase"), import_Session = require("./Session");
const SSR = (fn) => import_AppConfig.SiteConfig.SSR ? fn : void 0;
function DataSSR(sourceUrl, permissions, props = {}) {
  return SSR(async (context) => (0, import_Session.withSession)(context, permissions, {
    pageState: {
      sourceUrl,
      initialItems: await import_protobase.API.get({ url: sourceUrl, ...props }),
      ...props
    }
  }));
}
function PaginatedData(sourceUrl, permissions, extraData) {
  return PaginatedDataSSR(sourceUrl, permissions, {}, async (context) => {
    if (!extraData) return {};
    const result = {};
    for (const key of Object.keys(extraData))
      result[key] = await import_protobase.API.get((0, import_Session.getURLWithToken)(extraData[key], context));
    return result;
  });
}
function PaginatedDataSSR(sourceUrl, permissions, dataProps = {}, extraData = {}) {
  return SSR(async (context) => {
    const filters = Object.keys(context.query ?? {}).filter((q) => q.startsWith("filter")).reduce((total, current) => ({
      ...total,
      [current]: context.query[current]
    }), {}) ?? {}, _dataProps = {
      ...context.query,
      ...filters,
      itemsPerPage: parseInt(context.query.itemsPerPage) ? parseInt(context.query.itemsPerPage) : "",
      page: parseInt(context.query.page, 10) ? parseInt(context.query.page, 10) : "",
      search: context.query.search ?? "",
      orderBy: context.query.orderBy ?? "",
      orderDirection: context.query.orderDirection ?? "",
      view: context.query.view ?? "",
      item: context.query.item ?? "",
      editFile: context.query.editFile ?? "",
      ...typeof dataProps == "function" ? await dataProps(context) : dataProps
    }, _sourceUrl = typeof sourceUrl == "function" ? sourceUrl(context) : sourceUrl;
    return (0, import_Session.withSession)(context, permissions, {
      sourceUrl: _sourceUrl,
      initialItems: await import_protobase.API.get({ url: (0, import_Session.getURLWithToken)(_sourceUrl, context), ..._dataProps }),
      itemData: context.query.item ? await import_protobase.API.get((0, import_Session.getURLWithToken)(_sourceUrl + "/" + context.query.item, context)) : "",
      extraData: { ...typeof extraData == "function" ? await extraData(context) : extraData },
      pageState: {
        ..._dataProps
      }
    });
  });
}
//# sourceMappingURL=SSR.js.map
