var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Session_exports = {};
__export(Session_exports, {
  clearSession: () => clearSession,
  getSessionCookie: () => getSessionCookie,
  getURLWithToken: () => getURLWithToken,
  hasSessionCookie: () => hasSessionCookie,
  withSession: () => withSession
});
module.exports = __toCommonJS(Session_exports);
var cookie = __toESM(require("cookie")), import_session = require("protonode/dist/lib/session"), import_cookie = require("cookie"), import_protobase = require("protobase");
const logger = (0, import_protobase.getLogger)(), hasSessionCookie = (cookieStr) => {
  const parsedCookies = cookie.parse(cookieStr ?? "");
  return parsedCookies.session && JSON.parse(parsedCookies.session).loggedIn;
}, getSessionCookie = async (cookieStr) => {
  const parsedCookies = cookie.parse(cookieStr ?? "");
  if (parsedCookies.session)
    try {
      const data = JSON.parse(parsedCookies.session), { iat, exp, ...validatedData } = await (0, import_session.validateSession)(data);
      return {
        ...data,
        user: {
          ...data.user,
          ...validatedData
        }
      };
    } catch (error) {
      if (logger.error({ error }, "ERROR validating session"), error == "Server Error")
        throw "Server Error";
    }
}, fail = (returnUrl) => {
  returnUrl.includes("_next/data/development/") && (returnUrl = returnUrl.split("_next/data/development")[1].split(".json")[0]), returnUrl == "/" && (returnUrl = void 0);
  const encodedReturn = encodeURIComponent(returnUrl);
  return {
    redirect: {
      permanent: !1,
      destination: "/auth/login" + (returnUrl ? "?return=" + encodedReturn : "")
    }
  };
}, withSession = async (context, permissions, props) => {
  let session, sessionError;
  const hasSomePermission = (validPermissions, userPermissions) => (logger.trace({ validPermissions, userPermissions }, "Checking permissions to access page"), validPermissions.some((perm) => userPermissions.includes(perm)));
  try {
    session = await getSessionCookie(context.req.headers.cookie);
  } catch {
    sessionError = !0;
  }
  if (permissions && !sessionError) {
    if (!session) return fail(context.req.url);
    if (permissions.length && !session?.user?.admin && !hasSomePermission(permissions, session?.user?.permissions ?? [])) return fail();
  }
  return {
    props: {
      pageSession: { session: sessionError ? null : session ?? (0, import_protobase.createSession)(), context: await (0, import_session.getSessionContext)(session?.user?.type) },
      ...typeof props == "function" ? await props(session) : props
    }
  };
}, initialContext = { state: "pending", group: { workspaces: [] } }, clearSession = (setSession, setSessionContext) => {
  setSession((0, import_protobase.createSession)()), setSessionContext(initialContext);
}, getURLWithToken = (url, context) => {
  const { req } = context, cookies = req.headers.cookie;
  let session;
  if (cookies)
    try {
      const parsedCookies = (0, import_cookie.parse)(cookies);
      session = JSON.parse(parsedCookies.session);
    } catch {
      session = null;
    }
  const finalUrl = url + (session && session.token ? (url.includes("?") ? "&" : "?") + "token=" + session.token : "");
  return logger.debug({ url: finalUrl }, "Return url with session token"), finalUrl;
};
//# sourceMappingURL=Session.js.map
