var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Tints_exports = {};
__export(Tints_exports, {
  ThemeTint: () => ThemeTint,
  ThemeTintAlt: () => ThemeTintAlt,
  getTints: () => getTints,
  initialTint: () => initialTint,
  onTintChange: () => onTintChange,
  onTintFamilyChange: () => onTintFamilyChange,
  setNextTintFamily: () => setNextTintFamily,
  setTintFamily: () => setTintFamily,
  setTintIndex: () => setTintIndex,
  useTint: () => useTint,
  useTints: () => useTints
});
module.exports = __toCommonJS(Tints_exports);
var import_react = require("react"), import_ui = require("@my/ui"), import_AppConfig = require("@my/config/dist/AppConfig"), import_jsx_runtime = require("react/jsx-runtime");
const familiesValues = {
  tamagui: ["gray", "orange", "yellow", "green", "blue", "purple", "pink", "red"]
}, familiesNames = Object.keys(familiesValues), families = familiesValues;
let fam = "tamagui";
const defaultTint = import_AppConfig.SiteConfig?.ui.defaultTint, defaultTintIndex = familiesValues[fam].indexOf(defaultTint);
function getTints() {
  return {
    name: fam || "tamagui",
    tints: families[fam] || families.tamagui,
    families
  };
}
function useTints() {
  const [val, setVal] = (0, import_react.useState)(getTints());
  return (0, import_react.useEffect)(() => onTintFamilyChange(() => {
    setVal(getTints());
  }), []), val;
}
const setTintFamily = (next) => {
  if (!families[next]) throw "impossible";
  fam = next, listeners.forEach((l) => l(next));
}, setNextTintFamily = () => {
  setTintFamily(familiesNames[(familiesNames.indexOf(fam) + 1) % familiesNames.length]);
}, listeners = /* @__PURE__ */ new Set(), onTintFamilyChange = (cb) => (listeners.add(cb), () => {
  listeners.delete(cb);
}), initialTint = defaultTintIndex == -1 ? 3 : defaultTintIndex;
let current = initialTint;
const listeners_ = /* @__PURE__ */ new Set(), onTintChange = (listener) => (listeners_.add(listener), () => {
  listeners_.delete(listener);
}), numTints = getTints().tints.length, setTintIndex = (next) => {
  const val = next % numTints;
  val !== current && (current = val, (0, import_react.startTransition)(() => {
    listeners_.forEach((x) => x(val));
  }));
}, useTint = () => {
  const index = (0, import_react.useSyncExternalStore)(
    onTintChange,
    () => current,
    () => initialTint
  ), tintsContext = useTints(), { tints } = tintsContext;
  return {
    ...tintsContext,
    tints: tintsContext.tints,
    tintIndex: index,
    tint: tints[index],
    setTintIndex,
    setNextTintFamily,
    setNextTint: () => {
      setTintIndex(index + 1);
    }
  };
}, ThemeTint = (props) => {
  const curTint = useTint().tint;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Theme, { name: props.disable ? null : curTint, children: (0, import_react.useMemo)(() => props.children, [props.children]) });
}, ThemeTintAlt = ({
  children,
  disable,
  offset = 2
}) => {
  const tint = useTint(), curTint = tint.tints[(tint.tintIndex + offset) % tint.tints.length];
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ui.Theme, { name: disable ? null : curTint, children: (0, import_react.useMemo)(() => children, [children]) });
};
//# sourceMappingURL=Tints.js.map
