var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Connector_exports = {};
__export(Connector_exports, {
  default: () => Connector
});
module.exports = __toCommonJS(Connector_exports);
var import_react = require("react"), import_mqtt = __toESM(require("mqtt")), import_Context = __toESM(require("./Context")), import_jsx_runtime = require("react/jsx-runtime");
function Connector({
  children,
  brokerUrl,
  options = { keepalive: 0 },
  parserMethod
}) {
  const clientValid = (0, import_react.useRef)(!1), [connectionStatus, setStatus] = (0, import_react.useState)("Offline"), [client, setClient] = (0, import_react.useState)(null);
  (0, import_react.useEffect)(() => {
    if (!client && !clientValid.current && brokerUrl) {
      clientValid.current = !0, setStatus("Connecting"), console.log(`attempting to connect to ${brokerUrl}`);
      const mqtt = import_mqtt.default.connect(brokerUrl, options);
      mqtt.on("connect", () => {
        console.debug("on connect"), setStatus("Connected"), setClient(mqtt);
      }), mqtt.on("reconnect", () => {
        console.debug("on reconnect"), setStatus("Reconnecting");
      }), mqtt.on("error", (err) => {
        console.log(`Connection error: ${err}`), setStatus(err.message);
      }), mqtt.on("offline", () => {
        console.debug("on offline"), setStatus("Offline");
      }), mqtt.on("end", () => {
        console.debug("on end"), setStatus("Offline");
      });
    }
  }, [client, clientValid, brokerUrl, options]), (0, import_react.useEffect)(
    () => () => {
      client && (console.log("closing mqtt client"), client.end(!0), setClient(null), clientValid.current = !1);
    },
    [client, clientValid]
  );
  const value = (0, import_react.useMemo)(
    () => ({
      connectionStatus,
      client,
      parserMethod
    }),
    [connectionStatus, client, parserMethod]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Context.default.Provider, { value, children });
}
//# sourceMappingURL=Connector.js.map
