var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: !0 }) : target,
  mod
)), __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var useRemoteState_exports = {};
__export(useRemoteState_exports, {
  useRemoteStateList: () => useRemoteStateList
});
module.exports = __toCommonJS(useRemoteState_exports);
var import_react = require("react"), import_usePendingEffect = require("./usePendingEffect"), import_useSubscription = __toESM(require("./mqtt/useSubscription"));
const useRemoteStateList = (items, fetch, topic, model, quickRefresh = !1) => {
  const [dataState, setDataState] = (0, import_react.useState)(items), lastId = (0, import_react.useRef)(0);
  (0, import_usePendingEffect.usePendingEffect)((s) => fetch(s), setDataState, dataState);
  const { messages } = (0, import_useSubscription.default)(topic);
  return (0, import_react.useEffect)(() => {
    const unseenMessages = messages.filter((m) => m.id > lastId.current);
    unseenMessages.length > 0 && (quickRefresh ? unseenMessages.forEach((message) => {
      const mqttDataString = typeof message.message == "string" ? message.message : JSON.stringify(message.message), mqttData = JSON.parse(mqttDataString), [, , action] = message.topic.split("/");
      setDataState((prev) => {
        const currentData = prev?.data || {}, items2 = currentData.items || [];
        switch (action) {
          case "create":
            return {
              ...prev,
              data: { ...currentData, items: [mqttData, ...items2] }
            };
          case "delete":
            const newItemsDelete = items2.filter((item) => model.load(item).getId() !== model.load(mqttData).getId());
            return {
              ...prev,
              data: { ...currentData, items: newItemsDelete }
            };
          case "update":
            const newItemsUpdate = items2.map((item) => model.load(item).getId() === model.load(mqttData).getId() ? mqttData : item);
            return {
              ...prev,
              data: { ...currentData, items: newItemsUpdate }
            };
          default:
            return prev;
        }
      }), lastId.current = message.id;
    }) : (lastId.current = unseenMessages[unseenMessages.length - 1].id, fetch(setDataState)));
  }, [messages]), [dataState, setDataState];
};
//# sourceMappingURL=useRemoteState.js.map
