var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var useSetting_exports = {};
__export(useSetting_exports, {
  useSetting: () => useSetting,
  useSettingValue: () => useSettingValue
});
module.exports = __toCommonJS(useSetting_exports);
var import_react = require("react"), import_protobase = require("protobase");
const useSetting = (key, defaultValue = null) => {
  const [value, setValue] = (0, import_react.useState)(defaultValue), [loading, setLoading] = (0, import_react.useState)(!0), [error, setError] = (0, import_react.useState)(null);
  return (0, import_react.useEffect)(() => {
    (async () => {
      try {
        setLoading(!0);
        const url = `/api/core/v1/settings/${key}`, response = await import_protobase.API.get(url);
        if (response.isError)
          throw new Error(response.error?.error || response.error);
        setValue(response.data?.value);
      } catch (err) {
        setError(err.message);
      } finally {
        setLoading(!1);
      }
    })();
  }, [key, defaultValue]), { value, loading, error };
}, useSettingValue = (key, defaultValue = null) => {
  const { value } = useSetting(key, defaultValue);
  return value;
};
//# sourceMappingURL=useSetting.js.map
