var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: !0 });
}, __copyProps = (to, from, except, desc) => {
  if (from && typeof from == "object" || typeof from == "function")
    for (let key of __getOwnPropNames(from))
      !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod);
var Params_exports = {};
__export(Params_exports, {
  usePageParams: () => usePageParams,
  useQueryState: () => useQueryState
});
module.exports = __toCommonJS(Params_exports);
var import_navigation = require("solito/navigation"), import_usehooks_ts = require("usehooks-ts");
const omitProp = (obj, prop) => {
  const { [prop]: _, ...rest } = obj;
  return rest;
}, useQueryState = (setState) => {
  const searchParams = (0, import_navigation.useSearchParams)();
  if (!searchParams) {
    console.warn("useSearchParams is not available. Ensure you are using this hook within a Solito navigation context.");
    return;
  }
  const query = Object.fromEntries(searchParams.entries());
  (0, import_usehooks_ts.useUpdateEffect)(() => {
    setState(query);
  }, [searchParams]);
}, navigate = (router, pathname, query, method) => {
  const newSearchParams = new URLSearchParams(query).toString(), newUrl = pathname + "?" + newSearchParams;
  method === "push" ? router.push(newUrl) : method === "replace" && router.replace(newUrl);
}, usePageParams = (state) => {
  try {
    const router = (0, import_navigation.useRouter)(), searchParams = (0, import_navigation.useSearchParams)(), pathname = (0, import_navigation.usePathname)(), query = Object.fromEntries(searchParams.entries()), cleanState = () => Object.keys(state ?? {}).reduce((total, current) => state[current] !== "" ? {
      ...total,
      [current]: state[current]
    } : total, {});
    return {
      query,
      push: (key, value) => {
        const newQuery = {
          ...query,
          ...cleanState(),
          [key]: value
        };
        navigate(router, pathname, newQuery, "push");
      },
      mergePush: (obj) => {
        const newQuery = {
          ...query,
          ...cleanState(),
          ...obj
        };
        navigate(router, pathname, newQuery, "push");
      },
      removePush: (keys) => {
        const keysArr = Array.isArray(keys) ? keys : [keys];
        let newQuery = { ...query };
        keysArr.forEach((key) => {
          newQuery = omitProp(newQuery, key);
        }), navigate(router, pathname, newQuery, "push");
      },
      removeReplace: (key) => {
        const newQuery = omitProp(query, key);
        navigate(router, pathname, newQuery, "replace");
      },
      replace: (key, value) => {
        const newQuery = {
          ...query,
          ...cleanState(),
          [key]: value
        };
        navigate(router, pathname, newQuery, "replace");
      },
      mergeReplace: (obj) => {
        const newQuery = {
          ...cleanState(),
          ...state,
          ...obj
        };
        navigate(router, pathname, newQuery, "replace");
      }
    };
  } catch {
    return {
      query: {},
      push: () => {
      },
      mergePush: () => {
      },
      removePush: () => {
      },
      removeReplace: () => {
      },
      replace: () => {
      },
      mergeReplace: () => {
      }
    };
  }
};
//# sourceMappingURL=Params.js.map
