import { ProtoDB, ProtoDBConfig } from '../protodb';
export declare class ProtoLevelDB extends ProtoDB {
    private rootDb;
    private db;
    private batchCounter;
    private batchTimer;
    private batchLimit;
    private batchTimeout;
    private orderedInsert;
    private batch;
    private regeneratingIndexes;
    private tableVersion;
    private pendingIndex;
    constructor(location: any, options?: any, config?: ProtoDBConfig);
    get status(): any;
    on(event: string, cb: Function): any;
    get(key: string, options?: any): any;
    del(key: string, options?: any): Promise<any>;
    count(filter?: any): Promise<any>;
    getIndexedKeys(): Promise<any>;
    hasGroupIndexes(groupIndexes: any): Promise<any>;
    getPageItems(total: any, key: any, pageNumber: any, itemsPerPage: any, direction: any, filter?: any): Promise<any>;
    put(key: string, value: string, options?: any): Promise<any>;
    private batchIndexes;
    regenerateIndexes(): Promise<void>;
    getGroupIndexes(): Promise<any>;
    getGroupIndexOptions(groupKey: any, limit?: number): Promise<any[]>;
    static removeFromIndexes(rootDb: any, db: any, location: any, tableVersion: any, value: any): Promise<void>;
    static appendToIndexes(rootDb: any, db: any, location: any, tableVersion: any, value: any): Promise<void>;
    static regenerateIndexes(rootDb: any, db: any, location: any, tableVersion: any): Promise<void>;
    iterator(options?: any): any;
    close(): any;
    exists(key: string): Promise<boolean>;
    static initDB(dbPath: string, initialData?: {}, options?: any): Promise<void>;
    static connect(location: any, options?: any, config?: any): ProtoLevelDB;
    static getInstance(location: any, options?: any, config?: ProtoDBConfig): ProtoLevelDB;
    static locks: {
        [key: string]: Promise<void>;
    };
    static incrementKey(db: any, key: any): Promise<number>;
    static decrementKey(db: any, key: any): Promise<number>;
}
