import { ProtoDB, ProtoDBConfig } from '../protodb';
export interface SQLiteOptions {
    indexes?: {
        primary: string;
        keys: string[];
    };
    groupIndexes?: Array<{
        key: string;
        fn?: string;
    }>;
    dbOptions?: any;
}
export declare class ProtoSqliteDB extends ProtoDB {
    private db;
    capabilities: string[];
    constructor(dbPath: string, options?: any, config?: ProtoDBConfig);
    /** Crea las tablas si no existen */
    private prepareSchema;
    static connect(dbPath: string, options?: any, config?: ProtoDBConfig): ProtoSqliteDB;
    static getInstance(dbPath: string, options?: any, config?: ProtoDBConfig): ProtoSqliteDB;
    /** Inicializa en disco y precarga initialData */
    static initDB(dbPath: string, initialData?: {}, options?: SQLiteOptions): Promise<void>;
    get(key: string): any;
    exists(key: string): Promise<boolean>;
    put(key: string, value: string, options?: any): Promise<boolean>;
    del(key: string): Promise<boolean>;
    count(filter?: {
        key: string;
        value: any;
    }): Promise<any>;
    getIndexedKeys(): Promise<any>;
    getGroupIndexes(): Promise<any>;
    hasGroupIndexes(keys: string[]): Promise<boolean>;
    getGroupIndexOptions(groupKey: string, limit?: number): Promise<any>;
    getPageItems(total: number, key: string, pageNumber: number, itemsPerPage: number, direction: 'asc' | 'desc', filter?: {
        key: string;
        value: any;
    }): Promise<any>;
    iterator(): Generator<any[], void, unknown>;
    close(): Promise<void>;
}
