type AutoAPIOptions = {
    modelName: string;
    modelType: any;
    initialData?: Object;
    prefix?: string;
    dbName?: string | Function;
    notify?: Function;
    transformers?: any;
    connectDB?: any;
    getDB?: any;
    operations?: string[];
    single?: boolean;
    disableEvents?: boolean;
    paginatedRead?: {
        model: any;
    };
    requiresAdmin?: string[];
    extraData?: any;
    logLevel?: string;
    itemsPerPage?: number;
    defaultOrderBy?: string;
    defaultOrderDirection?: string;
    skipStorage?: Function;
    onBeforeList?: Function;
    onAfterList?: Function;
    onBeforeCreate?: Function;
    onAfterCreate?: Function;
    onBeforeRead?: Function;
    onAfterRead?: Function;
    onBeforeUpdate?: Function;
    onAfterUpdate?: Function;
    onBeforeDelete?: Function;
    onAfterDelete?: Function;
    skipDatabaseIndexes?: boolean;
    skipDatabaseInitialization?: boolean;
    dbOptions?: {
        batch?: boolean;
        batchLimit?: number;
        batchTimeout?: number;
        orderedInsert?: boolean;
        maxEntries?: number;
    };
};
export declare const AutoAPI: ({ modelName, modelType, initialData, prefix, dbName, transformers, connectDB, getDB, notify, operations, single, disableEvents, paginatedRead, requiresAdmin, extraData, logLevel, itemsPerPage, skipStorage, onBeforeList, onAfterList, onBeforeCreate, onAfterCreate, onBeforeRead, onAfterRead, onBeforeUpdate, onAfterUpdate, onBeforeDelete, onAfterDelete, skipDatabaseIndexes, dbOptions, defaultOrderBy, defaultOrderDirection, skipDatabaseInitialization }: AutoAPIOptions) => (app: any, context: any) => Promise<void>;
export {};
