"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMQTTClient = void 0;
const mqtt = __importStar(require("mqtt"));
const protobase_1 = require("protobase");
const logger = (0, protobase_1.getLogger)();
var mqttClient;
const getMQTTClient = (username, password, onConnect) => {
    var _a;
    if (!mqttClient) {
        const mqttServer = (_a = process.env.MQTT_URL) !== null && _a !== void 0 ? _a : 'mqtt://localhost:1883';
        mqttClient = mqtt.connect(mqttServer, {
            username: username,
            clientId: username + '_' + Math.random().toString(16).substr(2, 8),
            password: password
        });
        mqttClient.hasConnected = false;
        mqttClient.retries = 0;
        logger.debug({
            mqttServer: mqttServer,
            username: username
        }, "Connecting to MQTT");
        mqttClient.on('connect', function () {
            if (!mqttClient.hasConnected && onConnect) {
                onConnect(mqttClient);
            }
            mqttClient.hasConnected = true;
            mqttClient.retries = 0;
            logger.debug('Connected to MQTT');
        });
        mqttClient.on('reconnect', function () {
            if (mqttClient.hasConnected || mqttClient.retries > 10) {
                logger.debug('Trying to connect MQTT...');
            }
        });
        mqttClient.on('offline', function () {
            if (mqttClient.hasConnected) {
                logger.debug('MQTT disconnected');
            }
        });
        mqttClient.on('error', function (error) {
            if (mqttClient.hasConnected) {
                logger.error({ error }, "MQTT Error");
            }
        });
        mqttClient = mqttClient;
    }
    return mqttClient;
};
exports.getMQTTClient = getMQTTClient;
