export type ProtoDBConfig = {
    context?: any;
    name?: string;
};
export declare abstract class ProtoDB {
    capabilities: string[];
    location: string;
    options: any;
    config: ProtoDBConfig;
    constructor(location: any, options?: any, config?: any);
    get status(): string;
    on(event: string, cb: Function): void;
    hasCapability(capability: string): boolean;
    abstract get(key: string, options?: any): any;
    abstract put(key: string, value: string, options?: any): any;
    abstract del(key: string, options?: any): any;
    abstract iterator(options?: any): any;
    close(): Promise<void>;
    exists(key: string): Promise<boolean>;
    static getInstance(location: any, options?: any, config?: ProtoDBConfig): void;
    static connect(location: any, options?: any, config?: ProtoDBConfig): any;
    static closeDBS(): Promise<void>;
    static initDB(dbPath: string, initialData?: {}, options?: any): Promise<void>;
}
