"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.response = void 0;
const protobase_1 = require("protobase");
const logger = (0, protobase_1.getLogger)();
const response = async (pendingOperation, res, defaultValue = [], error = "Error reading database") => {
    pendingOperation.then((data) => {
        res.send(data);
    }).catch((error) => {
        if (error.notFound) {
            res.send([]);
        }
        else {
            res.status(500).send("Error reading database");
            logger.error({ error }, "Error reading database");
        }
    });
};
exports.response = response;
