import { createTamagui } from "tamagui";
import { createInterFont } from "@tamagui/font-inter";
import { shorthands } from "@tamagui/shorthands";
import { createMedia } from "@tamagui/react-native-media-driver";
import { createCherryBombFont } from "@tamagui/font-cherry-bomb";
import { createDmSansFont } from "@tamagui/font-dm-sans";
import { createDmSerifDisplayFont } from "@tamagui/font-dm-serif-display";
import { createMunroFont } from "@tamagui/font-munro";
import { createSilkscreenFont } from "@tamagui/font-silkscreen";
import { createGenericFont } from "./createGenericFont";
import { animations } from "./animations";
import { themes } from "./themes";
import { tokens } from "./tokens";
import uiConfig from "./uiConfig";
import { createAnimations } from "@tamagui/animations-css";
function _define_property(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {}, ownKeys2 = Object.keys(source);
    typeof Object.getOwnPropertySymbols == "function" && (ownKeys2 = ownKeys2.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
      return Object.getOwnPropertyDescriptor(source, sym).enumerable;
    }))), ownKeys2.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _object_spread_props(target, source) {
  return source = source ?? {}, Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
  }), target;
}
function _type_of(obj) {
  "@swc/helpers - typeof";
  return obj && typeof Symbol < "u" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
var cherryBombFont = createCherryBombFont(), munroFont = createMunroFont(), silkscreenFont = createSilkscreenFont(), headingFont = createInterFont({
  size: {
    5: 13,
    6: 15,
    9: 32,
    10: 44
  },
  transform: {
    6: "uppercase",
    7: "none"
  },
  weight: {
    6: "400",
    7: "700"
  },
  color: {
    6: "$colorFocus",
    7: "$color"
  },
  letterSpacing: {
    5: 2,
    6: 1,
    7: 0,
    8: 0,
    9: -0.1,
    10: -0.25,
    11: -0.5,
    12: -0.75,
    14: -1,
    15: -2
  },
  // for native
  face: {
    700: {
      normal: "InterBold"
    },
    800: {
      normal: "InterBold"
    },
    900: {
      normal: "InterBold"
    }
  }
}, {
  sizeLineHeight: function(size) {
    return Math.round(size * 1.1 + (size < 30 ? 10 : 5));
  }
}), dmSansHeadingFont = createDmSansFont({
  size: {
    5: 13,
    6: 15,
    9: 32,
    10: 44
  },
  transform: {
    6: "uppercase",
    7: "none"
  },
  weight: {
    6: "400",
    7: "700"
  },
  color: {
    6: "$colorFocus",
    7: "$color"
  },
  letterSpacing: {
    5: 2,
    6: 1,
    7: 0,
    8: 0,
    9: -0.1,
    10: -0.25,
    11: -0.5,
    12: -0.75,
    14: -1,
    15: -2
  },
  face: {}
}, {
  sizeLineHeight: function(size) {
    return Math.round(size * 1.1 + (size < 30 ? 10 : 5));
  }
}), dmSerifDisplayHeadingFont = createDmSerifDisplayFont({
  size: {
    5: 13,
    6: 15,
    9: 32,
    10: 44
  },
  transform: {
    6: "uppercase",
    7: "none"
  },
  weight: {
    6: "400",
    7: "700"
  },
  color: {
    6: "$colorFocus",
    7: "$color"
  },
  letterSpacing: {
    5: 2,
    6: 1,
    7: 0,
    8: 0,
    9: -0.1,
    10: -0.25,
    11: -0.5,
    12: -0.75,
    14: -1,
    15: -2
  },
  face: {}
}, {
  sizeLineHeight: function(size) {
    return Math.round(size * 1.1 + (size < 30 ? 10 : 5));
  }
}), bodyFont = createInterFont({
  weight: {
    1: "400"
  }
}, {
  sizeSize: function(size) {
    return Math.round(size);
  },
  sizeLineHeight: function(size) {
    return Math.round(size * 1.1 + (size >= 12 ? 8 : 4));
  }
}), monoFont = createGenericFont('"ui-monospace", "SFMono-Regular", "SF Mono", Menlo, Consolas, "Liberation Mono", monospace', {
  weight: {
    1: "500"
  },
  size: {
    1: 11,
    2: 12,
    3: 13,
    4: 13,
    5: 14,
    6: 16,
    7: 18,
    8: 20,
    9: 24,
    10: 32,
    11: 46,
    12: 62,
    13: 72,
    14: 92,
    15: 114,
    16: 124
  }
}, {
  sizeLineHeight: function(x) {
    return x * 1.5;
  }
}), defaultDataConfig = {
  defaultFont: "body",
  animations,
  shouldAddPrefersColorThemes: !0,
  themeClassNameOnRoot: !0,
  shorthands,
  fonts: {
    heading: headingFont,
    headingDmSans: dmSansHeadingFont,
    headingDmSerifDisplay: dmSerifDisplayHeadingFont,
    body: bodyFont,
    mono: monoFont,
    silkscreen: silkscreenFont,
    munro: munroFont,
    cherryBomb: cherryBombFont
  },
  themes,
  tokens,
  media: createMedia({
    xs: {
      maxWidth: 660
    },
    sm: {
      maxWidth: 800
    },
    md: {
      maxWidth: 1020
    },
    lg: {
      maxWidth: 1280
    },
    xl: {
      maxWidth: 1420
    },
    xxl: {
      maxWidth: 1600
    },
    gtXs: {
      minWidth: 661
    },
    gtSm: {
      minWidth: 801
    },
    gtMd: {
      minWidth: 1021
    },
    gtLg: {
      minWidth: 1281
    },
    short: {
      maxHeight: 820
    },
    tall: {
      minHeight: 820
    },
    hoverNone: {
      hover: "none"
    },
    pointerCoarse: {
      pointer: "coarse"
    }
  })
};
function spreadRecursive(config2, extraConfig) {
  var tmpConfig = _object_spread({}, config2);
  for (var key in extraConfig)
    extraConfig.hasOwnProperty(key) && (_type_of(extraConfig[key]) === "object" && config2.hasOwnProperty(key) && _type_of(config2[key]) === "object" ? tmpConfig[key] = spreadRecursive(config2[key], extraConfig[key]) : tmpConfig[key] = extraConfig[key]);
  return tmpConfig;
}
var createConfig = function() {
  var aditionalConfig = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, newConfig = defaultDataConfig;
  return Object.keys.length > 0 && (newConfig = spreadRecursive(defaultDataConfig, aditionalConfig)), createTamagui(newConfig);
}, config = createConfig(uiConfig), staticConfig = function() {
  return createTamagui(_object_spread_props(_object_spread({}, defaultDataConfig), {
    animations: createAnimations({
      bouncy: "ease-in-out",
      lazy: "ease-out",
      quick: "ease-in",
      tooltip: "ease-in"
    })
  }));
};
export {
  cherryBombFont,
  config,
  createConfig,
  munroFont,
  staticConfig
};
//# sourceMappingURL=tamagui.config.js.map
